package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.String;
import com.fasterxml.jackson.annotation.JsonProperty;
import java.lang.Boolean;
import java.lang.Object;

public class NodeSpecFluentImpl<A extends NodeSpecFluent<A>> extends BaseFluent<A> implements NodeSpecFluent<A>{

    private String externalID;
    private String podCIDR;
    private String providerID;
    private Boolean unschedulable;

    public NodeSpecFluentImpl(){
    }
    public NodeSpecFluentImpl(NodeSpec instance){
            this.withExternalID(instance.getExternalID()); 
            this.withPodCIDR(instance.getPodCIDR()); 
            this.withProviderID(instance.getProviderID()); 
            this.withUnschedulable(instance.getUnschedulable()); 
    }

    public String getExternalID(){
            return this.externalID;
    }

    public A withExternalID(String externalID){
            this.externalID=externalID; return (A) this;
    }

    public String getPodCIDR(){
            return this.podCIDR;
    }

    public A withPodCIDR(String podCIDR){
            this.podCIDR=podCIDR; return (A) this;
    }

    public String getProviderID(){
            return this.providerID;
    }

    public A withProviderID(String providerID){
            this.providerID=providerID; return (A) this;
    }

    public Boolean isUnschedulable(){
            return this.unschedulable;
    }

    public A withUnschedulable(Boolean unschedulable){
            this.unschedulable=unschedulable; return (A) this;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            NodeSpecFluentImpl that = (NodeSpecFluentImpl) o;
            if (externalID != null ? !externalID.equals(that.externalID) :that.externalID != null) return false;
            if (podCIDR != null ? !podCIDR.equals(that.podCIDR) :that.podCIDR != null) return false;
            if (providerID != null ? !providerID.equals(that.providerID) :that.providerID != null) return false;
            if (unschedulable != null ? !unschedulable.equals(that.unschedulable) :that.unschedulable != null) return false;
            return true;
    }




}
