package io.fabric8.kubernetes.api.model.extensions;

import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Integer;
import com.fasterxml.jackson.annotation.JsonProperty;
import java.lang.Object;

public class ScaleSpecFluentImpl<A extends ScaleSpecFluent<A>> extends BaseFluent<A> implements ScaleSpecFluent<A>{

    private Integer replicas;

    public ScaleSpecFluentImpl(){
    }
    public ScaleSpecFluentImpl(ScaleSpec instance){
            this.withReplicas(instance.getReplicas()); 
    }

    public Integer getReplicas(){
            return this.replicas;
    }

    public A withReplicas(Integer replicas){
            this.replicas=replicas; return (A) this;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ScaleSpecFluentImpl that = (ScaleSpecFluentImpl) o;
            if (replicas != null ? !replicas.equals(that.replicas) :that.replicas != null) return false;
            return true;
    }




}
