package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.String;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import io.fabric8.kubernetes.api.model.EnvVar;
import java.lang.Object;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.fabric8.kubernetes.api.builder.Nested;
import io.fabric8.kubernetes.api.model.EnvVarFluent;
import io.fabric8.kubernetes.api.model.EnvVarBuilder;

public interface CustomDeploymentStrategyParamsFluent<A extends CustomDeploymentStrategyParamsFluent<A>> extends Fluent<A>{


    public A addToCommand(String... items);
    public A removeFromCommand(String... items);
    public List<String> getCommand();
    public A withCommand(List<String> command);
    public A withCommand(String... command);
    public A addToEnvironment(EnvVar... items);
    public A removeFromEnvironment(EnvVar... items);
    public List<EnvVar> getEnvironment();
    public A withEnvironment(List<EnvVar> environment);
    public A withEnvironment(EnvVar... environment);
    public CustomDeploymentStrategyParamsFluent.EnvironmentNested<A> addNewEnvironment();
    public CustomDeploymentStrategyParamsFluent.EnvironmentNested<A> addNewEnvironmentLike(EnvVar item);
    public String getImage();
    public A withImage(String image);

    public interface EnvironmentNested<N> extends Nested<N>,EnvVarFluent<CustomDeploymentStrategyParamsFluent.EnvironmentNested<N>>{

        
    public N endEnvironment();    public N and();
}


}
