package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import java.lang.String;
import java.lang.Object;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.fabric8.kubernetes.api.builder.Nested;

public interface DeploymentDetailsFluent<A extends DeploymentDetailsFluent<A>> extends Fluent<A>{


    public A addToCauses(DeploymentCause... items);
    public A removeFromCauses(DeploymentCause... items);
    public List<DeploymentCause> getCauses();
    public A withCauses(List<DeploymentCause> causes);
    public A withCauses(DeploymentCause... causes);
    public DeploymentDetailsFluent.CausesNested<A> addNewCause();
    public DeploymentDetailsFluent.CausesNested<A> addNewCauseLike(DeploymentCause item);
    public String getMessage();
    public A withMessage(String message);

    public interface CausesNested<N> extends Nested<N>,DeploymentCauseFluent<DeploymentDetailsFluent.CausesNested<N>>{

        
    public N endCause();    public N and();
}


}
