package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.BaseFluent;
import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import java.lang.String;
import java.util.List;
import java.util.ArrayList;
import java.lang.Object;
import io.fabric8.kubernetes.api.builder.Nested;

public class LifecycleHookFluentImpl<A extends LifecycleHookFluent<A>> extends BaseFluent<A> implements LifecycleHookFluent<A>{

    private VisitableBuilder<? extends ExecNewPodHook,?> execNewPod;
    private String failurePolicy;
    private List<VisitableBuilder<? extends TagImageHook,?>> tagImages =  new ArrayList<VisitableBuilder<? extends TagImageHook,?>>();

    public LifecycleHookFluentImpl(){
    }
    public LifecycleHookFluentImpl(LifecycleHook instance){
            this.withExecNewPod(instance.getExecNewPod()); 
            this.withFailurePolicy(instance.getFailurePolicy()); 
            this.withTagImages(instance.getTagImages()); 
    }

    public ExecNewPodHook getExecNewPod(){
            return this.execNewPod!=null?this.execNewPod.build():null;
    }

    public A withExecNewPod(ExecNewPodHook execNewPod){
            if (execNewPod!=null){ this.execNewPod= new ExecNewPodHookBuilder(execNewPod); _visitables.add(this.execNewPod);} return (A) this;
    }

    public LifecycleHookFluent.ExecNewPodNested<A> withNewExecNewPod(){
            return new ExecNewPodNestedImpl();
    }

    public LifecycleHookFluent.ExecNewPodNested<A> withNewExecNewPodLike(ExecNewPodHook item){
            return new ExecNewPodNestedImpl(item);
    }

    public LifecycleHookFluent.ExecNewPodNested<A> editExecNewPod(){
            return withNewExecNewPodLike(getExecNewPod());
    }

    public String getFailurePolicy(){
            return this.failurePolicy;
    }

    public A withFailurePolicy(String failurePolicy){
            this.failurePolicy=failurePolicy; return (A) this;
    }

    public A addToTagImages(TagImageHook... items){
            for (TagImageHook item : items) {TagImageHookBuilder builder = new TagImageHookBuilder(item);_visitables.add(builder);this.tagImages.add(builder);} return (A)this;
    }

    public A removeFromTagImages(TagImageHook... items){
            for (TagImageHook item : items) {TagImageHookBuilder builder = new TagImageHookBuilder(item);_visitables.remove(builder);this.tagImages.remove(builder);} return (A)this;
    }

    public List<TagImageHook> getTagImages(){
            return build(tagImages);
    }

    public A withTagImages(List<TagImageHook> tagImages){
            this.tagImages.clear();
            if (tagImages != null) {for (TagImageHook item : tagImages){this.addToTagImages(item);}} return (A) this;
    }

    public A withTagImages(TagImageHook... tagImages){
            this.tagImages.clear(); if (tagImages != null) {for (TagImageHook item :tagImages){ this.addToTagImages(item);}} return (A) this;
    }

    public LifecycleHookFluent.TagImagesNested<A> addNewTagImage(){
            return new TagImagesNestedImpl();
    }

    public LifecycleHookFluent.TagImagesNested<A> addNewTagImageLike(TagImageHook item){
            return new TagImagesNestedImpl(item);
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            LifecycleHookFluentImpl that = (LifecycleHookFluentImpl) o;
            if (execNewPod != null ? !execNewPod.equals(that.execNewPod) :that.execNewPod != null) return false;
            if (failurePolicy != null ? !failurePolicy.equals(that.failurePolicy) :that.failurePolicy != null) return false;
            if (tagImages != null ? !tagImages.equals(that.tagImages) :that.tagImages != null) return false;
            return true;
    }


    public class ExecNewPodNestedImpl<N> extends ExecNewPodHookFluentImpl<LifecycleHookFluent.ExecNewPodNested<N>> implements LifecycleHookFluent.ExecNewPodNested<N>,Nested<N>{

            private final ExecNewPodHookBuilder builder;
    
            ExecNewPodNestedImpl(){
                    this.builder = new ExecNewPodHookBuilder(this);
            }
            ExecNewPodNestedImpl(ExecNewPodHook item){
                    this.builder = new ExecNewPodHookBuilder(this, item);
            }
    
    public N and(){
            return (N) LifecycleHookFluentImpl.this.withExecNewPod(builder.build());
    }
    public N endExecNewPod(){
            return and();
    }

}
    public class TagImagesNestedImpl<N> extends TagImageHookFluentImpl<LifecycleHookFluent.TagImagesNested<N>> implements LifecycleHookFluent.TagImagesNested<N>,Nested<N>{

            private final TagImageHookBuilder builder;
    
            TagImagesNestedImpl(){
                    this.builder = new TagImageHookBuilder(this);
            }
            TagImagesNestedImpl(TagImageHook item){
                    this.builder = new TagImageHookBuilder(this, item);
            }
    
    public N and(){
            return (N) LifecycleHookFluentImpl.this.addToTagImages(builder.build());
    }
    public N endTagImage(){
            return and();
    }

}


}
