package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.String;
import javax.validation.constraints.NotNull;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.model.HasMetadata;
import javax.validation.Valid;
import java.util.List;
import java.lang.Object;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonIgnore;

public interface LocalSubjectAccessReviewFluent<A extends LocalSubjectAccessReviewFluent<A>> extends Fluent<A>{


    public String getApiVersion();
    public A withApiVersion(String apiVersion);
    public HasMetadata getContent();
    public A withContent(HasMetadata content);
    public A addToGroups(String... items);
    public A removeFromGroups(String... items);
    public List<String> getGroups();
    public A withGroups(List<String> groups);
    public A withGroups(String... groups);
    public String getKind();
    public A withKind(String kind);
    public String getNamespace();
    public A withNamespace(String namespace);
    public String getResource();
    public A withResource(String resource);
    public String getResourceAPIGroup();
    public A withResourceAPIGroup(String resourceAPIGroup);
    public String getResourceAPIVersion();
    public A withResourceAPIVersion(String resourceAPIVersion);
    public String getResourceName();
    public A withResourceName(String resourceName);
    public A addToScopes(String... items);
    public A removeFromScopes(String... items);
    public List<String> getScopes();
    public A withScopes(List<String> scopes);
    public A withScopes(String... scopes);
    public String getUser();
    public A withUser(String user);
    public String getVerb();
    public A withVerb(String verb);



}
