package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.BaseFluent;
import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import java.lang.Long;
import java.lang.Object;
import io.fabric8.kubernetes.api.builder.Nested;

public class RecreateDeploymentStrategyParamsFluentImpl<A extends RecreateDeploymentStrategyParamsFluent<A>> extends BaseFluent<A> implements RecreateDeploymentStrategyParamsFluent<A>{

    private VisitableBuilder<? extends LifecycleHook,?> mid;
    private VisitableBuilder<? extends LifecycleHook,?> post;
    private VisitableBuilder<? extends LifecycleHook,?> pre;
    private Long timeoutSeconds;

    public RecreateDeploymentStrategyParamsFluentImpl(){
    }
    public RecreateDeploymentStrategyParamsFluentImpl(RecreateDeploymentStrategyParams instance){
            this.withMid(instance.getMid()); 
            this.withPost(instance.getPost()); 
            this.withPre(instance.getPre()); 
            this.withTimeoutSeconds(instance.getTimeoutSeconds()); 
    }

    public LifecycleHook getMid(){
            return this.mid!=null?this.mid.build():null;
    }

    public A withMid(LifecycleHook mid){
            if (mid!=null){ this.mid= new LifecycleHookBuilder(mid); _visitables.add(this.mid);} return (A) this;
    }

    public RecreateDeploymentStrategyParamsFluent.MidNested<A> withNewMid(){
            return new MidNestedImpl();
    }

    public RecreateDeploymentStrategyParamsFluent.MidNested<A> withNewMidLike(LifecycleHook item){
            return new MidNestedImpl(item);
    }

    public RecreateDeploymentStrategyParamsFluent.MidNested<A> editMid(){
            return withNewMidLike(getMid());
    }

    public LifecycleHook getPost(){
            return this.post!=null?this.post.build():null;
    }

    public A withPost(LifecycleHook post){
            if (post!=null){ this.post= new LifecycleHookBuilder(post); _visitables.add(this.post);} return (A) this;
    }

    public RecreateDeploymentStrategyParamsFluent.PostNested<A> withNewPost(){
            return new PostNestedImpl();
    }

    public RecreateDeploymentStrategyParamsFluent.PostNested<A> withNewPostLike(LifecycleHook item){
            return new PostNestedImpl(item);
    }

    public RecreateDeploymentStrategyParamsFluent.PostNested<A> editPost(){
            return withNewPostLike(getPost());
    }

    public LifecycleHook getPre(){
            return this.pre!=null?this.pre.build():null;
    }

    public A withPre(LifecycleHook pre){
            if (pre!=null){ this.pre= new LifecycleHookBuilder(pre); _visitables.add(this.pre);} return (A) this;
    }

    public RecreateDeploymentStrategyParamsFluent.PreNested<A> withNewPre(){
            return new PreNestedImpl();
    }

    public RecreateDeploymentStrategyParamsFluent.PreNested<A> withNewPreLike(LifecycleHook item){
            return new PreNestedImpl(item);
    }

    public RecreateDeploymentStrategyParamsFluent.PreNested<A> editPre(){
            return withNewPreLike(getPre());
    }

    public Long getTimeoutSeconds(){
            return this.timeoutSeconds;
    }

    public A withTimeoutSeconds(Long timeoutSeconds){
            this.timeoutSeconds=timeoutSeconds; return (A) this;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            RecreateDeploymentStrategyParamsFluentImpl that = (RecreateDeploymentStrategyParamsFluentImpl) o;
            if (mid != null ? !mid.equals(that.mid) :that.mid != null) return false;
            if (post != null ? !post.equals(that.post) :that.post != null) return false;
            if (pre != null ? !pre.equals(that.pre) :that.pre != null) return false;
            if (timeoutSeconds != null ? !timeoutSeconds.equals(that.timeoutSeconds) :that.timeoutSeconds != null) return false;
            return true;
    }


    public class MidNestedImpl<N> extends LifecycleHookFluentImpl<RecreateDeploymentStrategyParamsFluent.MidNested<N>> implements RecreateDeploymentStrategyParamsFluent.MidNested<N>,Nested<N>{

            private final LifecycleHookBuilder builder;
    
            MidNestedImpl(){
                    this.builder = new LifecycleHookBuilder(this);
            }
            MidNestedImpl(LifecycleHook item){
                    this.builder = new LifecycleHookBuilder(this, item);
            }
    
    public N endMid(){
            return and();
    }
    public N and(){
            return (N) RecreateDeploymentStrategyParamsFluentImpl.this.withMid(builder.build());
    }

}
    public class PostNestedImpl<N> extends LifecycleHookFluentImpl<RecreateDeploymentStrategyParamsFluent.PostNested<N>> implements RecreateDeploymentStrategyParamsFluent.PostNested<N>,Nested<N>{

            private final LifecycleHookBuilder builder;
    
            PostNestedImpl(){
                    this.builder = new LifecycleHookBuilder(this);
            }
            PostNestedImpl(LifecycleHook item){
                    this.builder = new LifecycleHookBuilder(this, item);
            }
    
    public N endPost(){
            return and();
    }
    public N and(){
            return (N) RecreateDeploymentStrategyParamsFluentImpl.this.withPost(builder.build());
    }

}
    public class PreNestedImpl<N> extends LifecycleHookFluentImpl<RecreateDeploymentStrategyParamsFluent.PreNested<N>> implements RecreateDeploymentStrategyParamsFluent.PreNested<N>,Nested<N>{

            private final LifecycleHookBuilder builder;
    
            PreNestedImpl(){
                    this.builder = new LifecycleHookBuilder(this);
            }
            PreNestedImpl(LifecycleHook item){
                    this.builder = new LifecycleHookBuilder(this, item);
            }
    
    public N and(){
            return (N) RecreateDeploymentStrategyParamsFluentImpl.this.withPre(builder.build());
    }
    public N endPre(){
            return and();
    }

}


}
