package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import java.lang.String;
import java.lang.Object;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.fabric8.kubernetes.api.builder.Nested;

public interface RouteIngressFluent<A extends RouteIngressFluent<A>> extends Fluent<A>{


    public A addToConditions(RouteIngressCondition... items);
    public A removeFromConditions(RouteIngressCondition... items);
    public List<RouteIngressCondition> getConditions();
    public A withConditions(List<RouteIngressCondition> conditions);
    public A withConditions(RouteIngressCondition... conditions);
    public RouteIngressFluent.ConditionsNested<A> addNewCondition();
    public RouteIngressFluent.ConditionsNested<A> addNewConditionLike(RouteIngressCondition item);
    public A addNewCondition(String lastTransitionTime,String message,String reason,String status,String type);
    public String getHost();
    public A withHost(String host);
    public String getRouterName();
    public A withRouterName(String routerName);

    public interface ConditionsNested<N> extends Nested<N>,RouteIngressConditionFluent<RouteIngressFluent.ConditionsNested<N>>{

        
    public N endCondition();    public N and();
}


}
