package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.String;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.constraints.NotNull;
import java.util.Map;
import javax.validation.Valid;
import io.fabric8.kubernetes.api.model.ObjectMeta;
import io.fabric8.kubernetes.api.model.HasMetadata;
import java.util.List;
import javax.validation.constraints.Size;
import java.lang.Object;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.fabric8.kubernetes.api.model.validators.CheckObjectMeta;
import io.fabric8.kubernetes.api.model.LimitRange;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResource;
import io.fabric8.kubernetes.api.model.extensions.Job;
import io.fabric8.kubernetes.api.model.SecurityContextConstraints;
import io.fabric8.kubernetes.api.model.Namespace;
import io.fabric8.kubernetes.api.model.Service;
import io.fabric8.kubernetes.api.model.ReplicationController;
import io.fabric8.kubernetes.api.model.extensions.Scale;
import io.fabric8.kubernetes.api.model.PodTemplate;
import io.fabric8.kubernetes.api.model.Event;
import io.fabric8.kubernetes.api.model.extensions.Ingress;
import io.fabric8.kubernetes.api.model.PersistentVolume;
import io.fabric8.kubernetes.api.model.PersistentVolumeClaim;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSet;
import io.fabric8.kubernetes.api.model.Endpoints;
import io.fabric8.kubernetes.api.model.Pod;
import io.fabric8.kubernetes.api.model.ConfigMap;
import io.fabric8.kubernetes.api.model.extensions.DaemonSet;
import io.fabric8.kubernetes.api.model.extensions.Deployment;
import io.fabric8.kubernetes.api.model.ComponentStatus;
import io.fabric8.kubernetes.api.model.Binding;
import io.fabric8.kubernetes.api.model.ResourceQuota;
import io.fabric8.kubernetes.api.model.Secret;
import io.fabric8.kubernetes.api.model.Node;
import io.fabric8.kubernetes.api.model.extensions.HorizontalPodAutoscaler;
import io.fabric8.kubernetes.api.model.ServiceAccount;
import io.fabric8.kubernetes.api.builder.Nested;
import io.fabric8.kubernetes.api.model.ObjectMetaFluent;
import io.fabric8.kubernetes.api.model.ObjectMetaBuilder;
import io.fabric8.kubernetes.api.model.LimitRangeFluent;
import io.fabric8.kubernetes.api.model.LimitRangeBuilder;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceFluent;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceBuilder;
import io.fabric8.kubernetes.api.model.extensions.JobFluent;
import io.fabric8.kubernetes.api.model.extensions.JobBuilder;
import io.fabric8.kubernetes.api.model.SecurityContextConstraintsFluent;
import io.fabric8.kubernetes.api.model.SecurityContextConstraintsBuilder;
import io.fabric8.kubernetes.api.model.NamespaceFluent;
import io.fabric8.kubernetes.api.model.NamespaceBuilder;
import io.fabric8.kubernetes.api.model.ServiceFluent;
import io.fabric8.kubernetes.api.model.ServiceBuilder;
import io.fabric8.kubernetes.api.model.ReplicationControllerFluent;
import io.fabric8.kubernetes.api.model.ReplicationControllerBuilder;
import io.fabric8.kubernetes.api.model.extensions.ScaleFluent;
import io.fabric8.kubernetes.api.model.extensions.ScaleBuilder;
import io.fabric8.kubernetes.api.model.PodTemplateFluent;
import io.fabric8.kubernetes.api.model.PodTemplateBuilder;
import io.fabric8.kubernetes.api.model.EventFluent;
import io.fabric8.kubernetes.api.model.EventBuilder;
import io.fabric8.kubernetes.api.model.extensions.IngressFluent;
import io.fabric8.kubernetes.api.model.extensions.IngressBuilder;
import io.fabric8.kubernetes.api.model.PersistentVolumeFluent;
import io.fabric8.kubernetes.api.model.PersistentVolumeBuilder;
import io.fabric8.kubernetes.api.model.PersistentVolumeClaimFluent;
import io.fabric8.kubernetes.api.model.PersistentVolumeClaimBuilder;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetFluent;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetBuilder;
import io.fabric8.kubernetes.api.model.EndpointsFluent;
import io.fabric8.kubernetes.api.model.EndpointsBuilder;
import io.fabric8.kubernetes.api.model.PodFluent;
import io.fabric8.kubernetes.api.model.PodBuilder;
import io.fabric8.kubernetes.api.model.ConfigMapFluent;
import io.fabric8.kubernetes.api.model.ConfigMapBuilder;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetFluent;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetBuilder;
import io.fabric8.kubernetes.api.model.extensions.DeploymentFluent;
import io.fabric8.kubernetes.api.model.extensions.DeploymentBuilder;
import io.fabric8.kubernetes.api.model.ComponentStatusFluent;
import io.fabric8.kubernetes.api.model.ComponentStatusBuilder;
import io.fabric8.kubernetes.api.model.BindingFluent;
import io.fabric8.kubernetes.api.model.BindingBuilder;
import io.fabric8.kubernetes.api.model.ResourceQuotaFluent;
import io.fabric8.kubernetes.api.model.ResourceQuotaBuilder;
import io.fabric8.kubernetes.api.model.SecretFluent;
import io.fabric8.kubernetes.api.model.SecretBuilder;
import io.fabric8.kubernetes.api.model.NodeFluent;
import io.fabric8.kubernetes.api.model.NodeBuilder;
import io.fabric8.kubernetes.api.model.extensions.HorizontalPodAutoscalerFluent;
import io.fabric8.kubernetes.api.model.extensions.HorizontalPodAutoscalerBuilder;
import io.fabric8.kubernetes.api.model.ServiceAccountFluent;
import io.fabric8.kubernetes.api.model.ServiceAccountBuilder;

public interface TemplateFluent<A extends TemplateFluent<A>> extends Fluent<A>{


    public String getApiVersion();
    public A withApiVersion(String apiVersion);
    public String getKind();
    public A withKind(String kind);
    public A addToLabels(String key,String value);
    public A addToLabels(Map<String,String> map);
    public A removeFromLabels(String key);
    public A removeFromLabels(Map<String,String> map);
    public Map<String,String> getLabels();
    public A withLabels(Map<String,String> labels);
    public ObjectMeta getMetadata();
    public A withMetadata(ObjectMeta metadata);
    public TemplateFluent.MetadataNested<A> withNewMetadata();
    public TemplateFluent.MetadataNested<A> withNewMetadataLike(ObjectMeta item);
    public TemplateFluent.MetadataNested<A> editMetadata();
    public A addToObjects(HasMetadata... items);
    public A removeFromObjects(HasMetadata... items);
    public List<HasMetadata> getObjects();
    public A withObjects(List<HasMetadata> objects);
    public A withObjects(HasMetadata... objects);
    public A addToLimitRangeObjects(LimitRange... items);
    public A removeFromLimitRangeObjects(LimitRange... items);
    public TemplateFluent.LimitRangeObjectsNested<A> addNewLimitRangeObject();
    public TemplateFluent.LimitRangeObjectsNested<A> addNewLimitRangeObjectLike(LimitRange item);
    public A addToThirdPartyResourceObjects(ThirdPartyResource... items);
    public A removeFromThirdPartyResourceObjects(ThirdPartyResource... items);
    public TemplateFluent.ThirdPartyResourceObjectsNested<A> addNewThirdPartyResourceObject();
    public TemplateFluent.ThirdPartyResourceObjectsNested<A> addNewThirdPartyResourceObjectLike(ThirdPartyResource item);
    public A addToJobObjects(Job... items);
    public A removeFromJobObjects(Job... items);
    public TemplateFluent.JobObjectsNested<A> addNewJobObject();
    public TemplateFluent.JobObjectsNested<A> addNewJobObjectLike(Job item);
    public A addToProjectObjects(Project... items);
    public A removeFromProjectObjects(Project... items);
    public TemplateFluent.ProjectObjectsNested<A> addNewProjectObject();
    public TemplateFluent.ProjectObjectsNested<A> addNewProjectObjectLike(Project item);
    public A addToSecurityContextConstraintsObjects(SecurityContextConstraints... items);
    public A removeFromSecurityContextConstraintsObjects(SecurityContextConstraints... items);
    public TemplateFluent.SecurityContextConstraintsObjectsNested<A> addNewSecurityContextConstraintsObject();
    public TemplateFluent.SecurityContextConstraintsObjectsNested<A> addNewSecurityContextConstraintsObjectLike(SecurityContextConstraints item);
    public A addToBuildConfigObjects(BuildConfig... items);
    public A removeFromBuildConfigObjects(BuildConfig... items);
    public TemplateFluent.BuildConfigObjectsNested<A> addNewBuildConfigObject();
    public TemplateFluent.BuildConfigObjectsNested<A> addNewBuildConfigObjectLike(BuildConfig item);
    public A addToRouteObjects(Route... items);
    public A removeFromRouteObjects(Route... items);
    public TemplateFluent.RouteObjectsNested<A> addNewRouteObject();
    public TemplateFluent.RouteObjectsNested<A> addNewRouteObjectLike(Route item);
    public A addToOAuthAuthorizeTokenObjects(OAuthAuthorizeToken... items);
    public A removeFromOAuthAuthorizeTokenObjects(OAuthAuthorizeToken... items);
    public TemplateFluent.OAuthAuthorizeTokenObjectsNested<A> addNewOAuthAuthorizeTokenObject();
    public TemplateFluent.OAuthAuthorizeTokenObjectsNested<A> addNewOAuthAuthorizeTokenObjectLike(OAuthAuthorizeToken item);
    public A addToNamespaceObjects(Namespace... items);
    public A removeFromNamespaceObjects(Namespace... items);
    public TemplateFluent.NamespaceObjectsNested<A> addNewNamespaceObject();
    public TemplateFluent.NamespaceObjectsNested<A> addNewNamespaceObjectLike(Namespace item);
    public A addToClusterRoleBindingObjects(ClusterRoleBinding... items);
    public A removeFromClusterRoleBindingObjects(ClusterRoleBinding... items);
    public TemplateFluent.ClusterRoleBindingObjectsNested<A> addNewClusterRoleBindingObject();
    public TemplateFluent.ClusterRoleBindingObjectsNested<A> addNewClusterRoleBindingObjectLike(ClusterRoleBinding item);
    public A addToServiceObjects(Service... items);
    public A removeFromServiceObjects(Service... items);
    public TemplateFluent.ServiceObjectsNested<A> addNewServiceObject();
    public TemplateFluent.ServiceObjectsNested<A> addNewServiceObjectLike(Service item);
    public A addToReplicationControllerObjects(ReplicationController... items);
    public A removeFromReplicationControllerObjects(ReplicationController... items);
    public TemplateFluent.ReplicationControllerObjectsNested<A> addNewReplicationControllerObject();
    public TemplateFluent.ReplicationControllerObjectsNested<A> addNewReplicationControllerObjectLike(ReplicationController item);
    public A addToProjectRequestObjects(ProjectRequest... items);
    public A removeFromProjectRequestObjects(ProjectRequest... items);
    public TemplateFluent.ProjectRequestObjectsNested<A> addNewProjectRequestObject();
    public TemplateFluent.ProjectRequestObjectsNested<A> addNewProjectRequestObjectLike(ProjectRequest item);
    public A addToTemplateObjects(Template... items);
    public A removeFromTemplateObjects(Template... items);
    public TemplateFluent.TemplateObjectsNested<A> addNewTemplateObject();
    public TemplateFluent.TemplateObjectsNested<A> addNewTemplateObjectLike(Template item);
    public A addToOAuthClientAuthorizationObjects(OAuthClientAuthorization... items);
    public A removeFromOAuthClientAuthorizationObjects(OAuthClientAuthorization... items);
    public TemplateFluent.OAuthClientAuthorizationObjectsNested<A> addNewOAuthClientAuthorizationObject();
    public TemplateFluent.OAuthClientAuthorizationObjectsNested<A> addNewOAuthClientAuthorizationObjectLike(OAuthClientAuthorization item);
    public A addToPolicyBindingObjects(PolicyBinding... items);
    public A removeFromPolicyBindingObjects(PolicyBinding... items);
    public TemplateFluent.PolicyBindingObjectsNested<A> addNewPolicyBindingObject();
    public TemplateFluent.PolicyBindingObjectsNested<A> addNewPolicyBindingObjectLike(PolicyBinding item);
    public A addToClusterRoleObjects(ClusterRole... items);
    public A removeFromClusterRoleObjects(ClusterRole... items);
    public TemplateFluent.ClusterRoleObjectsNested<A> addNewClusterRoleObject();
    public TemplateFluent.ClusterRoleObjectsNested<A> addNewClusterRoleObjectLike(ClusterRole item);
    public A addToScaleObjects(Scale... items);
    public A removeFromScaleObjects(Scale... items);
    public TemplateFluent.ScaleObjectsNested<A> addNewScaleObject();
    public TemplateFluent.ScaleObjectsNested<A> addNewScaleObjectLike(Scale item);
    public A addToPodTemplateObjects(PodTemplate... items);
    public A removeFromPodTemplateObjects(PodTemplate... items);
    public TemplateFluent.PodTemplateObjectsNested<A> addNewPodTemplateObject();
    public TemplateFluent.PodTemplateObjectsNested<A> addNewPodTemplateObjectLike(PodTemplate item);
    public A addToEventObjects(Event... items);
    public A removeFromEventObjects(Event... items);
    public TemplateFluent.EventObjectsNested<A> addNewEventObject();
    public TemplateFluent.EventObjectsNested<A> addNewEventObjectLike(Event item);
    public A addToIngressObjects(Ingress... items);
    public A removeFromIngressObjects(Ingress... items);
    public TemplateFluent.IngressObjectsNested<A> addNewIngressObject();
    public TemplateFluent.IngressObjectsNested<A> addNewIngressObjectLike(Ingress item);
    public A addToDeploymentConfigObjects(DeploymentConfig... items);
    public A removeFromDeploymentConfigObjects(DeploymentConfig... items);
    public TemplateFluent.DeploymentConfigObjectsNested<A> addNewDeploymentConfigObject();
    public TemplateFluent.DeploymentConfigObjectsNested<A> addNewDeploymentConfigObjectLike(DeploymentConfig item);
    public A addToOAuthAccessTokenObjects(OAuthAccessToken... items);
    public A removeFromOAuthAccessTokenObjects(OAuthAccessToken... items);
    public TemplateFluent.OAuthAccessTokenObjectsNested<A> addNewOAuthAccessTokenObject();
    public TemplateFluent.OAuthAccessTokenObjectsNested<A> addNewOAuthAccessTokenObjectLike(OAuthAccessToken item);
    public A addToRoleBindingObjects(RoleBinding... items);
    public A removeFromRoleBindingObjects(RoleBinding... items);
    public TemplateFluent.RoleBindingObjectsNested<A> addNewRoleBindingObject();
    public TemplateFluent.RoleBindingObjectsNested<A> addNewRoleBindingObjectLike(RoleBinding item);
    public A addToPersistentVolumeObjects(PersistentVolume... items);
    public A removeFromPersistentVolumeObjects(PersistentVolume... items);
    public TemplateFluent.PersistentVolumeObjectsNested<A> addNewPersistentVolumeObject();
    public TemplateFluent.PersistentVolumeObjectsNested<A> addNewPersistentVolumeObjectLike(PersistentVolume item);
    public A addToImageObjects(Image... items);
    public A removeFromImageObjects(Image... items);
    public TemplateFluent.ImageObjectsNested<A> addNewImageObject();
    public TemplateFluent.ImageObjectsNested<A> addNewImageObjectLike(Image item);
    public A addToPersistentVolumeClaimObjects(PersistentVolumeClaim... items);
    public A removeFromPersistentVolumeClaimObjects(PersistentVolumeClaim... items);
    public TemplateFluent.PersistentVolumeClaimObjectsNested<A> addNewPersistentVolumeClaimObject();
    public TemplateFluent.PersistentVolumeClaimObjectsNested<A> addNewPersistentVolumeClaimObjectLike(PersistentVolumeClaim item);
    public A addToReplicaSetObjects(ReplicaSet... items);
    public A removeFromReplicaSetObjects(ReplicaSet... items);
    public TemplateFluent.ReplicaSetObjectsNested<A> addNewReplicaSetObject();
    public TemplateFluent.ReplicaSetObjectsNested<A> addNewReplicaSetObjectLike(ReplicaSet item);
    public A addToRoleObjects(Role... items);
    public A removeFromRoleObjects(Role... items);
    public TemplateFluent.RoleObjectsNested<A> addNewRoleObject();
    public TemplateFluent.RoleObjectsNested<A> addNewRoleObjectLike(Role item);
    public A addToEndpointsObjects(Endpoints... items);
    public A removeFromEndpointsObjects(Endpoints... items);
    public TemplateFluent.EndpointsObjectsNested<A> addNewEndpointsObject();
    public TemplateFluent.EndpointsObjectsNested<A> addNewEndpointsObjectLike(Endpoints item);
    public A addToPodObjects(Pod... items);
    public A removeFromPodObjects(Pod... items);
    public TemplateFluent.PodObjectsNested<A> addNewPodObject();
    public TemplateFluent.PodObjectsNested<A> addNewPodObjectLike(Pod item);
    public A addToConfigMapObjects(ConfigMap... items);
    public A removeFromConfigMapObjects(ConfigMap... items);
    public TemplateFluent.ConfigMapObjectsNested<A> addNewConfigMapObject();
    public TemplateFluent.ConfigMapObjectsNested<A> addNewConfigMapObjectLike(ConfigMap item);
    public A addToClusterPolicyObjects(ClusterPolicy... items);
    public A removeFromClusterPolicyObjects(ClusterPolicy... items);
    public TemplateFluent.ClusterPolicyObjectsNested<A> addNewClusterPolicyObject();
    public TemplateFluent.ClusterPolicyObjectsNested<A> addNewClusterPolicyObjectLike(ClusterPolicy item);
    public A addToDaemonSetObjects(DaemonSet... items);
    public A removeFromDaemonSetObjects(DaemonSet... items);
    public TemplateFluent.DaemonSetObjectsNested<A> addNewDaemonSetObject();
    public TemplateFluent.DaemonSetObjectsNested<A> addNewDaemonSetObjectLike(DaemonSet item);
    public A addToDeploymentObjects(Deployment... items);
    public A removeFromDeploymentObjects(Deployment... items);
    public TemplateFluent.DeploymentObjectsNested<A> addNewDeploymentObject();
    public TemplateFluent.DeploymentObjectsNested<A> addNewDeploymentObjectLike(Deployment item);
    public A addToUserObjects(User... items);
    public A removeFromUserObjects(User... items);
    public TemplateFluent.UserObjectsNested<A> addNewUserObject();
    public TemplateFluent.UserObjectsNested<A> addNewUserObjectLike(User item);
    public A addToComponentStatusObjects(ComponentStatus... items);
    public A removeFromComponentStatusObjects(ComponentStatus... items);
    public TemplateFluent.ComponentStatusObjectsNested<A> addNewComponentStatusObject();
    public TemplateFluent.ComponentStatusObjectsNested<A> addNewComponentStatusObjectLike(ComponentStatus item);
    public A addToBuildObjects(Build... items);
    public A removeFromBuildObjects(Build... items);
    public TemplateFluent.BuildObjectsNested<A> addNewBuildObject();
    public TemplateFluent.BuildObjectsNested<A> addNewBuildObjectLike(Build item);
    public A addToImageStreamTagObjects(ImageStreamTag... items);
    public A removeFromImageStreamTagObjects(ImageStreamTag... items);
    public TemplateFluent.ImageStreamTagObjectsNested<A> addNewImageStreamTagObject();
    public TemplateFluent.ImageStreamTagObjectsNested<A> addNewImageStreamTagObjectLike(ImageStreamTag item);
    public A addToGroupObjects(Group... items);
    public A removeFromGroupObjects(Group... items);
    public TemplateFluent.GroupObjectsNested<A> addNewGroupObject();
    public TemplateFluent.GroupObjectsNested<A> addNewGroupObjectLike(Group item);
    public A addToPolicyObjects(Policy... items);
    public A removeFromPolicyObjects(Policy... items);
    public TemplateFluent.PolicyObjectsNested<A> addNewPolicyObject();
    public TemplateFluent.PolicyObjectsNested<A> addNewPolicyObjectLike(Policy item);
    public A addToImageSignatureObjects(ImageSignature... items);
    public A removeFromImageSignatureObjects(ImageSignature... items);
    public TemplateFluent.ImageSignatureObjectsNested<A> addNewImageSignatureObject();
    public TemplateFluent.ImageSignatureObjectsNested<A> addNewImageSignatureObjectLike(ImageSignature item);
    public A addToBindingObjects(Binding... items);
    public A removeFromBindingObjects(Binding... items);
    public TemplateFluent.BindingObjectsNested<A> addNewBindingObject();
    public TemplateFluent.BindingObjectsNested<A> addNewBindingObjectLike(Binding item);
    public A addToResourceQuotaObjects(ResourceQuota... items);
    public A removeFromResourceQuotaObjects(ResourceQuota... items);
    public TemplateFluent.ResourceQuotaObjectsNested<A> addNewResourceQuotaObject();
    public TemplateFluent.ResourceQuotaObjectsNested<A> addNewResourceQuotaObjectLike(ResourceQuota item);
    public A addToSecretObjects(Secret... items);
    public A removeFromSecretObjects(Secret... items);
    public TemplateFluent.SecretObjectsNested<A> addNewSecretObject();
    public TemplateFluent.SecretObjectsNested<A> addNewSecretObjectLike(Secret item);
    public A addToBuildRequestObjects(BuildRequest... items);
    public A removeFromBuildRequestObjects(BuildRequest... items);
    public TemplateFluent.BuildRequestObjectsNested<A> addNewBuildRequestObject();
    public TemplateFluent.BuildRequestObjectsNested<A> addNewBuildRequestObjectLike(BuildRequest item);
    public A addToClusterPolicyBindingObjects(ClusterPolicyBinding... items);
    public A removeFromClusterPolicyBindingObjects(ClusterPolicyBinding... items);
    public TemplateFluent.ClusterPolicyBindingObjectsNested<A> addNewClusterPolicyBindingObject();
    public TemplateFluent.ClusterPolicyBindingObjectsNested<A> addNewClusterPolicyBindingObjectLike(ClusterPolicyBinding item);
    public A addToNodeObjects(Node... items);
    public A removeFromNodeObjects(Node... items);
    public TemplateFluent.NodeObjectsNested<A> addNewNodeObject();
    public TemplateFluent.NodeObjectsNested<A> addNewNodeObjectLike(Node item);
    public A addToImageStreamObjects(ImageStream... items);
    public A removeFromImageStreamObjects(ImageStream... items);
    public TemplateFluent.ImageStreamObjectsNested<A> addNewImageStreamObject();
    public TemplateFluent.ImageStreamObjectsNested<A> addNewImageStreamObjectLike(ImageStream item);
    public A addToHorizontalPodAutoscalerObjects(HorizontalPodAutoscaler... items);
    public A removeFromHorizontalPodAutoscalerObjects(HorizontalPodAutoscaler... items);
    public TemplateFluent.HorizontalPodAutoscalerObjectsNested<A> addNewHorizontalPodAutoscalerObject();
    public TemplateFluent.HorizontalPodAutoscalerObjectsNested<A> addNewHorizontalPodAutoscalerObjectLike(HorizontalPodAutoscaler item);
    public A addToOAuthClientObjects(OAuthClient... items);
    public A removeFromOAuthClientObjects(OAuthClient... items);
    public TemplateFluent.OAuthClientObjectsNested<A> addNewOAuthClientObject();
    public TemplateFluent.OAuthClientObjectsNested<A> addNewOAuthClientObjectLike(OAuthClient item);
    public A addToIdentityObjects(Identity... items);
    public A removeFromIdentityObjects(Identity... items);
    public TemplateFluent.IdentityObjectsNested<A> addNewIdentityObject();
    public TemplateFluent.IdentityObjectsNested<A> addNewIdentityObjectLike(Identity item);
    public A addToServiceAccountObjects(ServiceAccount... items);
    public A removeFromServiceAccountObjects(ServiceAccount... items);
    public TemplateFluent.ServiceAccountObjectsNested<A> addNewServiceAccountObject();
    public TemplateFluent.ServiceAccountObjectsNested<A> addNewServiceAccountObjectLike(ServiceAccount item);
    public A addToParameters(Parameter... items);
    public A removeFromParameters(Parameter... items);
    public List<Parameter> getParameters();
    public A withParameters(List<Parameter> parameters);
    public A withParameters(Parameter... parameters);
    public TemplateFluent.ParametersNested<A> addNewParameter();
    public TemplateFluent.ParametersNested<A> addNewParameterLike(Parameter item);

    public interface MetadataNested<N> extends Nested<N>,ObjectMetaFluent<TemplateFluent.MetadataNested<N>>{

        
    public N and();    public N endMetadata();
}
    public interface LimitRangeObjectsNested<N> extends Nested<N>,LimitRangeFluent<TemplateFluent.LimitRangeObjectsNested<N>>{

        
    public N and();    public N endLimitRangeObject();
}
    public interface ThirdPartyResourceObjectsNested<N> extends Nested<N>,ThirdPartyResourceFluent<TemplateFluent.ThirdPartyResourceObjectsNested<N>>{

        
    public N and();    public N endThirdPartyResourceObject();
}
    public interface JobObjectsNested<N> extends Nested<N>,JobFluent<TemplateFluent.JobObjectsNested<N>>{

        
    public N endJobObject();    public N and();
}
    public interface ProjectObjectsNested<N> extends Nested<N>,ProjectFluent<TemplateFluent.ProjectObjectsNested<N>>{

        
    public N and();    public N endProjectObject();
}
    public interface SecurityContextConstraintsObjectsNested<N> extends Nested<N>,SecurityContextConstraintsFluent<TemplateFluent.SecurityContextConstraintsObjectsNested<N>>{

        
    public N and();    public N endSecurityContextConstraintsObject();
}
    public interface BuildConfigObjectsNested<N> extends Nested<N>,BuildConfigFluent<TemplateFluent.BuildConfigObjectsNested<N>>{

        
    public N and();    public N endBuildConfigObject();
}
    public interface RouteObjectsNested<N> extends Nested<N>,RouteFluent<TemplateFluent.RouteObjectsNested<N>>{

        
    public N endRouteObject();    public N and();
}
    public interface OAuthAuthorizeTokenObjectsNested<N> extends Nested<N>,OAuthAuthorizeTokenFluent<TemplateFluent.OAuthAuthorizeTokenObjectsNested<N>>{

        
    public N and();    public N endOAuthAuthorizeTokenObject();
}
    public interface NamespaceObjectsNested<N> extends Nested<N>,NamespaceFluent<TemplateFluent.NamespaceObjectsNested<N>>{

        
    public N endNamespaceObject();    public N and();
}
    public interface ClusterRoleBindingObjectsNested<N> extends Nested<N>,ClusterRoleBindingFluent<TemplateFluent.ClusterRoleBindingObjectsNested<N>>{

        
    public N endClusterRoleBindingObject();    public N and();
}
    public interface ServiceObjectsNested<N> extends Nested<N>,ServiceFluent<TemplateFluent.ServiceObjectsNested<N>>{

        
    public N and();    public N endServiceObject();
}
    public interface ReplicationControllerObjectsNested<N> extends Nested<N>,ReplicationControllerFluent<TemplateFluent.ReplicationControllerObjectsNested<N>>{

        
    public N endReplicationControllerObject();    public N and();
}
    public interface ProjectRequestObjectsNested<N> extends Nested<N>,ProjectRequestFluent<TemplateFluent.ProjectRequestObjectsNested<N>>{

        
    public N endProjectRequestObject();    public N and();
}
    public interface TemplateObjectsNested<N> extends Nested<N>,TemplateFluent<TemplateFluent.TemplateObjectsNested<N>>{

        
    public N endTemplateObject();    public N and();
}
    public interface OAuthClientAuthorizationObjectsNested<N> extends Nested<N>,OAuthClientAuthorizationFluent<TemplateFluent.OAuthClientAuthorizationObjectsNested<N>>{

        
    public N endOAuthClientAuthorizationObject();    public N and();
}
    public interface PolicyBindingObjectsNested<N> extends Nested<N>,PolicyBindingFluent<TemplateFluent.PolicyBindingObjectsNested<N>>{

        
    public N and();    public N endPolicyBindingObject();
}
    public interface ClusterRoleObjectsNested<N> extends Nested<N>,ClusterRoleFluent<TemplateFluent.ClusterRoleObjectsNested<N>>{

        
    public N endClusterRoleObject();    public N and();
}
    public interface ScaleObjectsNested<N> extends Nested<N>,ScaleFluent<TemplateFluent.ScaleObjectsNested<N>>{

        
    public N and();    public N endScaleObject();
}
    public interface PodTemplateObjectsNested<N> extends Nested<N>,PodTemplateFluent<TemplateFluent.PodTemplateObjectsNested<N>>{

        
    public N endPodTemplateObject();    public N and();
}
    public interface EventObjectsNested<N> extends Nested<N>,EventFluent<TemplateFluent.EventObjectsNested<N>>{

        
    public N and();    public N endEventObject();
}
    public interface IngressObjectsNested<N> extends Nested<N>,IngressFluent<TemplateFluent.IngressObjectsNested<N>>{

        
    public N endIngressObject();    public N and();
}
    public interface DeploymentConfigObjectsNested<N> extends Nested<N>,DeploymentConfigFluent<TemplateFluent.DeploymentConfigObjectsNested<N>>{

        
    public N and();    public N endDeploymentConfigObject();
}
    public interface OAuthAccessTokenObjectsNested<N> extends Nested<N>,OAuthAccessTokenFluent<TemplateFluent.OAuthAccessTokenObjectsNested<N>>{

        
    public N endOAuthAccessTokenObject();    public N and();
}
    public interface RoleBindingObjectsNested<N> extends Nested<N>,RoleBindingFluent<TemplateFluent.RoleBindingObjectsNested<N>>{

        
    public N and();    public N endRoleBindingObject();
}
    public interface PersistentVolumeObjectsNested<N> extends Nested<N>,PersistentVolumeFluent<TemplateFluent.PersistentVolumeObjectsNested<N>>{

        
    public N and();    public N endPersistentVolumeObject();
}
    public interface ImageObjectsNested<N> extends Nested<N>,ImageFluent<TemplateFluent.ImageObjectsNested<N>>{

        
    public N endImageObject();    public N and();
}
    public interface PersistentVolumeClaimObjectsNested<N> extends Nested<N>,PersistentVolumeClaimFluent<TemplateFluent.PersistentVolumeClaimObjectsNested<N>>{

        
    public N endPersistentVolumeClaimObject();    public N and();
}
    public interface ReplicaSetObjectsNested<N> extends Nested<N>,ReplicaSetFluent<TemplateFluent.ReplicaSetObjectsNested<N>>{

        
    public N endReplicaSetObject();    public N and();
}
    public interface RoleObjectsNested<N> extends Nested<N>,RoleFluent<TemplateFluent.RoleObjectsNested<N>>{

        
    public N and();    public N endRoleObject();
}
    public interface EndpointsObjectsNested<N> extends Nested<N>,EndpointsFluent<TemplateFluent.EndpointsObjectsNested<N>>{

        
    public N and();    public N endEndpointsObject();
}
    public interface PodObjectsNested<N> extends Nested<N>,PodFluent<TemplateFluent.PodObjectsNested<N>>{

        
    public N endPodObject();    public N and();
}
    public interface ConfigMapObjectsNested<N> extends Nested<N>,ConfigMapFluent<TemplateFluent.ConfigMapObjectsNested<N>>{

        
    public N and();    public N endConfigMapObject();
}
    public interface ClusterPolicyObjectsNested<N> extends Nested<N>,ClusterPolicyFluent<TemplateFluent.ClusterPolicyObjectsNested<N>>{

        
    public N endClusterPolicyObject();    public N and();
}
    public interface DaemonSetObjectsNested<N> extends Nested<N>,DaemonSetFluent<TemplateFluent.DaemonSetObjectsNested<N>>{

        
    public N endDaemonSetObject();    public N and();
}
    public interface DeploymentObjectsNested<N> extends Nested<N>,DeploymentFluent<TemplateFluent.DeploymentObjectsNested<N>>{

        
    public N endDeploymentObject();    public N and();
}
    public interface UserObjectsNested<N> extends Nested<N>,UserFluent<TemplateFluent.UserObjectsNested<N>>{

        
    public N and();    public N endUserObject();
}
    public interface ComponentStatusObjectsNested<N> extends Nested<N>,ComponentStatusFluent<TemplateFluent.ComponentStatusObjectsNested<N>>{

        
    public N and();    public N endComponentStatusObject();
}
    public interface BuildObjectsNested<N> extends Nested<N>,BuildFluent<TemplateFluent.BuildObjectsNested<N>>{

        
    public N endBuildObject();    public N and();
}
    public interface ImageStreamTagObjectsNested<N> extends Nested<N>,ImageStreamTagFluent<TemplateFluent.ImageStreamTagObjectsNested<N>>{

        
    public N endImageStreamTagObject();    public N and();
}
    public interface GroupObjectsNested<N> extends Nested<N>,GroupFluent<TemplateFluent.GroupObjectsNested<N>>{

        
    public N and();    public N endGroupObject();
}
    public interface PolicyObjectsNested<N> extends Nested<N>,PolicyFluent<TemplateFluent.PolicyObjectsNested<N>>{

        
    public N and();    public N endPolicyObject();
}
    public interface ImageSignatureObjectsNested<N> extends Nested<N>,ImageSignatureFluent<TemplateFluent.ImageSignatureObjectsNested<N>>{

        
    public N and();    public N endImageSignatureObject();
}
    public interface BindingObjectsNested<N> extends Nested<N>,BindingFluent<TemplateFluent.BindingObjectsNested<N>>{

        
    public N endBindingObject();    public N and();
}
    public interface ResourceQuotaObjectsNested<N> extends Nested<N>,ResourceQuotaFluent<TemplateFluent.ResourceQuotaObjectsNested<N>>{

        
    public N endResourceQuotaObject();    public N and();
}
    public interface SecretObjectsNested<N> extends Nested<N>,SecretFluent<TemplateFluent.SecretObjectsNested<N>>{

        
    public N endSecretObject();    public N and();
}
    public interface BuildRequestObjectsNested<N> extends Nested<N>,BuildRequestFluent<TemplateFluent.BuildRequestObjectsNested<N>>{

        
    public N endBuildRequestObject();    public N and();
}
    public interface ClusterPolicyBindingObjectsNested<N> extends Nested<N>,ClusterPolicyBindingFluent<TemplateFluent.ClusterPolicyBindingObjectsNested<N>>{

        
    public N endClusterPolicyBindingObject();    public N and();
}
    public interface NodeObjectsNested<N> extends Nested<N>,NodeFluent<TemplateFluent.NodeObjectsNested<N>>{

        
    public N endNodeObject();    public N and();
}
    public interface ImageStreamObjectsNested<N> extends Nested<N>,ImageStreamFluent<TemplateFluent.ImageStreamObjectsNested<N>>{

        
    public N endImageStreamObject();    public N and();
}
    public interface HorizontalPodAutoscalerObjectsNested<N> extends Nested<N>,HorizontalPodAutoscalerFluent<TemplateFluent.HorizontalPodAutoscalerObjectsNested<N>>{

        
    public N endHorizontalPodAutoscalerObject();    public N and();
}
    public interface OAuthClientObjectsNested<N> extends Nested<N>,OAuthClientFluent<TemplateFluent.OAuthClientObjectsNested<N>>{

        
    public N and();    public N endOAuthClientObject();
}
    public interface IdentityObjectsNested<N> extends Nested<N>,IdentityFluent<TemplateFluent.IdentityObjectsNested<N>>{

        
    public N and();    public N endIdentityObject();
}
    public interface ServiceAccountObjectsNested<N> extends Nested<N>,ServiceAccountFluent<TemplateFluent.ServiceAccountObjectsNested<N>>{

        
    public N and();    public N endServiceAccountObject();
}
    public interface ParametersNested<N> extends Nested<N>,ParameterFluent<TemplateFluent.ParametersNested<N>>{

        
    public N endParameter();    public N and();
}


}
