package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Boolean;
import javax.validation.Validation;
import javax.validation.Validator;
import javax.validation.ValidatorFactory;
import javax.validation.ValidationException;
import javax.validation.ConstraintViolation;
import javax.validation.ConstraintViolationException;
import java.util.Set;
import java.lang.Object;

public class DeprecatedDownwardAPIVolumeSourceBuilder extends DeprecatedDownwardAPIVolumeSourceFluentImpl<DeprecatedDownwardAPIVolumeSourceBuilder> implements VisitableBuilder<DeprecatedDownwardAPIVolumeSource,DeprecatedDownwardAPIVolumeSourceBuilder>{

    DeprecatedDownwardAPIVolumeSourceFluent<?> fluent;
    Boolean validationEnabled;

    public DeprecatedDownwardAPIVolumeSourceBuilder(){
            this(true);
    }
    public DeprecatedDownwardAPIVolumeSourceBuilder(Boolean validationEnabled){
            this(new DeprecatedDownwardAPIVolumeSource(), validationEnabled);
    }
    public DeprecatedDownwardAPIVolumeSourceBuilder(DeprecatedDownwardAPIVolumeSourceFluent<?> fluent){
            this(fluent, true);
    }
    public DeprecatedDownwardAPIVolumeSourceBuilder(DeprecatedDownwardAPIVolumeSourceFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new DeprecatedDownwardAPIVolumeSource(), validationEnabled);
    }
    public DeprecatedDownwardAPIVolumeSourceBuilder(DeprecatedDownwardAPIVolumeSourceFluent<?> fluent,DeprecatedDownwardAPIVolumeSource instance){
            this(fluent, instance, true);
    }
    public DeprecatedDownwardAPIVolumeSourceBuilder(DeprecatedDownwardAPIVolumeSourceFluent<?> fluent,DeprecatedDownwardAPIVolumeSource instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withItems(instance.getItems()); 
            this.validationEnabled = validationEnabled; 
    }
    public DeprecatedDownwardAPIVolumeSourceBuilder(DeprecatedDownwardAPIVolumeSource instance){
            this(instance,true);
    }
    public DeprecatedDownwardAPIVolumeSourceBuilder(DeprecatedDownwardAPIVolumeSource instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withItems(instance.getItems()); 
            this.validationEnabled = validationEnabled; 
    }

    public DeprecatedDownwardAPIVolumeSource build(){
            DeprecatedDownwardAPIVolumeSource buildable = new DeprecatedDownwardAPIVolumeSource(fluent.getItems());
            validate(buildable);
            return buildable;
    }

    private <T>void validate(T item){
            if (!validationEnabled) { return; }
            Validator validator = null;
            try {
                ValidatorFactory factory = Validation.buildDefaultValidatorFactory();
                validator = factory.getValidator();
            } catch(ValidationException e) {return;}
            Set<ConstraintViolation<T>> violations = validator.validate(item);
            if (!violations.isEmpty()) {
            throw new ConstraintViolationException(violations);
             }
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            DeprecatedDownwardAPIVolumeSourceBuilder that = (DeprecatedDownwardAPIVolumeSourceBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
