package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.BaseFluent;
import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import io.fabric8.openshift.api.model.BuildConfigList;
import io.fabric8.openshift.api.model.BuildList;
import io.fabric8.openshift.api.model.BuildRequest;
import io.fabric8.openshift.api.model.ClusterPolicy;
import io.fabric8.openshift.api.model.ClusterPolicyBinding;
import io.fabric8.openshift.api.model.ClusterPolicyBindingList;
import io.fabric8.openshift.api.model.ClusterPolicyList;
import io.fabric8.openshift.api.model.ClusterRoleBinding;
import io.fabric8.openshift.api.model.ClusterRoleBindingList;
import io.fabric8.kubernetes.api.model.extensions.DaemonSet;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetList;
import io.fabric8.kubernetes.api.model.extensions.Deployment;
import io.fabric8.openshift.api.model.DeploymentConfigList;
import io.fabric8.kubernetes.api.model.extensions.DeploymentList;
import io.fabric8.kubernetes.api.model.extensions.DeploymentRollback;
import io.fabric8.openshift.api.model.Group;
import io.fabric8.openshift.api.model.GroupList;
import io.fabric8.kubernetes.api.model.extensions.HorizontalPodAutoscaler;
import io.fabric8.kubernetes.api.model.extensions.HorizontalPodAutoscalerList;
import io.fabric8.openshift.api.model.Identity;
import io.fabric8.openshift.api.model.IdentityList;
import io.fabric8.openshift.api.model.ImageList;
import io.fabric8.openshift.api.model.ImageStreamList;
import io.fabric8.openshift.api.model.ImageStreamTagList;
import io.fabric8.kubernetes.api.model.extensions.Ingress;
import io.fabric8.kubernetes.api.model.extensions.IngressList;
import io.fabric8.kubernetes.api.model.extensions.Job;
import io.fabric8.kubernetes.api.model.extensions.JobList;
import java.lang.String;
import io.fabric8.openshift.api.model.LocalSubjectAccessReview;
import io.fabric8.openshift.api.model.OAuthAccessToken;
import io.fabric8.openshift.api.model.OAuthAccessTokenList;
import io.fabric8.openshift.api.model.OAuthAuthorizeToken;
import io.fabric8.openshift.api.model.OAuthAuthorizeTokenList;
import io.fabric8.openshift.api.model.OAuthClient;
import io.fabric8.openshift.api.model.OAuthClientAuthorization;
import io.fabric8.openshift.api.model.OAuthClientAuthorizationList;
import io.fabric8.openshift.api.model.OAuthClientList;
import io.fabric8.openshift.api.model.Policy;
import io.fabric8.openshift.api.model.PolicyBinding;
import io.fabric8.openshift.api.model.PolicyBindingList;
import io.fabric8.openshift.api.model.PolicyList;
import io.fabric8.openshift.api.model.Project;
import io.fabric8.openshift.api.model.ProjectList;
import io.fabric8.openshift.api.model.ProjectRequest;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSet;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetList;
import io.fabric8.openshift.api.model.Role;
import io.fabric8.openshift.api.model.RoleBinding;
import io.fabric8.openshift.api.model.RoleBindingList;
import io.fabric8.openshift.api.model.RoleList;
import io.fabric8.openshift.api.model.RouteList;
import io.fabric8.kubernetes.api.model.extensions.Scale;
import io.fabric8.openshift.api.model.SubjectAccessReview;
import io.fabric8.openshift.api.model.SubjectAccessReviewResponse;
import io.fabric8.openshift.api.model.TagEvent;
import java.lang.Long;
import io.fabric8.openshift.api.model.Template;
import io.fabric8.openshift.api.model.TemplateList;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResource;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceList;
import io.fabric8.openshift.api.model.User;
import io.fabric8.openshift.api.model.UserList;
import java.lang.Object;
import io.fabric8.kubernetes.api.builder.Nested;
import io.fabric8.openshift.api.model.BuildConfigListFluentImpl;
import io.fabric8.openshift.api.model.BuildConfigListBuilder;
import io.fabric8.openshift.api.model.BuildListFluentImpl;
import io.fabric8.openshift.api.model.BuildListBuilder;
import io.fabric8.openshift.api.model.BuildRequestFluentImpl;
import io.fabric8.openshift.api.model.BuildRequestBuilder;
import io.fabric8.openshift.api.model.ClusterPolicyFluentImpl;
import io.fabric8.openshift.api.model.ClusterPolicyBuilder;
import io.fabric8.openshift.api.model.ClusterPolicyBindingFluentImpl;
import io.fabric8.openshift.api.model.ClusterPolicyBindingBuilder;
import io.fabric8.openshift.api.model.ClusterPolicyBindingListFluentImpl;
import io.fabric8.openshift.api.model.ClusterPolicyBindingListBuilder;
import io.fabric8.openshift.api.model.ClusterPolicyListFluentImpl;
import io.fabric8.openshift.api.model.ClusterPolicyListBuilder;
import io.fabric8.openshift.api.model.ClusterRoleBindingFluentImpl;
import io.fabric8.openshift.api.model.ClusterRoleBindingBuilder;
import io.fabric8.openshift.api.model.ClusterRoleBindingListFluentImpl;
import io.fabric8.openshift.api.model.ClusterRoleBindingListBuilder;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetBuilder;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetListFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetListBuilder;
import io.fabric8.kubernetes.api.model.extensions.DeploymentFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.DeploymentBuilder;
import io.fabric8.openshift.api.model.DeploymentConfigListFluentImpl;
import io.fabric8.openshift.api.model.DeploymentConfigListBuilder;
import io.fabric8.kubernetes.api.model.extensions.DeploymentListFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.DeploymentListBuilder;
import io.fabric8.kubernetes.api.model.extensions.DeploymentRollbackFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.DeploymentRollbackBuilder;
import io.fabric8.openshift.api.model.GroupFluentImpl;
import io.fabric8.openshift.api.model.GroupBuilder;
import io.fabric8.openshift.api.model.GroupListFluentImpl;
import io.fabric8.openshift.api.model.GroupListBuilder;
import io.fabric8.kubernetes.api.model.extensions.HorizontalPodAutoscalerFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.HorizontalPodAutoscalerBuilder;
import io.fabric8.kubernetes.api.model.extensions.HorizontalPodAutoscalerListFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.HorizontalPodAutoscalerListBuilder;
import io.fabric8.openshift.api.model.IdentityFluentImpl;
import io.fabric8.openshift.api.model.IdentityBuilder;
import io.fabric8.openshift.api.model.IdentityListFluentImpl;
import io.fabric8.openshift.api.model.IdentityListBuilder;
import io.fabric8.openshift.api.model.ImageListFluentImpl;
import io.fabric8.openshift.api.model.ImageListBuilder;
import io.fabric8.openshift.api.model.ImageStreamListFluentImpl;
import io.fabric8.openshift.api.model.ImageStreamListBuilder;
import io.fabric8.openshift.api.model.ImageStreamTagListFluentImpl;
import io.fabric8.openshift.api.model.ImageStreamTagListBuilder;
import io.fabric8.kubernetes.api.model.extensions.IngressFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.IngressBuilder;
import io.fabric8.kubernetes.api.model.extensions.IngressListFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.IngressListBuilder;
import io.fabric8.kubernetes.api.model.extensions.JobFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.JobBuilder;
import io.fabric8.kubernetes.api.model.extensions.JobListFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.JobListBuilder;
import io.fabric8.openshift.api.model.LocalSubjectAccessReviewFluentImpl;
import io.fabric8.openshift.api.model.LocalSubjectAccessReviewBuilder;
import io.fabric8.openshift.api.model.OAuthAccessTokenFluentImpl;
import io.fabric8.openshift.api.model.OAuthAccessTokenBuilder;
import io.fabric8.openshift.api.model.OAuthAccessTokenListFluentImpl;
import io.fabric8.openshift.api.model.OAuthAccessTokenListBuilder;
import io.fabric8.openshift.api.model.OAuthAuthorizeTokenFluentImpl;
import io.fabric8.openshift.api.model.OAuthAuthorizeTokenBuilder;
import io.fabric8.openshift.api.model.OAuthAuthorizeTokenListFluentImpl;
import io.fabric8.openshift.api.model.OAuthAuthorizeTokenListBuilder;
import io.fabric8.openshift.api.model.OAuthClientFluentImpl;
import io.fabric8.openshift.api.model.OAuthClientBuilder;
import io.fabric8.openshift.api.model.OAuthClientAuthorizationFluentImpl;
import io.fabric8.openshift.api.model.OAuthClientAuthorizationBuilder;
import io.fabric8.openshift.api.model.OAuthClientAuthorizationListFluentImpl;
import io.fabric8.openshift.api.model.OAuthClientAuthorizationListBuilder;
import io.fabric8.openshift.api.model.OAuthClientListFluentImpl;
import io.fabric8.openshift.api.model.OAuthClientListBuilder;
import io.fabric8.openshift.api.model.PolicyFluentImpl;
import io.fabric8.openshift.api.model.PolicyBuilder;
import io.fabric8.openshift.api.model.PolicyBindingFluentImpl;
import io.fabric8.openshift.api.model.PolicyBindingBuilder;
import io.fabric8.openshift.api.model.PolicyBindingListFluentImpl;
import io.fabric8.openshift.api.model.PolicyBindingListBuilder;
import io.fabric8.openshift.api.model.PolicyListFluentImpl;
import io.fabric8.openshift.api.model.PolicyListBuilder;
import io.fabric8.openshift.api.model.ProjectFluentImpl;
import io.fabric8.openshift.api.model.ProjectBuilder;
import io.fabric8.openshift.api.model.ProjectListFluentImpl;
import io.fabric8.openshift.api.model.ProjectListBuilder;
import io.fabric8.openshift.api.model.ProjectRequestFluentImpl;
import io.fabric8.openshift.api.model.ProjectRequestBuilder;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import java.lang.Override;
import com.fasterxml.jackson.databind.JsonDeserializer;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetBuilder;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetListFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetListBuilder;
import io.fabric8.openshift.api.model.RoleFluentImpl;
import io.fabric8.openshift.api.model.RoleBuilder;
import io.fabric8.openshift.api.model.RoleBindingFluentImpl;
import io.fabric8.openshift.api.model.RoleBindingBuilder;
import io.fabric8.openshift.api.model.RoleBindingListFluentImpl;
import io.fabric8.openshift.api.model.RoleBindingListBuilder;
import io.fabric8.openshift.api.model.RoleListFluentImpl;
import io.fabric8.openshift.api.model.RoleListBuilder;
import io.fabric8.openshift.api.model.RouteListFluentImpl;
import io.fabric8.openshift.api.model.RouteListBuilder;
import io.fabric8.kubernetes.api.model.extensions.ScaleFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.ScaleBuilder;
import io.fabric8.openshift.api.model.SubjectAccessReviewFluentImpl;
import io.fabric8.openshift.api.model.SubjectAccessReviewBuilder;
import io.fabric8.openshift.api.model.SubjectAccessReviewResponseFluentImpl;
import io.fabric8.openshift.api.model.SubjectAccessReviewResponseBuilder;
import io.fabric8.openshift.api.model.TagEventFluentImpl;
import io.fabric8.openshift.api.model.TagEventBuilder;
import io.fabric8.openshift.api.model.TemplateFluentImpl;
import io.fabric8.openshift.api.model.TemplateBuilder;
import io.fabric8.openshift.api.model.TemplateListFluentImpl;
import io.fabric8.openshift.api.model.TemplateListBuilder;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceBuilder;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceListFluentImpl;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceListBuilder;
import io.fabric8.openshift.api.model.UserFluentImpl;
import io.fabric8.openshift.api.model.UserBuilder;
import io.fabric8.openshift.api.model.UserListFluentImpl;
import io.fabric8.openshift.api.model.UserListBuilder;

public class KubeSchemaFluentImpl<A extends KubeSchemaFluent<A>> extends BaseFluent<A> implements KubeSchemaFluent<A>{

    private VisitableBuilder<? extends BaseKubernetesList,?> BaseKubernetesList;
    private VisitableBuilder<? extends Binding,?> Binding;
    private VisitableBuilder<? extends BuildConfigList,?> BuildConfigList;
    private VisitableBuilder<? extends BuildList,?> BuildList;
    private VisitableBuilder<? extends BuildRequest,?> BuildRequest;
    private VisitableBuilder<? extends ClusterPolicy,?> ClusterPolicy;
    private VisitableBuilder<? extends ClusterPolicyBinding,?> ClusterPolicyBinding;
    private VisitableBuilder<? extends ClusterPolicyBindingList,?> ClusterPolicyBindingList;
    private VisitableBuilder<? extends ClusterPolicyList,?> ClusterPolicyList;
    private VisitableBuilder<? extends ClusterRoleBinding,?> ClusterRoleBinding;
    private VisitableBuilder<? extends ClusterRoleBindingList,?> ClusterRoleBindingList;
    private VisitableBuilder<? extends ComponentStatusList,?> ComponentStatusList;
    private VisitableBuilder<? extends Config,?> Config;
    private VisitableBuilder<? extends ConfigMap,?> ConfigMap;
    private VisitableBuilder<? extends ConfigMapList,?> ConfigMapList;
    private VisitableBuilder<? extends ContainerStatus,?> ContainerStatus;
    private VisitableBuilder<? extends DaemonSet,?> DaemonSet;
    private VisitableBuilder<? extends DaemonSetList,?> DaemonSetList;
    private VisitableBuilder<? extends DeleteOptions,?> DeleteOptions;
    private VisitableBuilder<? extends Deployment,?> Deployment;
    private VisitableBuilder<? extends DeploymentConfigList,?> DeploymentConfigList;
    private VisitableBuilder<? extends DeploymentList,?> DeploymentList;
    private VisitableBuilder<? extends DeploymentRollback,?> DeploymentRollback;
    private VisitableBuilder<? extends Endpoints,?> Endpoints;
    private VisitableBuilder<? extends EndpointsList,?> EndpointsList;
    private VisitableBuilder<? extends EnvVar,?> EnvVar;
    private VisitableBuilder<? extends EventList,?> EventList;
    private VisitableBuilder<? extends Group,?> Group;
    private VisitableBuilder<? extends GroupList,?> GroupList;
    private VisitableBuilder<? extends HorizontalPodAutoscaler,?> HorizontalPodAutoscaler;
    private VisitableBuilder<? extends HorizontalPodAutoscalerList,?> HorizontalPodAutoscalerList;
    private VisitableBuilder<? extends Identity,?> Identity;
    private VisitableBuilder<? extends IdentityList,?> IdentityList;
    private VisitableBuilder<? extends ImageList,?> ImageList;
    private VisitableBuilder<? extends ImageStreamList,?> ImageStreamList;
    private VisitableBuilder<? extends ImageStreamTagList,?> ImageStreamTagList;
    private VisitableBuilder<? extends Ingress,?> Ingress;
    private VisitableBuilder<? extends IngressList,?> IngressList;
    private VisitableBuilder<? extends Job,?> Job;
    private VisitableBuilder<? extends JobList,?> JobList;
    private VisitableBuilder<? extends LimitRangeList,?> LimitRangeList;
    private VisitableBuilder<? extends ListMeta,?> ListMeta;
    private VisitableBuilder<? extends LocalSubjectAccessReview,?> LocalSubjectAccessReview;
    private VisitableBuilder<? extends Namespace,?> Namespace;
    private VisitableBuilder<? extends NamespaceList,?> NamespaceList;
    private VisitableBuilder<? extends Node,?> Node;
    private VisitableBuilder<? extends NodeList,?> NodeList;
    private VisitableBuilder<? extends OAuthAccessToken,?> OAuthAccessToken;
    private VisitableBuilder<? extends OAuthAccessTokenList,?> OAuthAccessTokenList;
    private VisitableBuilder<? extends OAuthAuthorizeToken,?> OAuthAuthorizeToken;
    private VisitableBuilder<? extends OAuthAuthorizeTokenList,?> OAuthAuthorizeTokenList;
    private VisitableBuilder<? extends OAuthClient,?> OAuthClient;
    private VisitableBuilder<? extends OAuthClientAuthorization,?> OAuthClientAuthorization;
    private VisitableBuilder<? extends OAuthClientAuthorizationList,?> OAuthClientAuthorizationList;
    private VisitableBuilder<? extends OAuthClientList,?> OAuthClientList;
    private VisitableBuilder<? extends ObjectMeta,?> ObjectMeta;
    private Patch Patch;
    private VisitableBuilder<? extends PersistentVolume,?> PersistentVolume;
    private VisitableBuilder<? extends PersistentVolumeClaim,?> PersistentVolumeClaim;
    private VisitableBuilder<? extends PersistentVolumeClaimList,?> PersistentVolumeClaimList;
    private VisitableBuilder<? extends PersistentVolumeList,?> PersistentVolumeList;
    private VisitableBuilder<? extends PodList,?> PodList;
    private VisitableBuilder<? extends PodTemplateList,?> PodTemplateList;
    private VisitableBuilder<? extends Policy,?> Policy;
    private VisitableBuilder<? extends PolicyBinding,?> PolicyBinding;
    private VisitableBuilder<? extends PolicyBindingList,?> PolicyBindingList;
    private VisitableBuilder<? extends PolicyList,?> PolicyList;
    private VisitableBuilder<? extends Project,?> Project;
    private VisitableBuilder<? extends ProjectList,?> ProjectList;
    private VisitableBuilder<? extends ProjectRequest,?> ProjectRequest;
    private VisitableBuilder<? extends Quantity,?> Quantity;
    private VisitableBuilder<? extends ReplicaSet,?> ReplicaSet;
    private VisitableBuilder<? extends ReplicaSetList,?> ReplicaSetList;
    private VisitableBuilder<? extends ReplicationControllerList,?> ReplicationControllerList;
    private VisitableBuilder<? extends ResourceQuota,?> ResourceQuota;
    private VisitableBuilder<? extends ResourceQuotaList,?> ResourceQuotaList;
    private VisitableBuilder<? extends Role,?> Role;
    private VisitableBuilder<? extends RoleBinding,?> RoleBinding;
    private VisitableBuilder<? extends RoleBindingList,?> RoleBindingList;
    private VisitableBuilder<? extends RoleList,?> RoleList;
    private VisitableBuilder<? extends RootPaths,?> RootPaths;
    private VisitableBuilder<? extends RouteList,?> RouteList;
    private VisitableBuilder<? extends Scale,?> Scale;
    private VisitableBuilder<? extends Secret,?> Secret;
    private VisitableBuilder<? extends SecretList,?> SecretList;
    private VisitableBuilder<? extends SecurityContextConstraints,?> SecurityContextConstraints;
    private VisitableBuilder<? extends SecurityContextConstraintsList,?> SecurityContextConstraintsList;
    private VisitableBuilder<? extends ServiceAccount,?> ServiceAccount;
    private VisitableBuilder<? extends ServiceAccountList,?> ServiceAccountList;
    private VisitableBuilder<? extends ServiceList,?> ServiceList;
    private VisitableBuilder<? extends Status,?> Status;
    private VisitableBuilder<? extends SubjectAccessReview,?> SubjectAccessReview;
    private VisitableBuilder<? extends SubjectAccessReviewResponse,?> SubjectAccessReviewResponse;
    private VisitableBuilder<? extends TagEvent,?> TagEvent;
    private VisitableBuilder<? extends Template,?> Template;
    private VisitableBuilder<? extends TemplateList,?> TemplateList;
    private VisitableBuilder<? extends ThirdPartyResource,?> ThirdPartyResource;
    private VisitableBuilder<? extends ThirdPartyResourceList,?> ThirdPartyResourceList;
    private VisitableBuilder<? extends User,?> User;
    private VisitableBuilder<? extends UserList,?> UserList;
    private VisitableBuilder<? extends WatchEvent,?> WatchEvent;

    public KubeSchemaFluentImpl(){
    }
    public KubeSchemaFluentImpl(KubeSchema instance){
            this.withBaseKubernetesList(instance.getBaseKubernetesList()); 
            this.withBinding(instance.getBinding()); 
            this.withBuildConfigList(instance.getBuildConfigList()); 
            this.withBuildList(instance.getBuildList()); 
            this.withBuildRequest(instance.getBuildRequest()); 
            this.withClusterPolicy(instance.getClusterPolicy()); 
            this.withClusterPolicyBinding(instance.getClusterPolicyBinding()); 
            this.withClusterPolicyBindingList(instance.getClusterPolicyBindingList()); 
            this.withClusterPolicyList(instance.getClusterPolicyList()); 
            this.withClusterRoleBinding(instance.getClusterRoleBinding()); 
            this.withClusterRoleBindingList(instance.getClusterRoleBindingList()); 
            this.withComponentStatusList(instance.getComponentStatusList()); 
            this.withConfig(instance.getConfig()); 
            this.withConfigMap(instance.getConfigMap()); 
            this.withConfigMapList(instance.getConfigMapList()); 
            this.withContainerStatus(instance.getContainerStatus()); 
            this.withDaemonSet(instance.getDaemonSet()); 
            this.withDaemonSetList(instance.getDaemonSetList()); 
            this.withDeleteOptions(instance.getDeleteOptions()); 
            this.withDeployment(instance.getDeployment()); 
            this.withDeploymentConfigList(instance.getDeploymentConfigList()); 
            this.withDeploymentList(instance.getDeploymentList()); 
            this.withDeploymentRollback(instance.getDeploymentRollback()); 
            this.withEndpoints(instance.getEndpoints()); 
            this.withEndpointsList(instance.getEndpointsList()); 
            this.withEnvVar(instance.getEnvVar()); 
            this.withEventList(instance.getEventList()); 
            this.withGroup(instance.getGroup()); 
            this.withGroupList(instance.getGroupList()); 
            this.withHorizontalPodAutoscaler(instance.getHorizontalPodAutoscaler()); 
            this.withHorizontalPodAutoscalerList(instance.getHorizontalPodAutoscalerList()); 
            this.withIdentity(instance.getIdentity()); 
            this.withIdentityList(instance.getIdentityList()); 
            this.withImageList(instance.getImageList()); 
            this.withImageStreamList(instance.getImageStreamList()); 
            this.withImageStreamTagList(instance.getImageStreamTagList()); 
            this.withIngress(instance.getIngress()); 
            this.withIngressList(instance.getIngressList()); 
            this.withJob(instance.getJob()); 
            this.withJobList(instance.getJobList()); 
            this.withLimitRangeList(instance.getLimitRangeList()); 
            this.withListMeta(instance.getListMeta()); 
            this.withLocalSubjectAccessReview(instance.getLocalSubjectAccessReview()); 
            this.withNamespace(instance.getNamespace()); 
            this.withNamespaceList(instance.getNamespaceList()); 
            this.withNode(instance.getNode()); 
            this.withNodeList(instance.getNodeList()); 
            this.withOAuthAccessToken(instance.getOAuthAccessToken()); 
            this.withOAuthAccessTokenList(instance.getOAuthAccessTokenList()); 
            this.withOAuthAuthorizeToken(instance.getOAuthAuthorizeToken()); 
            this.withOAuthAuthorizeTokenList(instance.getOAuthAuthorizeTokenList()); 
            this.withOAuthClient(instance.getOAuthClient()); 
            this.withOAuthClientAuthorization(instance.getOAuthClientAuthorization()); 
            this.withOAuthClientAuthorizationList(instance.getOAuthClientAuthorizationList()); 
            this.withOAuthClientList(instance.getOAuthClientList()); 
            this.withObjectMeta(instance.getObjectMeta()); 
            this.withPatch(instance.getPatch()); 
            this.withPersistentVolume(instance.getPersistentVolume()); 
            this.withPersistentVolumeClaim(instance.getPersistentVolumeClaim()); 
            this.withPersistentVolumeClaimList(instance.getPersistentVolumeClaimList()); 
            this.withPersistentVolumeList(instance.getPersistentVolumeList()); 
            this.withPodList(instance.getPodList()); 
            this.withPodTemplateList(instance.getPodTemplateList()); 
            this.withPolicy(instance.getPolicy()); 
            this.withPolicyBinding(instance.getPolicyBinding()); 
            this.withPolicyBindingList(instance.getPolicyBindingList()); 
            this.withPolicyList(instance.getPolicyList()); 
            this.withProject(instance.getProject()); 
            this.withProjectList(instance.getProjectList()); 
            this.withProjectRequest(instance.getProjectRequest()); 
            this.withQuantity(instance.getQuantity()); 
            this.withReplicaSet(instance.getReplicaSet()); 
            this.withReplicaSetList(instance.getReplicaSetList()); 
            this.withReplicationControllerList(instance.getReplicationControllerList()); 
            this.withResourceQuota(instance.getResourceQuota()); 
            this.withResourceQuotaList(instance.getResourceQuotaList()); 
            this.withRole(instance.getRole()); 
            this.withRoleBinding(instance.getRoleBinding()); 
            this.withRoleBindingList(instance.getRoleBindingList()); 
            this.withRoleList(instance.getRoleList()); 
            this.withRootPaths(instance.getRootPaths()); 
            this.withRouteList(instance.getRouteList()); 
            this.withScale(instance.getScale()); 
            this.withSecret(instance.getSecret()); 
            this.withSecretList(instance.getSecretList()); 
            this.withSecurityContextConstraints(instance.getSecurityContextConstraints()); 
            this.withSecurityContextConstraintsList(instance.getSecurityContextConstraintsList()); 
            this.withServiceAccount(instance.getServiceAccount()); 
            this.withServiceAccountList(instance.getServiceAccountList()); 
            this.withServiceList(instance.getServiceList()); 
            this.withStatus(instance.getStatus()); 
            this.withSubjectAccessReview(instance.getSubjectAccessReview()); 
            this.withSubjectAccessReviewResponse(instance.getSubjectAccessReviewResponse()); 
            this.withTagEvent(instance.getTagEvent()); 
            this.withTemplate(instance.getTemplate()); 
            this.withTemplateList(instance.getTemplateList()); 
            this.withThirdPartyResource(instance.getThirdPartyResource()); 
            this.withThirdPartyResourceList(instance.getThirdPartyResourceList()); 
            this.withUser(instance.getUser()); 
            this.withUserList(instance.getUserList()); 
            this.withWatchEvent(instance.getWatchEvent()); 
    }

    public BaseKubernetesList getBaseKubernetesList(){
            return this.BaseKubernetesList!=null?this.BaseKubernetesList.build():null;
    }

    public A withBaseKubernetesList(BaseKubernetesList BaseKubernetesList){
            if (BaseKubernetesList!=null){ this.BaseKubernetesList= new BaseKubernetesListBuilder(BaseKubernetesList); _visitables.add(this.BaseKubernetesList);} return (A) this;
    }

    public KubeSchemaFluent.BaseKubernetesListNested<A> withNewBaseKubernetesList(){
            return new BaseKubernetesListNestedImpl();
    }

    public KubeSchemaFluent.BaseKubernetesListNested<A> withNewBaseKubernetesListLike(BaseKubernetesList item){
            return new BaseKubernetesListNestedImpl(item);
    }

    public KubeSchemaFluent.BaseKubernetesListNested<A> editBaseKubernetesList(){
            return withNewBaseKubernetesListLike(getBaseKubernetesList());
    }

    public Binding getBinding(){
            return this.Binding!=null?this.Binding.build():null;
    }

    public A withBinding(Binding Binding){
            if (Binding!=null){ this.Binding= new BindingBuilder(Binding); _visitables.add(this.Binding);} return (A) this;
    }

    public KubeSchemaFluent.BindingNested<A> withNewBinding(){
            return new BindingNestedImpl();
    }

    public KubeSchemaFluent.BindingNested<A> withNewBindingLike(Binding item){
            return new BindingNestedImpl(item);
    }

    public KubeSchemaFluent.BindingNested<A> editBinding(){
            return withNewBindingLike(getBinding());
    }

    public BuildConfigList getBuildConfigList(){
            return this.BuildConfigList!=null?this.BuildConfigList.build():null;
    }

    public A withBuildConfigList(BuildConfigList BuildConfigList){
            if (BuildConfigList!=null){ this.BuildConfigList= new BuildConfigListBuilder(BuildConfigList); _visitables.add(this.BuildConfigList);} return (A) this;
    }

    public KubeSchemaFluent.BuildConfigListNested<A> withNewBuildConfigList(){
            return new BuildConfigListNestedImpl();
    }

    public KubeSchemaFluent.BuildConfigListNested<A> withNewBuildConfigListLike(BuildConfigList item){
            return new BuildConfigListNestedImpl(item);
    }

    public KubeSchemaFluent.BuildConfigListNested<A> editBuildConfigList(){
            return withNewBuildConfigListLike(getBuildConfigList());
    }

    public BuildList getBuildList(){
            return this.BuildList!=null?this.BuildList.build():null;
    }

    public A withBuildList(BuildList BuildList){
            if (BuildList!=null){ this.BuildList= new BuildListBuilder(BuildList); _visitables.add(this.BuildList);} return (A) this;
    }

    public KubeSchemaFluent.BuildListNested<A> withNewBuildList(){
            return new BuildListNestedImpl();
    }

    public KubeSchemaFluent.BuildListNested<A> withNewBuildListLike(BuildList item){
            return new BuildListNestedImpl(item);
    }

    public KubeSchemaFluent.BuildListNested<A> editBuildList(){
            return withNewBuildListLike(getBuildList());
    }

    public BuildRequest getBuildRequest(){
            return this.BuildRequest!=null?this.BuildRequest.build():null;
    }

    public A withBuildRequest(BuildRequest BuildRequest){
            if (BuildRequest!=null){ this.BuildRequest= new BuildRequestBuilder(BuildRequest); _visitables.add(this.BuildRequest);} return (A) this;
    }

    public KubeSchemaFluent.BuildRequestNested<A> withNewBuildRequest(){
            return new BuildRequestNestedImpl();
    }

    public KubeSchemaFluent.BuildRequestNested<A> withNewBuildRequestLike(BuildRequest item){
            return new BuildRequestNestedImpl(item);
    }

    public KubeSchemaFluent.BuildRequestNested<A> editBuildRequest(){
            return withNewBuildRequestLike(getBuildRequest());
    }

    public ClusterPolicy getClusterPolicy(){
            return this.ClusterPolicy!=null?this.ClusterPolicy.build():null;
    }

    public A withClusterPolicy(ClusterPolicy ClusterPolicy){
            if (ClusterPolicy!=null){ this.ClusterPolicy= new ClusterPolicyBuilder(ClusterPolicy); _visitables.add(this.ClusterPolicy);} return (A) this;
    }

    public KubeSchemaFluent.ClusterPolicyNested<A> withNewClusterPolicy(){
            return new ClusterPolicyNestedImpl();
    }

    public KubeSchemaFluent.ClusterPolicyNested<A> withNewClusterPolicyLike(ClusterPolicy item){
            return new ClusterPolicyNestedImpl(item);
    }

    public KubeSchemaFluent.ClusterPolicyNested<A> editClusterPolicy(){
            return withNewClusterPolicyLike(getClusterPolicy());
    }

    public ClusterPolicyBinding getClusterPolicyBinding(){
            return this.ClusterPolicyBinding!=null?this.ClusterPolicyBinding.build():null;
    }

    public A withClusterPolicyBinding(ClusterPolicyBinding ClusterPolicyBinding){
            if (ClusterPolicyBinding!=null){ this.ClusterPolicyBinding= new ClusterPolicyBindingBuilder(ClusterPolicyBinding); _visitables.add(this.ClusterPolicyBinding);} return (A) this;
    }

    public KubeSchemaFluent.ClusterPolicyBindingNested<A> withNewClusterPolicyBinding(){
            return new ClusterPolicyBindingNestedImpl();
    }

    public KubeSchemaFluent.ClusterPolicyBindingNested<A> withNewClusterPolicyBindingLike(ClusterPolicyBinding item){
            return new ClusterPolicyBindingNestedImpl(item);
    }

    public KubeSchemaFluent.ClusterPolicyBindingNested<A> editClusterPolicyBinding(){
            return withNewClusterPolicyBindingLike(getClusterPolicyBinding());
    }

    public ClusterPolicyBindingList getClusterPolicyBindingList(){
            return this.ClusterPolicyBindingList!=null?this.ClusterPolicyBindingList.build():null;
    }

    public A withClusterPolicyBindingList(ClusterPolicyBindingList ClusterPolicyBindingList){
            if (ClusterPolicyBindingList!=null){ this.ClusterPolicyBindingList= new ClusterPolicyBindingListBuilder(ClusterPolicyBindingList); _visitables.add(this.ClusterPolicyBindingList);} return (A) this;
    }

    public KubeSchemaFluent.ClusterPolicyBindingListNested<A> withNewClusterPolicyBindingList(){
            return new ClusterPolicyBindingListNestedImpl();
    }

    public KubeSchemaFluent.ClusterPolicyBindingListNested<A> withNewClusterPolicyBindingListLike(ClusterPolicyBindingList item){
            return new ClusterPolicyBindingListNestedImpl(item);
    }

    public KubeSchemaFluent.ClusterPolicyBindingListNested<A> editClusterPolicyBindingList(){
            return withNewClusterPolicyBindingListLike(getClusterPolicyBindingList());
    }

    public ClusterPolicyList getClusterPolicyList(){
            return this.ClusterPolicyList!=null?this.ClusterPolicyList.build():null;
    }

    public A withClusterPolicyList(ClusterPolicyList ClusterPolicyList){
            if (ClusterPolicyList!=null){ this.ClusterPolicyList= new ClusterPolicyListBuilder(ClusterPolicyList); _visitables.add(this.ClusterPolicyList);} return (A) this;
    }

    public KubeSchemaFluent.ClusterPolicyListNested<A> withNewClusterPolicyList(){
            return new ClusterPolicyListNestedImpl();
    }

    public KubeSchemaFluent.ClusterPolicyListNested<A> withNewClusterPolicyListLike(ClusterPolicyList item){
            return new ClusterPolicyListNestedImpl(item);
    }

    public KubeSchemaFluent.ClusterPolicyListNested<A> editClusterPolicyList(){
            return withNewClusterPolicyListLike(getClusterPolicyList());
    }

    public ClusterRoleBinding getClusterRoleBinding(){
            return this.ClusterRoleBinding!=null?this.ClusterRoleBinding.build():null;
    }

    public A withClusterRoleBinding(ClusterRoleBinding ClusterRoleBinding){
            if (ClusterRoleBinding!=null){ this.ClusterRoleBinding= new ClusterRoleBindingBuilder(ClusterRoleBinding); _visitables.add(this.ClusterRoleBinding);} return (A) this;
    }

    public KubeSchemaFluent.ClusterRoleBindingNested<A> withNewClusterRoleBinding(){
            return new ClusterRoleBindingNestedImpl();
    }

    public KubeSchemaFluent.ClusterRoleBindingNested<A> withNewClusterRoleBindingLike(ClusterRoleBinding item){
            return new ClusterRoleBindingNestedImpl(item);
    }

    public KubeSchemaFluent.ClusterRoleBindingNested<A> editClusterRoleBinding(){
            return withNewClusterRoleBindingLike(getClusterRoleBinding());
    }

    public ClusterRoleBindingList getClusterRoleBindingList(){
            return this.ClusterRoleBindingList!=null?this.ClusterRoleBindingList.build():null;
    }

    public A withClusterRoleBindingList(ClusterRoleBindingList ClusterRoleBindingList){
            if (ClusterRoleBindingList!=null){ this.ClusterRoleBindingList= new ClusterRoleBindingListBuilder(ClusterRoleBindingList); _visitables.add(this.ClusterRoleBindingList);} return (A) this;
    }

    public KubeSchemaFluent.ClusterRoleBindingListNested<A> withNewClusterRoleBindingList(){
            return new ClusterRoleBindingListNestedImpl();
    }

    public KubeSchemaFluent.ClusterRoleBindingListNested<A> withNewClusterRoleBindingListLike(ClusterRoleBindingList item){
            return new ClusterRoleBindingListNestedImpl(item);
    }

    public KubeSchemaFluent.ClusterRoleBindingListNested<A> editClusterRoleBindingList(){
            return withNewClusterRoleBindingListLike(getClusterRoleBindingList());
    }

    public ComponentStatusList getComponentStatusList(){
            return this.ComponentStatusList!=null?this.ComponentStatusList.build():null;
    }

    public A withComponentStatusList(ComponentStatusList ComponentStatusList){
            if (ComponentStatusList!=null){ this.ComponentStatusList= new ComponentStatusListBuilder(ComponentStatusList); _visitables.add(this.ComponentStatusList);} return (A) this;
    }

    public KubeSchemaFluent.ComponentStatusListNested<A> withNewComponentStatusList(){
            return new ComponentStatusListNestedImpl();
    }

    public KubeSchemaFluent.ComponentStatusListNested<A> withNewComponentStatusListLike(ComponentStatusList item){
            return new ComponentStatusListNestedImpl(item);
    }

    public KubeSchemaFluent.ComponentStatusListNested<A> editComponentStatusList(){
            return withNewComponentStatusListLike(getComponentStatusList());
    }

    public Config getConfig(){
            return this.Config!=null?this.Config.build():null;
    }

    public A withConfig(Config Config){
            if (Config!=null){ this.Config= new ConfigBuilder(Config); _visitables.add(this.Config);} return (A) this;
    }

    public KubeSchemaFluent.ConfigNested<A> withNewConfig(){
            return new ConfigNestedImpl();
    }

    public KubeSchemaFluent.ConfigNested<A> withNewConfigLike(Config item){
            return new ConfigNestedImpl(item);
    }

    public KubeSchemaFluent.ConfigNested<A> editConfig(){
            return withNewConfigLike(getConfig());
    }

    public ConfigMap getConfigMap(){
            return this.ConfigMap!=null?this.ConfigMap.build():null;
    }

    public A withConfigMap(ConfigMap ConfigMap){
            if (ConfigMap!=null){ this.ConfigMap= new ConfigMapBuilder(ConfigMap); _visitables.add(this.ConfigMap);} return (A) this;
    }

    public KubeSchemaFluent.ConfigMapNested<A> withNewConfigMap(){
            return new ConfigMapNestedImpl();
    }

    public KubeSchemaFluent.ConfigMapNested<A> withNewConfigMapLike(ConfigMap item){
            return new ConfigMapNestedImpl(item);
    }

    public KubeSchemaFluent.ConfigMapNested<A> editConfigMap(){
            return withNewConfigMapLike(getConfigMap());
    }

    public ConfigMapList getConfigMapList(){
            return this.ConfigMapList!=null?this.ConfigMapList.build():null;
    }

    public A withConfigMapList(ConfigMapList ConfigMapList){
            if (ConfigMapList!=null){ this.ConfigMapList= new ConfigMapListBuilder(ConfigMapList); _visitables.add(this.ConfigMapList);} return (A) this;
    }

    public KubeSchemaFluent.ConfigMapListNested<A> withNewConfigMapList(){
            return new ConfigMapListNestedImpl();
    }

    public KubeSchemaFluent.ConfigMapListNested<A> withNewConfigMapListLike(ConfigMapList item){
            return new ConfigMapListNestedImpl(item);
    }

    public KubeSchemaFluent.ConfigMapListNested<A> editConfigMapList(){
            return withNewConfigMapListLike(getConfigMapList());
    }

    public ContainerStatus getContainerStatus(){
            return this.ContainerStatus!=null?this.ContainerStatus.build():null;
    }

    public A withContainerStatus(ContainerStatus ContainerStatus){
            if (ContainerStatus!=null){ this.ContainerStatus= new ContainerStatusBuilder(ContainerStatus); _visitables.add(this.ContainerStatus);} return (A) this;
    }

    public KubeSchemaFluent.ContainerStatusNested<A> withNewContainerStatus(){
            return new ContainerStatusNestedImpl();
    }

    public KubeSchemaFluent.ContainerStatusNested<A> withNewContainerStatusLike(ContainerStatus item){
            return new ContainerStatusNestedImpl(item);
    }

    public KubeSchemaFluent.ContainerStatusNested<A> editContainerStatus(){
            return withNewContainerStatusLike(getContainerStatus());
    }

    public DaemonSet getDaemonSet(){
            return this.DaemonSet!=null?this.DaemonSet.build():null;
    }

    public A withDaemonSet(DaemonSet DaemonSet){
            if (DaemonSet!=null){ this.DaemonSet= new DaemonSetBuilder(DaemonSet); _visitables.add(this.DaemonSet);} return (A) this;
    }

    public KubeSchemaFluent.DaemonSetNested<A> withNewDaemonSet(){
            return new DaemonSetNestedImpl();
    }

    public KubeSchemaFluent.DaemonSetNested<A> withNewDaemonSetLike(DaemonSet item){
            return new DaemonSetNestedImpl(item);
    }

    public KubeSchemaFluent.DaemonSetNested<A> editDaemonSet(){
            return withNewDaemonSetLike(getDaemonSet());
    }

    public DaemonSetList getDaemonSetList(){
            return this.DaemonSetList!=null?this.DaemonSetList.build():null;
    }

    public A withDaemonSetList(DaemonSetList DaemonSetList){
            if (DaemonSetList!=null){ this.DaemonSetList= new DaemonSetListBuilder(DaemonSetList); _visitables.add(this.DaemonSetList);} return (A) this;
    }

    public KubeSchemaFluent.DaemonSetListNested<A> withNewDaemonSetList(){
            return new DaemonSetListNestedImpl();
    }

    public KubeSchemaFluent.DaemonSetListNested<A> withNewDaemonSetListLike(DaemonSetList item){
            return new DaemonSetListNestedImpl(item);
    }

    public KubeSchemaFluent.DaemonSetListNested<A> editDaemonSetList(){
            return withNewDaemonSetListLike(getDaemonSetList());
    }

    public DeleteOptions getDeleteOptions(){
            return this.DeleteOptions!=null?this.DeleteOptions.build():null;
    }

    public A withDeleteOptions(DeleteOptions DeleteOptions){
            if (DeleteOptions!=null){ this.DeleteOptions= new DeleteOptionsBuilder(DeleteOptions); _visitables.add(this.DeleteOptions);} return (A) this;
    }

    public KubeSchemaFluent.DeleteOptionsNested<A> withNewDeleteOptions(){
            return new DeleteOptionsNestedImpl();
    }

    public KubeSchemaFluent.DeleteOptionsNested<A> withNewDeleteOptionsLike(DeleteOptions item){
            return new DeleteOptionsNestedImpl(item);
    }

    public KubeSchemaFluent.DeleteOptionsNested<A> editDeleteOptions(){
            return withNewDeleteOptionsLike(getDeleteOptions());
    }

    public Deployment getDeployment(){
            return this.Deployment!=null?this.Deployment.build():null;
    }

    public A withDeployment(Deployment Deployment){
            if (Deployment!=null){ this.Deployment= new DeploymentBuilder(Deployment); _visitables.add(this.Deployment);} return (A) this;
    }

    public KubeSchemaFluent.DeploymentNested<A> withNewDeployment(){
            return new DeploymentNestedImpl();
    }

    public KubeSchemaFluent.DeploymentNested<A> withNewDeploymentLike(Deployment item){
            return new DeploymentNestedImpl(item);
    }

    public KubeSchemaFluent.DeploymentNested<A> editDeployment(){
            return withNewDeploymentLike(getDeployment());
    }

    public DeploymentConfigList getDeploymentConfigList(){
            return this.DeploymentConfigList!=null?this.DeploymentConfigList.build():null;
    }

    public A withDeploymentConfigList(DeploymentConfigList DeploymentConfigList){
            if (DeploymentConfigList!=null){ this.DeploymentConfigList= new DeploymentConfigListBuilder(DeploymentConfigList); _visitables.add(this.DeploymentConfigList);} return (A) this;
    }

    public KubeSchemaFluent.DeploymentConfigListNested<A> withNewDeploymentConfigList(){
            return new DeploymentConfigListNestedImpl();
    }

    public KubeSchemaFluent.DeploymentConfigListNested<A> withNewDeploymentConfigListLike(DeploymentConfigList item){
            return new DeploymentConfigListNestedImpl(item);
    }

    public KubeSchemaFluent.DeploymentConfigListNested<A> editDeploymentConfigList(){
            return withNewDeploymentConfigListLike(getDeploymentConfigList());
    }

    public DeploymentList getDeploymentList(){
            return this.DeploymentList!=null?this.DeploymentList.build():null;
    }

    public A withDeploymentList(DeploymentList DeploymentList){
            if (DeploymentList!=null){ this.DeploymentList= new DeploymentListBuilder(DeploymentList); _visitables.add(this.DeploymentList);} return (A) this;
    }

    public KubeSchemaFluent.DeploymentListNested<A> withNewDeploymentList(){
            return new DeploymentListNestedImpl();
    }

    public KubeSchemaFluent.DeploymentListNested<A> withNewDeploymentListLike(DeploymentList item){
            return new DeploymentListNestedImpl(item);
    }

    public KubeSchemaFluent.DeploymentListNested<A> editDeploymentList(){
            return withNewDeploymentListLike(getDeploymentList());
    }

    public DeploymentRollback getDeploymentRollback(){
            return this.DeploymentRollback!=null?this.DeploymentRollback.build():null;
    }

    public A withDeploymentRollback(DeploymentRollback DeploymentRollback){
            if (DeploymentRollback!=null){ this.DeploymentRollback= new DeploymentRollbackBuilder(DeploymentRollback); _visitables.add(this.DeploymentRollback);} return (A) this;
    }

    public KubeSchemaFluent.DeploymentRollbackNested<A> withNewDeploymentRollback(){
            return new DeploymentRollbackNestedImpl();
    }

    public KubeSchemaFluent.DeploymentRollbackNested<A> withNewDeploymentRollbackLike(DeploymentRollback item){
            return new DeploymentRollbackNestedImpl(item);
    }

    public KubeSchemaFluent.DeploymentRollbackNested<A> editDeploymentRollback(){
            return withNewDeploymentRollbackLike(getDeploymentRollback());
    }

    public Endpoints getEndpoints(){
            return this.Endpoints!=null?this.Endpoints.build():null;
    }

    public A withEndpoints(Endpoints Endpoints){
            if (Endpoints!=null){ this.Endpoints= new EndpointsBuilder(Endpoints); _visitables.add(this.Endpoints);} return (A) this;
    }

    public KubeSchemaFluent.EndpointsNested<A> withNewEndpoints(){
            return new EndpointsNestedImpl();
    }

    public KubeSchemaFluent.EndpointsNested<A> withNewEndpointsLike(Endpoints item){
            return new EndpointsNestedImpl(item);
    }

    public KubeSchemaFluent.EndpointsNested<A> editEndpoints(){
            return withNewEndpointsLike(getEndpoints());
    }

    public EndpointsList getEndpointsList(){
            return this.EndpointsList!=null?this.EndpointsList.build():null;
    }

    public A withEndpointsList(EndpointsList EndpointsList){
            if (EndpointsList!=null){ this.EndpointsList= new EndpointsListBuilder(EndpointsList); _visitables.add(this.EndpointsList);} return (A) this;
    }

    public KubeSchemaFluent.EndpointsListNested<A> withNewEndpointsList(){
            return new EndpointsListNestedImpl();
    }

    public KubeSchemaFluent.EndpointsListNested<A> withNewEndpointsListLike(EndpointsList item){
            return new EndpointsListNestedImpl(item);
    }

    public KubeSchemaFluent.EndpointsListNested<A> editEndpointsList(){
            return withNewEndpointsListLike(getEndpointsList());
    }

    public EnvVar getEnvVar(){
            return this.EnvVar!=null?this.EnvVar.build():null;
    }

    public A withEnvVar(EnvVar EnvVar){
            if (EnvVar!=null){ this.EnvVar= new EnvVarBuilder(EnvVar); _visitables.add(this.EnvVar);} return (A) this;
    }

    public KubeSchemaFluent.EnvVarNested<A> withNewEnvVar(){
            return new EnvVarNestedImpl();
    }

    public KubeSchemaFluent.EnvVarNested<A> withNewEnvVarLike(EnvVar item){
            return new EnvVarNestedImpl(item);
    }

    public KubeSchemaFluent.EnvVarNested<A> editEnvVar(){
            return withNewEnvVarLike(getEnvVar());
    }

    public EventList getEventList(){
            return this.EventList!=null?this.EventList.build():null;
    }

    public A withEventList(EventList EventList){
            if (EventList!=null){ this.EventList= new EventListBuilder(EventList); _visitables.add(this.EventList);} return (A) this;
    }

    public KubeSchemaFluent.EventListNested<A> withNewEventList(){
            return new EventListNestedImpl();
    }

    public KubeSchemaFluent.EventListNested<A> withNewEventListLike(EventList item){
            return new EventListNestedImpl(item);
    }

    public KubeSchemaFluent.EventListNested<A> editEventList(){
            return withNewEventListLike(getEventList());
    }

    public Group getGroup(){
            return this.Group!=null?this.Group.build():null;
    }

    public A withGroup(Group Group){
            if (Group!=null){ this.Group= new GroupBuilder(Group); _visitables.add(this.Group);} return (A) this;
    }

    public KubeSchemaFluent.GroupNested<A> withNewGroup(){
            return new GroupNestedImpl();
    }

    public KubeSchemaFluent.GroupNested<A> withNewGroupLike(Group item){
            return new GroupNestedImpl(item);
    }

    public KubeSchemaFluent.GroupNested<A> editGroup(){
            return withNewGroupLike(getGroup());
    }

    public GroupList getGroupList(){
            return this.GroupList!=null?this.GroupList.build():null;
    }

    public A withGroupList(GroupList GroupList){
            if (GroupList!=null){ this.GroupList= new GroupListBuilder(GroupList); _visitables.add(this.GroupList);} return (A) this;
    }

    public KubeSchemaFluent.GroupListNested<A> withNewGroupList(){
            return new GroupListNestedImpl();
    }

    public KubeSchemaFluent.GroupListNested<A> withNewGroupListLike(GroupList item){
            return new GroupListNestedImpl(item);
    }

    public KubeSchemaFluent.GroupListNested<A> editGroupList(){
            return withNewGroupListLike(getGroupList());
    }

    public HorizontalPodAutoscaler getHorizontalPodAutoscaler(){
            return this.HorizontalPodAutoscaler!=null?this.HorizontalPodAutoscaler.build():null;
    }

    public A withHorizontalPodAutoscaler(HorizontalPodAutoscaler HorizontalPodAutoscaler){
            if (HorizontalPodAutoscaler!=null){ this.HorizontalPodAutoscaler= new HorizontalPodAutoscalerBuilder(HorizontalPodAutoscaler); _visitables.add(this.HorizontalPodAutoscaler);} return (A) this;
    }

    public KubeSchemaFluent.HorizontalPodAutoscalerNested<A> withNewHorizontalPodAutoscaler(){
            return new HorizontalPodAutoscalerNestedImpl();
    }

    public KubeSchemaFluent.HorizontalPodAutoscalerNested<A> withNewHorizontalPodAutoscalerLike(HorizontalPodAutoscaler item){
            return new HorizontalPodAutoscalerNestedImpl(item);
    }

    public KubeSchemaFluent.HorizontalPodAutoscalerNested<A> editHorizontalPodAutoscaler(){
            return withNewHorizontalPodAutoscalerLike(getHorizontalPodAutoscaler());
    }

    public HorizontalPodAutoscalerList getHorizontalPodAutoscalerList(){
            return this.HorizontalPodAutoscalerList!=null?this.HorizontalPodAutoscalerList.build():null;
    }

    public A withHorizontalPodAutoscalerList(HorizontalPodAutoscalerList HorizontalPodAutoscalerList){
            if (HorizontalPodAutoscalerList!=null){ this.HorizontalPodAutoscalerList= new HorizontalPodAutoscalerListBuilder(HorizontalPodAutoscalerList); _visitables.add(this.HorizontalPodAutoscalerList);} return (A) this;
    }

    public KubeSchemaFluent.HorizontalPodAutoscalerListNested<A> withNewHorizontalPodAutoscalerList(){
            return new HorizontalPodAutoscalerListNestedImpl();
    }

    public KubeSchemaFluent.HorizontalPodAutoscalerListNested<A> withNewHorizontalPodAutoscalerListLike(HorizontalPodAutoscalerList item){
            return new HorizontalPodAutoscalerListNestedImpl(item);
    }

    public KubeSchemaFluent.HorizontalPodAutoscalerListNested<A> editHorizontalPodAutoscalerList(){
            return withNewHorizontalPodAutoscalerListLike(getHorizontalPodAutoscalerList());
    }

    public Identity getIdentity(){
            return this.Identity!=null?this.Identity.build():null;
    }

    public A withIdentity(Identity Identity){
            if (Identity!=null){ this.Identity= new IdentityBuilder(Identity); _visitables.add(this.Identity);} return (A) this;
    }

    public KubeSchemaFluent.IdentityNested<A> withNewIdentity(){
            return new IdentityNestedImpl();
    }

    public KubeSchemaFluent.IdentityNested<A> withNewIdentityLike(Identity item){
            return new IdentityNestedImpl(item);
    }

    public KubeSchemaFluent.IdentityNested<A> editIdentity(){
            return withNewIdentityLike(getIdentity());
    }

    public IdentityList getIdentityList(){
            return this.IdentityList!=null?this.IdentityList.build():null;
    }

    public A withIdentityList(IdentityList IdentityList){
            if (IdentityList!=null){ this.IdentityList= new IdentityListBuilder(IdentityList); _visitables.add(this.IdentityList);} return (A) this;
    }

    public KubeSchemaFluent.IdentityListNested<A> withNewIdentityList(){
            return new IdentityListNestedImpl();
    }

    public KubeSchemaFluent.IdentityListNested<A> withNewIdentityListLike(IdentityList item){
            return new IdentityListNestedImpl(item);
    }

    public KubeSchemaFluent.IdentityListNested<A> editIdentityList(){
            return withNewIdentityListLike(getIdentityList());
    }

    public ImageList getImageList(){
            return this.ImageList!=null?this.ImageList.build():null;
    }

    public A withImageList(ImageList ImageList){
            if (ImageList!=null){ this.ImageList= new ImageListBuilder(ImageList); _visitables.add(this.ImageList);} return (A) this;
    }

    public KubeSchemaFluent.ImageListNested<A> withNewImageList(){
            return new ImageListNestedImpl();
    }

    public KubeSchemaFluent.ImageListNested<A> withNewImageListLike(ImageList item){
            return new ImageListNestedImpl(item);
    }

    public KubeSchemaFluent.ImageListNested<A> editImageList(){
            return withNewImageListLike(getImageList());
    }

    public ImageStreamList getImageStreamList(){
            return this.ImageStreamList!=null?this.ImageStreamList.build():null;
    }

    public A withImageStreamList(ImageStreamList ImageStreamList){
            if (ImageStreamList!=null){ this.ImageStreamList= new ImageStreamListBuilder(ImageStreamList); _visitables.add(this.ImageStreamList);} return (A) this;
    }

    public KubeSchemaFluent.ImageStreamListNested<A> withNewImageStreamList(){
            return new ImageStreamListNestedImpl();
    }

    public KubeSchemaFluent.ImageStreamListNested<A> withNewImageStreamListLike(ImageStreamList item){
            return new ImageStreamListNestedImpl(item);
    }

    public KubeSchemaFluent.ImageStreamListNested<A> editImageStreamList(){
            return withNewImageStreamListLike(getImageStreamList());
    }

    public ImageStreamTagList getImageStreamTagList(){
            return this.ImageStreamTagList!=null?this.ImageStreamTagList.build():null;
    }

    public A withImageStreamTagList(ImageStreamTagList ImageStreamTagList){
            if (ImageStreamTagList!=null){ this.ImageStreamTagList= new ImageStreamTagListBuilder(ImageStreamTagList); _visitables.add(this.ImageStreamTagList);} return (A) this;
    }

    public KubeSchemaFluent.ImageStreamTagListNested<A> withNewImageStreamTagList(){
            return new ImageStreamTagListNestedImpl();
    }

    public KubeSchemaFluent.ImageStreamTagListNested<A> withNewImageStreamTagListLike(ImageStreamTagList item){
            return new ImageStreamTagListNestedImpl(item);
    }

    public KubeSchemaFluent.ImageStreamTagListNested<A> editImageStreamTagList(){
            return withNewImageStreamTagListLike(getImageStreamTagList());
    }

    public Ingress getIngress(){
            return this.Ingress!=null?this.Ingress.build():null;
    }

    public A withIngress(Ingress Ingress){
            if (Ingress!=null){ this.Ingress= new IngressBuilder(Ingress); _visitables.add(this.Ingress);} return (A) this;
    }

    public KubeSchemaFluent.IngressNested<A> withNewIngress(){
            return new IngressNestedImpl();
    }

    public KubeSchemaFluent.IngressNested<A> withNewIngressLike(Ingress item){
            return new IngressNestedImpl(item);
    }

    public KubeSchemaFluent.IngressNested<A> editIngress(){
            return withNewIngressLike(getIngress());
    }

    public IngressList getIngressList(){
            return this.IngressList!=null?this.IngressList.build():null;
    }

    public A withIngressList(IngressList IngressList){
            if (IngressList!=null){ this.IngressList= new IngressListBuilder(IngressList); _visitables.add(this.IngressList);} return (A) this;
    }

    public KubeSchemaFluent.IngressListNested<A> withNewIngressList(){
            return new IngressListNestedImpl();
    }

    public KubeSchemaFluent.IngressListNested<A> withNewIngressListLike(IngressList item){
            return new IngressListNestedImpl(item);
    }

    public KubeSchemaFluent.IngressListNested<A> editIngressList(){
            return withNewIngressListLike(getIngressList());
    }

    public Job getJob(){
            return this.Job!=null?this.Job.build():null;
    }

    public A withJob(Job Job){
            if (Job!=null){ this.Job= new JobBuilder(Job); _visitables.add(this.Job);} return (A) this;
    }

    public KubeSchemaFluent.JobNested<A> withNewJob(){
            return new JobNestedImpl();
    }

    public KubeSchemaFluent.JobNested<A> withNewJobLike(Job item){
            return new JobNestedImpl(item);
    }

    public KubeSchemaFluent.JobNested<A> editJob(){
            return withNewJobLike(getJob());
    }

    public JobList getJobList(){
            return this.JobList!=null?this.JobList.build():null;
    }

    public A withJobList(JobList JobList){
            if (JobList!=null){ this.JobList= new JobListBuilder(JobList); _visitables.add(this.JobList);} return (A) this;
    }

    public KubeSchemaFluent.JobListNested<A> withNewJobList(){
            return new JobListNestedImpl();
    }

    public KubeSchemaFluent.JobListNested<A> withNewJobListLike(JobList item){
            return new JobListNestedImpl(item);
    }

    public KubeSchemaFluent.JobListNested<A> editJobList(){
            return withNewJobListLike(getJobList());
    }

    public LimitRangeList getLimitRangeList(){
            return this.LimitRangeList!=null?this.LimitRangeList.build():null;
    }

    public A withLimitRangeList(LimitRangeList LimitRangeList){
            if (LimitRangeList!=null){ this.LimitRangeList= new LimitRangeListBuilder(LimitRangeList); _visitables.add(this.LimitRangeList);} return (A) this;
    }

    public KubeSchemaFluent.LimitRangeListNested<A> withNewLimitRangeList(){
            return new LimitRangeListNestedImpl();
    }

    public KubeSchemaFluent.LimitRangeListNested<A> withNewLimitRangeListLike(LimitRangeList item){
            return new LimitRangeListNestedImpl(item);
    }

    public KubeSchemaFluent.LimitRangeListNested<A> editLimitRangeList(){
            return withNewLimitRangeListLike(getLimitRangeList());
    }

    public ListMeta getListMeta(){
            return this.ListMeta!=null?this.ListMeta.build():null;
    }

    public A withListMeta(ListMeta ListMeta){
            if (ListMeta!=null){ this.ListMeta= new ListMetaBuilder(ListMeta); _visitables.add(this.ListMeta);} return (A) this;
    }

    public KubeSchemaFluent.ListMetaNested<A> withNewListMeta(){
            return new ListMetaNestedImpl();
    }

    public KubeSchemaFluent.ListMetaNested<A> withNewListMetaLike(ListMeta item){
            return new ListMetaNestedImpl(item);
    }

    public KubeSchemaFluent.ListMetaNested<A> editListMeta(){
            return withNewListMetaLike(getListMeta());
    }

    public A withNewListMeta(String resourceVersion,String selfLink){
            return (A)withListMeta(new ListMeta(resourceVersion, selfLink));
    }

    public LocalSubjectAccessReview getLocalSubjectAccessReview(){
            return this.LocalSubjectAccessReview!=null?this.LocalSubjectAccessReview.build():null;
    }

    public A withLocalSubjectAccessReview(LocalSubjectAccessReview LocalSubjectAccessReview){
            if (LocalSubjectAccessReview!=null){ this.LocalSubjectAccessReview= new LocalSubjectAccessReviewBuilder(LocalSubjectAccessReview); _visitables.add(this.LocalSubjectAccessReview);} return (A) this;
    }

    public KubeSchemaFluent.LocalSubjectAccessReviewNested<A> withNewLocalSubjectAccessReview(){
            return new LocalSubjectAccessReviewNestedImpl();
    }

    public KubeSchemaFluent.LocalSubjectAccessReviewNested<A> withNewLocalSubjectAccessReviewLike(LocalSubjectAccessReview item){
            return new LocalSubjectAccessReviewNestedImpl(item);
    }

    public KubeSchemaFluent.LocalSubjectAccessReviewNested<A> editLocalSubjectAccessReview(){
            return withNewLocalSubjectAccessReviewLike(getLocalSubjectAccessReview());
    }

    public Namespace getNamespace(){
            return this.Namespace!=null?this.Namespace.build():null;
    }

    public A withNamespace(Namespace Namespace){
            if (Namespace!=null){ this.Namespace= new NamespaceBuilder(Namespace); _visitables.add(this.Namespace);} return (A) this;
    }

    public KubeSchemaFluent.NamespaceNested<A> withNewNamespace(){
            return new NamespaceNestedImpl();
    }

    public KubeSchemaFluent.NamespaceNested<A> withNewNamespaceLike(Namespace item){
            return new NamespaceNestedImpl(item);
    }

    public KubeSchemaFluent.NamespaceNested<A> editNamespace(){
            return withNewNamespaceLike(getNamespace());
    }

    public NamespaceList getNamespaceList(){
            return this.NamespaceList!=null?this.NamespaceList.build():null;
    }

    public A withNamespaceList(NamespaceList NamespaceList){
            if (NamespaceList!=null){ this.NamespaceList= new NamespaceListBuilder(NamespaceList); _visitables.add(this.NamespaceList);} return (A) this;
    }

    public KubeSchemaFluent.NamespaceListNested<A> withNewNamespaceList(){
            return new NamespaceListNestedImpl();
    }

    public KubeSchemaFluent.NamespaceListNested<A> withNewNamespaceListLike(NamespaceList item){
            return new NamespaceListNestedImpl(item);
    }

    public KubeSchemaFluent.NamespaceListNested<A> editNamespaceList(){
            return withNewNamespaceListLike(getNamespaceList());
    }

    public Node getNode(){
            return this.Node!=null?this.Node.build():null;
    }

    public A withNode(Node Node){
            if (Node!=null){ this.Node= new NodeBuilder(Node); _visitables.add(this.Node);} return (A) this;
    }

    public KubeSchemaFluent.NodeNested<A> withNewNode(){
            return new NodeNestedImpl();
    }

    public KubeSchemaFluent.NodeNested<A> withNewNodeLike(Node item){
            return new NodeNestedImpl(item);
    }

    public KubeSchemaFluent.NodeNested<A> editNode(){
            return withNewNodeLike(getNode());
    }

    public NodeList getNodeList(){
            return this.NodeList!=null?this.NodeList.build():null;
    }

    public A withNodeList(NodeList NodeList){
            if (NodeList!=null){ this.NodeList= new NodeListBuilder(NodeList); _visitables.add(this.NodeList);} return (A) this;
    }

    public KubeSchemaFluent.NodeListNested<A> withNewNodeList(){
            return new NodeListNestedImpl();
    }

    public KubeSchemaFluent.NodeListNested<A> withNewNodeListLike(NodeList item){
            return new NodeListNestedImpl(item);
    }

    public KubeSchemaFluent.NodeListNested<A> editNodeList(){
            return withNewNodeListLike(getNodeList());
    }

    public OAuthAccessToken getOAuthAccessToken(){
            return this.OAuthAccessToken!=null?this.OAuthAccessToken.build():null;
    }

    public A withOAuthAccessToken(OAuthAccessToken OAuthAccessToken){
            if (OAuthAccessToken!=null){ this.OAuthAccessToken= new OAuthAccessTokenBuilder(OAuthAccessToken); _visitables.add(this.OAuthAccessToken);} return (A) this;
    }

    public KubeSchemaFluent.OAuthAccessTokenNested<A> withNewOAuthAccessToken(){
            return new OAuthAccessTokenNestedImpl();
    }

    public KubeSchemaFluent.OAuthAccessTokenNested<A> withNewOAuthAccessTokenLike(OAuthAccessToken item){
            return new OAuthAccessTokenNestedImpl(item);
    }

    public KubeSchemaFluent.OAuthAccessTokenNested<A> editOAuthAccessToken(){
            return withNewOAuthAccessTokenLike(getOAuthAccessToken());
    }

    public OAuthAccessTokenList getOAuthAccessTokenList(){
            return this.OAuthAccessTokenList!=null?this.OAuthAccessTokenList.build():null;
    }

    public A withOAuthAccessTokenList(OAuthAccessTokenList OAuthAccessTokenList){
            if (OAuthAccessTokenList!=null){ this.OAuthAccessTokenList= new OAuthAccessTokenListBuilder(OAuthAccessTokenList); _visitables.add(this.OAuthAccessTokenList);} return (A) this;
    }

    public KubeSchemaFluent.OAuthAccessTokenListNested<A> withNewOAuthAccessTokenList(){
            return new OAuthAccessTokenListNestedImpl();
    }

    public KubeSchemaFluent.OAuthAccessTokenListNested<A> withNewOAuthAccessTokenListLike(OAuthAccessTokenList item){
            return new OAuthAccessTokenListNestedImpl(item);
    }

    public KubeSchemaFluent.OAuthAccessTokenListNested<A> editOAuthAccessTokenList(){
            return withNewOAuthAccessTokenListLike(getOAuthAccessTokenList());
    }

    public OAuthAuthorizeToken getOAuthAuthorizeToken(){
            return this.OAuthAuthorizeToken!=null?this.OAuthAuthorizeToken.build():null;
    }

    public A withOAuthAuthorizeToken(OAuthAuthorizeToken OAuthAuthorizeToken){
            if (OAuthAuthorizeToken!=null){ this.OAuthAuthorizeToken= new OAuthAuthorizeTokenBuilder(OAuthAuthorizeToken); _visitables.add(this.OAuthAuthorizeToken);} return (A) this;
    }

    public KubeSchemaFluent.OAuthAuthorizeTokenNested<A> withNewOAuthAuthorizeToken(){
            return new OAuthAuthorizeTokenNestedImpl();
    }

    public KubeSchemaFluent.OAuthAuthorizeTokenNested<A> withNewOAuthAuthorizeTokenLike(OAuthAuthorizeToken item){
            return new OAuthAuthorizeTokenNestedImpl(item);
    }

    public KubeSchemaFluent.OAuthAuthorizeTokenNested<A> editOAuthAuthorizeToken(){
            return withNewOAuthAuthorizeTokenLike(getOAuthAuthorizeToken());
    }

    public OAuthAuthorizeTokenList getOAuthAuthorizeTokenList(){
            return this.OAuthAuthorizeTokenList!=null?this.OAuthAuthorizeTokenList.build():null;
    }

    public A withOAuthAuthorizeTokenList(OAuthAuthorizeTokenList OAuthAuthorizeTokenList){
            if (OAuthAuthorizeTokenList!=null){ this.OAuthAuthorizeTokenList= new OAuthAuthorizeTokenListBuilder(OAuthAuthorizeTokenList); _visitables.add(this.OAuthAuthorizeTokenList);} return (A) this;
    }

    public KubeSchemaFluent.OAuthAuthorizeTokenListNested<A> withNewOAuthAuthorizeTokenList(){
            return new OAuthAuthorizeTokenListNestedImpl();
    }

    public KubeSchemaFluent.OAuthAuthorizeTokenListNested<A> withNewOAuthAuthorizeTokenListLike(OAuthAuthorizeTokenList item){
            return new OAuthAuthorizeTokenListNestedImpl(item);
    }

    public KubeSchemaFluent.OAuthAuthorizeTokenListNested<A> editOAuthAuthorizeTokenList(){
            return withNewOAuthAuthorizeTokenListLike(getOAuthAuthorizeTokenList());
    }

    public OAuthClient getOAuthClient(){
            return this.OAuthClient!=null?this.OAuthClient.build():null;
    }

    public A withOAuthClient(OAuthClient OAuthClient){
            if (OAuthClient!=null){ this.OAuthClient= new OAuthClientBuilder(OAuthClient); _visitables.add(this.OAuthClient);} return (A) this;
    }

    public KubeSchemaFluent.OAuthClientNested<A> withNewOAuthClient(){
            return new OAuthClientNestedImpl();
    }

    public KubeSchemaFluent.OAuthClientNested<A> withNewOAuthClientLike(OAuthClient item){
            return new OAuthClientNestedImpl(item);
    }

    public KubeSchemaFluent.OAuthClientNested<A> editOAuthClient(){
            return withNewOAuthClientLike(getOAuthClient());
    }

    public OAuthClientAuthorization getOAuthClientAuthorization(){
            return this.OAuthClientAuthorization!=null?this.OAuthClientAuthorization.build():null;
    }

    public A withOAuthClientAuthorization(OAuthClientAuthorization OAuthClientAuthorization){
            if (OAuthClientAuthorization!=null){ this.OAuthClientAuthorization= new OAuthClientAuthorizationBuilder(OAuthClientAuthorization); _visitables.add(this.OAuthClientAuthorization);} return (A) this;
    }

    public KubeSchemaFluent.OAuthClientAuthorizationNested<A> withNewOAuthClientAuthorization(){
            return new OAuthClientAuthorizationNestedImpl();
    }

    public KubeSchemaFluent.OAuthClientAuthorizationNested<A> withNewOAuthClientAuthorizationLike(OAuthClientAuthorization item){
            return new OAuthClientAuthorizationNestedImpl(item);
    }

    public KubeSchemaFluent.OAuthClientAuthorizationNested<A> editOAuthClientAuthorization(){
            return withNewOAuthClientAuthorizationLike(getOAuthClientAuthorization());
    }

    public OAuthClientAuthorizationList getOAuthClientAuthorizationList(){
            return this.OAuthClientAuthorizationList!=null?this.OAuthClientAuthorizationList.build():null;
    }

    public A withOAuthClientAuthorizationList(OAuthClientAuthorizationList OAuthClientAuthorizationList){
            if (OAuthClientAuthorizationList!=null){ this.OAuthClientAuthorizationList= new OAuthClientAuthorizationListBuilder(OAuthClientAuthorizationList); _visitables.add(this.OAuthClientAuthorizationList);} return (A) this;
    }

    public KubeSchemaFluent.OAuthClientAuthorizationListNested<A> withNewOAuthClientAuthorizationList(){
            return new OAuthClientAuthorizationListNestedImpl();
    }

    public KubeSchemaFluent.OAuthClientAuthorizationListNested<A> withNewOAuthClientAuthorizationListLike(OAuthClientAuthorizationList item){
            return new OAuthClientAuthorizationListNestedImpl(item);
    }

    public KubeSchemaFluent.OAuthClientAuthorizationListNested<A> editOAuthClientAuthorizationList(){
            return withNewOAuthClientAuthorizationListLike(getOAuthClientAuthorizationList());
    }

    public OAuthClientList getOAuthClientList(){
            return this.OAuthClientList!=null?this.OAuthClientList.build():null;
    }

    public A withOAuthClientList(OAuthClientList OAuthClientList){
            if (OAuthClientList!=null){ this.OAuthClientList= new OAuthClientListBuilder(OAuthClientList); _visitables.add(this.OAuthClientList);} return (A) this;
    }

    public KubeSchemaFluent.OAuthClientListNested<A> withNewOAuthClientList(){
            return new OAuthClientListNestedImpl();
    }

    public KubeSchemaFluent.OAuthClientListNested<A> withNewOAuthClientListLike(OAuthClientList item){
            return new OAuthClientListNestedImpl(item);
    }

    public KubeSchemaFluent.OAuthClientListNested<A> editOAuthClientList(){
            return withNewOAuthClientListLike(getOAuthClientList());
    }

    public ObjectMeta getObjectMeta(){
            return this.ObjectMeta!=null?this.ObjectMeta.build():null;
    }

    public A withObjectMeta(ObjectMeta ObjectMeta){
            if (ObjectMeta!=null){ this.ObjectMeta= new ObjectMetaBuilder(ObjectMeta); _visitables.add(this.ObjectMeta);} return (A) this;
    }

    public KubeSchemaFluent.ObjectMetaNested<A> withNewObjectMeta(){
            return new ObjectMetaNestedImpl();
    }

    public KubeSchemaFluent.ObjectMetaNested<A> withNewObjectMetaLike(ObjectMeta item){
            return new ObjectMetaNestedImpl(item);
    }

    public KubeSchemaFluent.ObjectMetaNested<A> editObjectMeta(){
            return withNewObjectMetaLike(getObjectMeta());
    }

    public Patch getPatch(){
            return this.Patch;
    }

    public A withPatch(Patch Patch){
            this.Patch=Patch; return (A) this;
    }

    public PersistentVolume getPersistentVolume(){
            return this.PersistentVolume!=null?this.PersistentVolume.build():null;
    }

    public A withPersistentVolume(PersistentVolume PersistentVolume){
            if (PersistentVolume!=null){ this.PersistentVolume= new PersistentVolumeBuilder(PersistentVolume); _visitables.add(this.PersistentVolume);} return (A) this;
    }

    public KubeSchemaFluent.PersistentVolumeNested<A> withNewPersistentVolume(){
            return new PersistentVolumeNestedImpl();
    }

    public KubeSchemaFluent.PersistentVolumeNested<A> withNewPersistentVolumeLike(PersistentVolume item){
            return new PersistentVolumeNestedImpl(item);
    }

    public KubeSchemaFluent.PersistentVolumeNested<A> editPersistentVolume(){
            return withNewPersistentVolumeLike(getPersistentVolume());
    }

    public PersistentVolumeClaim getPersistentVolumeClaim(){
            return this.PersistentVolumeClaim!=null?this.PersistentVolumeClaim.build():null;
    }

    public A withPersistentVolumeClaim(PersistentVolumeClaim PersistentVolumeClaim){
            if (PersistentVolumeClaim!=null){ this.PersistentVolumeClaim= new PersistentVolumeClaimBuilder(PersistentVolumeClaim); _visitables.add(this.PersistentVolumeClaim);} return (A) this;
    }

    public KubeSchemaFluent.PersistentVolumeClaimNested<A> withNewPersistentVolumeClaim(){
            return new PersistentVolumeClaimNestedImpl();
    }

    public KubeSchemaFluent.PersistentVolumeClaimNested<A> withNewPersistentVolumeClaimLike(PersistentVolumeClaim item){
            return new PersistentVolumeClaimNestedImpl(item);
    }

    public KubeSchemaFluent.PersistentVolumeClaimNested<A> editPersistentVolumeClaim(){
            return withNewPersistentVolumeClaimLike(getPersistentVolumeClaim());
    }

    public PersistentVolumeClaimList getPersistentVolumeClaimList(){
            return this.PersistentVolumeClaimList!=null?this.PersistentVolumeClaimList.build():null;
    }

    public A withPersistentVolumeClaimList(PersistentVolumeClaimList PersistentVolumeClaimList){
            if (PersistentVolumeClaimList!=null){ this.PersistentVolumeClaimList= new PersistentVolumeClaimListBuilder(PersistentVolumeClaimList); _visitables.add(this.PersistentVolumeClaimList);} return (A) this;
    }

    public KubeSchemaFluent.PersistentVolumeClaimListNested<A> withNewPersistentVolumeClaimList(){
            return new PersistentVolumeClaimListNestedImpl();
    }

    public KubeSchemaFluent.PersistentVolumeClaimListNested<A> withNewPersistentVolumeClaimListLike(PersistentVolumeClaimList item){
            return new PersistentVolumeClaimListNestedImpl(item);
    }

    public KubeSchemaFluent.PersistentVolumeClaimListNested<A> editPersistentVolumeClaimList(){
            return withNewPersistentVolumeClaimListLike(getPersistentVolumeClaimList());
    }

    public PersistentVolumeList getPersistentVolumeList(){
            return this.PersistentVolumeList!=null?this.PersistentVolumeList.build():null;
    }

    public A withPersistentVolumeList(PersistentVolumeList PersistentVolumeList){
            if (PersistentVolumeList!=null){ this.PersistentVolumeList= new PersistentVolumeListBuilder(PersistentVolumeList); _visitables.add(this.PersistentVolumeList);} return (A) this;
    }

    public KubeSchemaFluent.PersistentVolumeListNested<A> withNewPersistentVolumeList(){
            return new PersistentVolumeListNestedImpl();
    }

    public KubeSchemaFluent.PersistentVolumeListNested<A> withNewPersistentVolumeListLike(PersistentVolumeList item){
            return new PersistentVolumeListNestedImpl(item);
    }

    public KubeSchemaFluent.PersistentVolumeListNested<A> editPersistentVolumeList(){
            return withNewPersistentVolumeListLike(getPersistentVolumeList());
    }

    public PodList getPodList(){
            return this.PodList!=null?this.PodList.build():null;
    }

    public A withPodList(PodList PodList){
            if (PodList!=null){ this.PodList= new PodListBuilder(PodList); _visitables.add(this.PodList);} return (A) this;
    }

    public KubeSchemaFluent.PodListNested<A> withNewPodList(){
            return new PodListNestedImpl();
    }

    public KubeSchemaFluent.PodListNested<A> withNewPodListLike(PodList item){
            return new PodListNestedImpl(item);
    }

    public KubeSchemaFluent.PodListNested<A> editPodList(){
            return withNewPodListLike(getPodList());
    }

    public PodTemplateList getPodTemplateList(){
            return this.PodTemplateList!=null?this.PodTemplateList.build():null;
    }

    public A withPodTemplateList(PodTemplateList PodTemplateList){
            if (PodTemplateList!=null){ this.PodTemplateList= new PodTemplateListBuilder(PodTemplateList); _visitables.add(this.PodTemplateList);} return (A) this;
    }

    public KubeSchemaFluent.PodTemplateListNested<A> withNewPodTemplateList(){
            return new PodTemplateListNestedImpl();
    }

    public KubeSchemaFluent.PodTemplateListNested<A> withNewPodTemplateListLike(PodTemplateList item){
            return new PodTemplateListNestedImpl(item);
    }

    public KubeSchemaFluent.PodTemplateListNested<A> editPodTemplateList(){
            return withNewPodTemplateListLike(getPodTemplateList());
    }

    public Policy getPolicy(){
            return this.Policy!=null?this.Policy.build():null;
    }

    public A withPolicy(Policy Policy){
            if (Policy!=null){ this.Policy= new PolicyBuilder(Policy); _visitables.add(this.Policy);} return (A) this;
    }

    public KubeSchemaFluent.PolicyNested<A> withNewPolicy(){
            return new PolicyNestedImpl();
    }

    public KubeSchemaFluent.PolicyNested<A> withNewPolicyLike(Policy item){
            return new PolicyNestedImpl(item);
    }

    public KubeSchemaFluent.PolicyNested<A> editPolicy(){
            return withNewPolicyLike(getPolicy());
    }

    public PolicyBinding getPolicyBinding(){
            return this.PolicyBinding!=null?this.PolicyBinding.build():null;
    }

    public A withPolicyBinding(PolicyBinding PolicyBinding){
            if (PolicyBinding!=null){ this.PolicyBinding= new PolicyBindingBuilder(PolicyBinding); _visitables.add(this.PolicyBinding);} return (A) this;
    }

    public KubeSchemaFluent.PolicyBindingNested<A> withNewPolicyBinding(){
            return new PolicyBindingNestedImpl();
    }

    public KubeSchemaFluent.PolicyBindingNested<A> withNewPolicyBindingLike(PolicyBinding item){
            return new PolicyBindingNestedImpl(item);
    }

    public KubeSchemaFluent.PolicyBindingNested<A> editPolicyBinding(){
            return withNewPolicyBindingLike(getPolicyBinding());
    }

    public PolicyBindingList getPolicyBindingList(){
            return this.PolicyBindingList!=null?this.PolicyBindingList.build():null;
    }

    public A withPolicyBindingList(PolicyBindingList PolicyBindingList){
            if (PolicyBindingList!=null){ this.PolicyBindingList= new PolicyBindingListBuilder(PolicyBindingList); _visitables.add(this.PolicyBindingList);} return (A) this;
    }

    public KubeSchemaFluent.PolicyBindingListNested<A> withNewPolicyBindingList(){
            return new PolicyBindingListNestedImpl();
    }

    public KubeSchemaFluent.PolicyBindingListNested<A> withNewPolicyBindingListLike(PolicyBindingList item){
            return new PolicyBindingListNestedImpl(item);
    }

    public KubeSchemaFluent.PolicyBindingListNested<A> editPolicyBindingList(){
            return withNewPolicyBindingListLike(getPolicyBindingList());
    }

    public PolicyList getPolicyList(){
            return this.PolicyList!=null?this.PolicyList.build():null;
    }

    public A withPolicyList(PolicyList PolicyList){
            if (PolicyList!=null){ this.PolicyList= new PolicyListBuilder(PolicyList); _visitables.add(this.PolicyList);} return (A) this;
    }

    public KubeSchemaFluent.PolicyListNested<A> withNewPolicyList(){
            return new PolicyListNestedImpl();
    }

    public KubeSchemaFluent.PolicyListNested<A> withNewPolicyListLike(PolicyList item){
            return new PolicyListNestedImpl(item);
    }

    public KubeSchemaFluent.PolicyListNested<A> editPolicyList(){
            return withNewPolicyListLike(getPolicyList());
    }

    public Project getProject(){
            return this.Project!=null?this.Project.build():null;
    }

    public A withProject(Project Project){
            if (Project!=null){ this.Project= new ProjectBuilder(Project); _visitables.add(this.Project);} return (A) this;
    }

    public KubeSchemaFluent.ProjectNested<A> withNewProject(){
            return new ProjectNestedImpl();
    }

    public KubeSchemaFluent.ProjectNested<A> withNewProjectLike(Project item){
            return new ProjectNestedImpl(item);
    }

    public KubeSchemaFluent.ProjectNested<A> editProject(){
            return withNewProjectLike(getProject());
    }

    public ProjectList getProjectList(){
            return this.ProjectList!=null?this.ProjectList.build():null;
    }

    public A withProjectList(ProjectList ProjectList){
            if (ProjectList!=null){ this.ProjectList= new ProjectListBuilder(ProjectList); _visitables.add(this.ProjectList);} return (A) this;
    }

    public KubeSchemaFluent.ProjectListNested<A> withNewProjectList(){
            return new ProjectListNestedImpl();
    }

    public KubeSchemaFluent.ProjectListNested<A> withNewProjectListLike(ProjectList item){
            return new ProjectListNestedImpl(item);
    }

    public KubeSchemaFluent.ProjectListNested<A> editProjectList(){
            return withNewProjectListLike(getProjectList());
    }

    public ProjectRequest getProjectRequest(){
            return this.ProjectRequest!=null?this.ProjectRequest.build():null;
    }

    public A withProjectRequest(ProjectRequest ProjectRequest){
            if (ProjectRequest!=null){ this.ProjectRequest= new ProjectRequestBuilder(ProjectRequest); _visitables.add(this.ProjectRequest);} return (A) this;
    }

    public KubeSchemaFluent.ProjectRequestNested<A> withNewProjectRequest(){
            return new ProjectRequestNestedImpl();
    }

    public KubeSchemaFluent.ProjectRequestNested<A> withNewProjectRequestLike(ProjectRequest item){
            return new ProjectRequestNestedImpl(item);
    }

    public KubeSchemaFluent.ProjectRequestNested<A> editProjectRequest(){
            return withNewProjectRequestLike(getProjectRequest());
    }

    public Quantity getQuantity(){
            return this.Quantity!=null?this.Quantity.build():null;
    }

    public A withQuantity(Quantity Quantity){
            if (Quantity!=null){ this.Quantity= new QuantityBuilder(Quantity); _visitables.add(this.Quantity);} return (A) this;
    }

    public KubeSchemaFluent.QuantityNested<A> withNewQuantity(){
            return new QuantityNestedImpl();
    }

    public KubeSchemaFluent.QuantityNested<A> withNewQuantityLike(Quantity item){
            return new QuantityNestedImpl(item);
    }

    public KubeSchemaFluent.QuantityNested<A> editQuantity(){
            return withNewQuantityLike(getQuantity());
    }

    public A withNewQuantity(String amount){
            return (A)withQuantity(new Quantity(amount));
    }

    public A withNewQuantity(String amount,String format){
            return (A)withQuantity(new Quantity(amount, format));
    }

    public ReplicaSet getReplicaSet(){
            return this.ReplicaSet!=null?this.ReplicaSet.build():null;
    }

    public A withReplicaSet(ReplicaSet ReplicaSet){
            if (ReplicaSet!=null){ this.ReplicaSet= new ReplicaSetBuilder(ReplicaSet); _visitables.add(this.ReplicaSet);} return (A) this;
    }

    public KubeSchemaFluent.ReplicaSetNested<A> withNewReplicaSet(){
            return new ReplicaSetNestedImpl();
    }

    public KubeSchemaFluent.ReplicaSetNested<A> withNewReplicaSetLike(ReplicaSet item){
            return new ReplicaSetNestedImpl(item);
    }

    public KubeSchemaFluent.ReplicaSetNested<A> editReplicaSet(){
            return withNewReplicaSetLike(getReplicaSet());
    }

    public ReplicaSetList getReplicaSetList(){
            return this.ReplicaSetList!=null?this.ReplicaSetList.build():null;
    }

    public A withReplicaSetList(ReplicaSetList ReplicaSetList){
            if (ReplicaSetList!=null){ this.ReplicaSetList= new ReplicaSetListBuilder(ReplicaSetList); _visitables.add(this.ReplicaSetList);} return (A) this;
    }

    public KubeSchemaFluent.ReplicaSetListNested<A> withNewReplicaSetList(){
            return new ReplicaSetListNestedImpl();
    }

    public KubeSchemaFluent.ReplicaSetListNested<A> withNewReplicaSetListLike(ReplicaSetList item){
            return new ReplicaSetListNestedImpl(item);
    }

    public KubeSchemaFluent.ReplicaSetListNested<A> editReplicaSetList(){
            return withNewReplicaSetListLike(getReplicaSetList());
    }

    public ReplicationControllerList getReplicationControllerList(){
            return this.ReplicationControllerList!=null?this.ReplicationControllerList.build():null;
    }

    public A withReplicationControllerList(ReplicationControllerList ReplicationControllerList){
            if (ReplicationControllerList!=null){ this.ReplicationControllerList= new ReplicationControllerListBuilder(ReplicationControllerList); _visitables.add(this.ReplicationControllerList);} return (A) this;
    }

    public KubeSchemaFluent.ReplicationControllerListNested<A> withNewReplicationControllerList(){
            return new ReplicationControllerListNestedImpl();
    }

    public KubeSchemaFluent.ReplicationControllerListNested<A> withNewReplicationControllerListLike(ReplicationControllerList item){
            return new ReplicationControllerListNestedImpl(item);
    }

    public KubeSchemaFluent.ReplicationControllerListNested<A> editReplicationControllerList(){
            return withNewReplicationControllerListLike(getReplicationControllerList());
    }

    public ResourceQuota getResourceQuota(){
            return this.ResourceQuota!=null?this.ResourceQuota.build():null;
    }

    public A withResourceQuota(ResourceQuota ResourceQuota){
            if (ResourceQuota!=null){ this.ResourceQuota= new ResourceQuotaBuilder(ResourceQuota); _visitables.add(this.ResourceQuota);} return (A) this;
    }

    public KubeSchemaFluent.ResourceQuotaNested<A> withNewResourceQuota(){
            return new ResourceQuotaNestedImpl();
    }

    public KubeSchemaFluent.ResourceQuotaNested<A> withNewResourceQuotaLike(ResourceQuota item){
            return new ResourceQuotaNestedImpl(item);
    }

    public KubeSchemaFluent.ResourceQuotaNested<A> editResourceQuota(){
            return withNewResourceQuotaLike(getResourceQuota());
    }

    public ResourceQuotaList getResourceQuotaList(){
            return this.ResourceQuotaList!=null?this.ResourceQuotaList.build():null;
    }

    public A withResourceQuotaList(ResourceQuotaList ResourceQuotaList){
            if (ResourceQuotaList!=null){ this.ResourceQuotaList= new ResourceQuotaListBuilder(ResourceQuotaList); _visitables.add(this.ResourceQuotaList);} return (A) this;
    }

    public KubeSchemaFluent.ResourceQuotaListNested<A> withNewResourceQuotaList(){
            return new ResourceQuotaListNestedImpl();
    }

    public KubeSchemaFluent.ResourceQuotaListNested<A> withNewResourceQuotaListLike(ResourceQuotaList item){
            return new ResourceQuotaListNestedImpl(item);
    }

    public KubeSchemaFluent.ResourceQuotaListNested<A> editResourceQuotaList(){
            return withNewResourceQuotaListLike(getResourceQuotaList());
    }

    public Role getRole(){
            return this.Role!=null?this.Role.build():null;
    }

    public A withRole(Role Role){
            if (Role!=null){ this.Role= new RoleBuilder(Role); _visitables.add(this.Role);} return (A) this;
    }

    public KubeSchemaFluent.RoleNested<A> withNewRole(){
            return new RoleNestedImpl();
    }

    public KubeSchemaFluent.RoleNested<A> withNewRoleLike(Role item){
            return new RoleNestedImpl(item);
    }

    public KubeSchemaFluent.RoleNested<A> editRole(){
            return withNewRoleLike(getRole());
    }

    public RoleBinding getRoleBinding(){
            return this.RoleBinding!=null?this.RoleBinding.build():null;
    }

    public A withRoleBinding(RoleBinding RoleBinding){
            if (RoleBinding!=null){ this.RoleBinding= new RoleBindingBuilder(RoleBinding); _visitables.add(this.RoleBinding);} return (A) this;
    }

    public KubeSchemaFluent.RoleBindingNested<A> withNewRoleBinding(){
            return new RoleBindingNestedImpl();
    }

    public KubeSchemaFluent.RoleBindingNested<A> withNewRoleBindingLike(RoleBinding item){
            return new RoleBindingNestedImpl(item);
    }

    public KubeSchemaFluent.RoleBindingNested<A> editRoleBinding(){
            return withNewRoleBindingLike(getRoleBinding());
    }

    public RoleBindingList getRoleBindingList(){
            return this.RoleBindingList!=null?this.RoleBindingList.build():null;
    }

    public A withRoleBindingList(RoleBindingList RoleBindingList){
            if (RoleBindingList!=null){ this.RoleBindingList= new RoleBindingListBuilder(RoleBindingList); _visitables.add(this.RoleBindingList);} return (A) this;
    }

    public KubeSchemaFluent.RoleBindingListNested<A> withNewRoleBindingList(){
            return new RoleBindingListNestedImpl();
    }

    public KubeSchemaFluent.RoleBindingListNested<A> withNewRoleBindingListLike(RoleBindingList item){
            return new RoleBindingListNestedImpl(item);
    }

    public KubeSchemaFluent.RoleBindingListNested<A> editRoleBindingList(){
            return withNewRoleBindingListLike(getRoleBindingList());
    }

    public RoleList getRoleList(){
            return this.RoleList!=null?this.RoleList.build():null;
    }

    public A withRoleList(RoleList RoleList){
            if (RoleList!=null){ this.RoleList= new RoleListBuilder(RoleList); _visitables.add(this.RoleList);} return (A) this;
    }

    public KubeSchemaFluent.RoleListNested<A> withNewRoleList(){
            return new RoleListNestedImpl();
    }

    public KubeSchemaFluent.RoleListNested<A> withNewRoleListLike(RoleList item){
            return new RoleListNestedImpl(item);
    }

    public KubeSchemaFluent.RoleListNested<A> editRoleList(){
            return withNewRoleListLike(getRoleList());
    }

    public RootPaths getRootPaths(){
            return this.RootPaths!=null?this.RootPaths.build():null;
    }

    public A withRootPaths(RootPaths RootPaths){
            if (RootPaths!=null){ this.RootPaths= new RootPathsBuilder(RootPaths); _visitables.add(this.RootPaths);} return (A) this;
    }

    public KubeSchemaFluent.RootPathsNested<A> withNewRootPaths(){
            return new RootPathsNestedImpl();
    }

    public KubeSchemaFluent.RootPathsNested<A> withNewRootPathsLike(RootPaths item){
            return new RootPathsNestedImpl(item);
    }

    public KubeSchemaFluent.RootPathsNested<A> editRootPaths(){
            return withNewRootPathsLike(getRootPaths());
    }

    public RouteList getRouteList(){
            return this.RouteList!=null?this.RouteList.build():null;
    }

    public A withRouteList(RouteList RouteList){
            if (RouteList!=null){ this.RouteList= new RouteListBuilder(RouteList); _visitables.add(this.RouteList);} return (A) this;
    }

    public KubeSchemaFluent.RouteListNested<A> withNewRouteList(){
            return new RouteListNestedImpl();
    }

    public KubeSchemaFluent.RouteListNested<A> withNewRouteListLike(RouteList item){
            return new RouteListNestedImpl(item);
    }

    public KubeSchemaFluent.RouteListNested<A> editRouteList(){
            return withNewRouteListLike(getRouteList());
    }

    public Scale getScale(){
            return this.Scale!=null?this.Scale.build():null;
    }

    public A withScale(Scale Scale){
            if (Scale!=null){ this.Scale= new ScaleBuilder(Scale); _visitables.add(this.Scale);} return (A) this;
    }

    public KubeSchemaFluent.ScaleNested<A> withNewScale(){
            return new ScaleNestedImpl();
    }

    public KubeSchemaFluent.ScaleNested<A> withNewScaleLike(Scale item){
            return new ScaleNestedImpl(item);
    }

    public KubeSchemaFluent.ScaleNested<A> editScale(){
            return withNewScaleLike(getScale());
    }

    public Secret getSecret(){
            return this.Secret!=null?this.Secret.build():null;
    }

    public A withSecret(Secret Secret){
            if (Secret!=null){ this.Secret= new SecretBuilder(Secret); _visitables.add(this.Secret);} return (A) this;
    }

    public KubeSchemaFluent.SecretNested<A> withNewSecret(){
            return new SecretNestedImpl();
    }

    public KubeSchemaFluent.SecretNested<A> withNewSecretLike(Secret item){
            return new SecretNestedImpl(item);
    }

    public KubeSchemaFluent.SecretNested<A> editSecret(){
            return withNewSecretLike(getSecret());
    }

    public SecretList getSecretList(){
            return this.SecretList!=null?this.SecretList.build():null;
    }

    public A withSecretList(SecretList SecretList){
            if (SecretList!=null){ this.SecretList= new SecretListBuilder(SecretList); _visitables.add(this.SecretList);} return (A) this;
    }

    public KubeSchemaFluent.SecretListNested<A> withNewSecretList(){
            return new SecretListNestedImpl();
    }

    public KubeSchemaFluent.SecretListNested<A> withNewSecretListLike(SecretList item){
            return new SecretListNestedImpl(item);
    }

    public KubeSchemaFluent.SecretListNested<A> editSecretList(){
            return withNewSecretListLike(getSecretList());
    }

    public SecurityContextConstraints getSecurityContextConstraints(){
            return this.SecurityContextConstraints!=null?this.SecurityContextConstraints.build():null;
    }

    public A withSecurityContextConstraints(SecurityContextConstraints SecurityContextConstraints){
            if (SecurityContextConstraints!=null){ this.SecurityContextConstraints= new SecurityContextConstraintsBuilder(SecurityContextConstraints); _visitables.add(this.SecurityContextConstraints);} return (A) this;
    }

    public KubeSchemaFluent.SecurityContextConstraintsNested<A> withNewSecurityContextConstraints(){
            return new SecurityContextConstraintsNestedImpl();
    }

    public KubeSchemaFluent.SecurityContextConstraintsNested<A> withNewSecurityContextConstraintsLike(SecurityContextConstraints item){
            return new SecurityContextConstraintsNestedImpl(item);
    }

    public KubeSchemaFluent.SecurityContextConstraintsNested<A> editSecurityContextConstraints(){
            return withNewSecurityContextConstraintsLike(getSecurityContextConstraints());
    }

    public SecurityContextConstraintsList getSecurityContextConstraintsList(){
            return this.SecurityContextConstraintsList!=null?this.SecurityContextConstraintsList.build():null;
    }

    public A withSecurityContextConstraintsList(SecurityContextConstraintsList SecurityContextConstraintsList){
            if (SecurityContextConstraintsList!=null){ this.SecurityContextConstraintsList= new SecurityContextConstraintsListBuilder(SecurityContextConstraintsList); _visitables.add(this.SecurityContextConstraintsList);} return (A) this;
    }

    public KubeSchemaFluent.SecurityContextConstraintsListNested<A> withNewSecurityContextConstraintsList(){
            return new SecurityContextConstraintsListNestedImpl();
    }

    public KubeSchemaFluent.SecurityContextConstraintsListNested<A> withNewSecurityContextConstraintsListLike(SecurityContextConstraintsList item){
            return new SecurityContextConstraintsListNestedImpl(item);
    }

    public KubeSchemaFluent.SecurityContextConstraintsListNested<A> editSecurityContextConstraintsList(){
            return withNewSecurityContextConstraintsListLike(getSecurityContextConstraintsList());
    }

    public ServiceAccount getServiceAccount(){
            return this.ServiceAccount!=null?this.ServiceAccount.build():null;
    }

    public A withServiceAccount(ServiceAccount ServiceAccount){
            if (ServiceAccount!=null){ this.ServiceAccount= new ServiceAccountBuilder(ServiceAccount); _visitables.add(this.ServiceAccount);} return (A) this;
    }

    public KubeSchemaFluent.ServiceAccountNested<A> withNewServiceAccount(){
            return new ServiceAccountNestedImpl();
    }

    public KubeSchemaFluent.ServiceAccountNested<A> withNewServiceAccountLike(ServiceAccount item){
            return new ServiceAccountNestedImpl(item);
    }

    public KubeSchemaFluent.ServiceAccountNested<A> editServiceAccount(){
            return withNewServiceAccountLike(getServiceAccount());
    }

    public ServiceAccountList getServiceAccountList(){
            return this.ServiceAccountList!=null?this.ServiceAccountList.build():null;
    }

    public A withServiceAccountList(ServiceAccountList ServiceAccountList){
            if (ServiceAccountList!=null){ this.ServiceAccountList= new ServiceAccountListBuilder(ServiceAccountList); _visitables.add(this.ServiceAccountList);} return (A) this;
    }

    public KubeSchemaFluent.ServiceAccountListNested<A> withNewServiceAccountList(){
            return new ServiceAccountListNestedImpl();
    }

    public KubeSchemaFluent.ServiceAccountListNested<A> withNewServiceAccountListLike(ServiceAccountList item){
            return new ServiceAccountListNestedImpl(item);
    }

    public KubeSchemaFluent.ServiceAccountListNested<A> editServiceAccountList(){
            return withNewServiceAccountListLike(getServiceAccountList());
    }

    public ServiceList getServiceList(){
            return this.ServiceList!=null?this.ServiceList.build():null;
    }

    public A withServiceList(ServiceList ServiceList){
            if (ServiceList!=null){ this.ServiceList= new ServiceListBuilder(ServiceList); _visitables.add(this.ServiceList);} return (A) this;
    }

    public KubeSchemaFluent.ServiceListNested<A> withNewServiceList(){
            return new ServiceListNestedImpl();
    }

    public KubeSchemaFluent.ServiceListNested<A> withNewServiceListLike(ServiceList item){
            return new ServiceListNestedImpl(item);
    }

    public KubeSchemaFluent.ServiceListNested<A> editServiceList(){
            return withNewServiceListLike(getServiceList());
    }

    public Status getStatus(){
            return this.Status!=null?this.Status.build():null;
    }

    public A withStatus(Status Status){
            if (Status!=null){ this.Status= new StatusBuilder(Status); _visitables.add(this.Status);} return (A) this;
    }

    public KubeSchemaFluent.StatusNested<A> withNewStatus(){
            return new StatusNestedImpl();
    }

    public KubeSchemaFluent.StatusNested<A> withNewStatusLike(Status item){
            return new StatusNestedImpl(item);
    }

    public KubeSchemaFluent.StatusNested<A> editStatus(){
            return withNewStatusLike(getStatus());
    }

    public SubjectAccessReview getSubjectAccessReview(){
            return this.SubjectAccessReview!=null?this.SubjectAccessReview.build():null;
    }

    public A withSubjectAccessReview(SubjectAccessReview SubjectAccessReview){
            if (SubjectAccessReview!=null){ this.SubjectAccessReview= new SubjectAccessReviewBuilder(SubjectAccessReview); _visitables.add(this.SubjectAccessReview);} return (A) this;
    }

    public KubeSchemaFluent.SubjectAccessReviewNested<A> withNewSubjectAccessReview(){
            return new SubjectAccessReviewNestedImpl();
    }

    public KubeSchemaFluent.SubjectAccessReviewNested<A> withNewSubjectAccessReviewLike(SubjectAccessReview item){
            return new SubjectAccessReviewNestedImpl(item);
    }

    public KubeSchemaFluent.SubjectAccessReviewNested<A> editSubjectAccessReview(){
            return withNewSubjectAccessReviewLike(getSubjectAccessReview());
    }

    public SubjectAccessReviewResponse getSubjectAccessReviewResponse(){
            return this.SubjectAccessReviewResponse!=null?this.SubjectAccessReviewResponse.build():null;
    }

    public A withSubjectAccessReviewResponse(SubjectAccessReviewResponse SubjectAccessReviewResponse){
            if (SubjectAccessReviewResponse!=null){ this.SubjectAccessReviewResponse= new SubjectAccessReviewResponseBuilder(SubjectAccessReviewResponse); _visitables.add(this.SubjectAccessReviewResponse);} return (A) this;
    }

    public KubeSchemaFluent.SubjectAccessReviewResponseNested<A> withNewSubjectAccessReviewResponse(){
            return new SubjectAccessReviewResponseNestedImpl();
    }

    public KubeSchemaFluent.SubjectAccessReviewResponseNested<A> withNewSubjectAccessReviewResponseLike(SubjectAccessReviewResponse item){
            return new SubjectAccessReviewResponseNestedImpl(item);
    }

    public KubeSchemaFluent.SubjectAccessReviewResponseNested<A> editSubjectAccessReviewResponse(){
            return withNewSubjectAccessReviewResponseLike(getSubjectAccessReviewResponse());
    }

    public TagEvent getTagEvent(){
            return this.TagEvent!=null?this.TagEvent.build():null;
    }

    public A withTagEvent(TagEvent TagEvent){
            if (TagEvent!=null){ this.TagEvent= new TagEventBuilder(TagEvent); _visitables.add(this.TagEvent);} return (A) this;
    }

    public KubeSchemaFluent.TagEventNested<A> withNewTagEvent(){
            return new TagEventNestedImpl();
    }

    public KubeSchemaFluent.TagEventNested<A> withNewTagEventLike(TagEvent item){
            return new TagEventNestedImpl(item);
    }

    public KubeSchemaFluent.TagEventNested<A> editTagEvent(){
            return withNewTagEventLike(getTagEvent());
    }

    public A withNewTagEvent(String created,String dockerImageReference,Long generation,String image){
            return (A)withTagEvent(new TagEvent(created, dockerImageReference, generation, image));
    }

    public Template getTemplate(){
            return this.Template!=null?this.Template.build():null;
    }

    public A withTemplate(Template Template){
            if (Template!=null){ this.Template= new TemplateBuilder(Template); _visitables.add(this.Template);} return (A) this;
    }

    public KubeSchemaFluent.TemplateNested<A> withNewTemplate(){
            return new TemplateNestedImpl();
    }

    public KubeSchemaFluent.TemplateNested<A> withNewTemplateLike(Template item){
            return new TemplateNestedImpl(item);
    }

    public KubeSchemaFluent.TemplateNested<A> editTemplate(){
            return withNewTemplateLike(getTemplate());
    }

    public TemplateList getTemplateList(){
            return this.TemplateList!=null?this.TemplateList.build():null;
    }

    public A withTemplateList(TemplateList TemplateList){
            if (TemplateList!=null){ this.TemplateList= new TemplateListBuilder(TemplateList); _visitables.add(this.TemplateList);} return (A) this;
    }

    public KubeSchemaFluent.TemplateListNested<A> withNewTemplateList(){
            return new TemplateListNestedImpl();
    }

    public KubeSchemaFluent.TemplateListNested<A> withNewTemplateListLike(TemplateList item){
            return new TemplateListNestedImpl(item);
    }

    public KubeSchemaFluent.TemplateListNested<A> editTemplateList(){
            return withNewTemplateListLike(getTemplateList());
    }

    public ThirdPartyResource getThirdPartyResource(){
            return this.ThirdPartyResource!=null?this.ThirdPartyResource.build():null;
    }

    public A withThirdPartyResource(ThirdPartyResource ThirdPartyResource){
            if (ThirdPartyResource!=null){ this.ThirdPartyResource= new ThirdPartyResourceBuilder(ThirdPartyResource); _visitables.add(this.ThirdPartyResource);} return (A) this;
    }

    public KubeSchemaFluent.ThirdPartyResourceNested<A> withNewThirdPartyResource(){
            return new ThirdPartyResourceNestedImpl();
    }

    public KubeSchemaFluent.ThirdPartyResourceNested<A> withNewThirdPartyResourceLike(ThirdPartyResource item){
            return new ThirdPartyResourceNestedImpl(item);
    }

    public KubeSchemaFluent.ThirdPartyResourceNested<A> editThirdPartyResource(){
            return withNewThirdPartyResourceLike(getThirdPartyResource());
    }

    public ThirdPartyResourceList getThirdPartyResourceList(){
            return this.ThirdPartyResourceList!=null?this.ThirdPartyResourceList.build():null;
    }

    public A withThirdPartyResourceList(ThirdPartyResourceList ThirdPartyResourceList){
            if (ThirdPartyResourceList!=null){ this.ThirdPartyResourceList= new ThirdPartyResourceListBuilder(ThirdPartyResourceList); _visitables.add(this.ThirdPartyResourceList);} return (A) this;
    }

    public KubeSchemaFluent.ThirdPartyResourceListNested<A> withNewThirdPartyResourceList(){
            return new ThirdPartyResourceListNestedImpl();
    }

    public KubeSchemaFluent.ThirdPartyResourceListNested<A> withNewThirdPartyResourceListLike(ThirdPartyResourceList item){
            return new ThirdPartyResourceListNestedImpl(item);
    }

    public KubeSchemaFluent.ThirdPartyResourceListNested<A> editThirdPartyResourceList(){
            return withNewThirdPartyResourceListLike(getThirdPartyResourceList());
    }

    public User getUser(){
            return this.User!=null?this.User.build():null;
    }

    public A withUser(User User){
            if (User!=null){ this.User= new UserBuilder(User); _visitables.add(this.User);} return (A) this;
    }

    public KubeSchemaFluent.UserNested<A> withNewUser(){
            return new UserNestedImpl();
    }

    public KubeSchemaFluent.UserNested<A> withNewUserLike(User item){
            return new UserNestedImpl(item);
    }

    public KubeSchemaFluent.UserNested<A> editUser(){
            return withNewUserLike(getUser());
    }

    public UserList getUserList(){
            return this.UserList!=null?this.UserList.build():null;
    }

    public A withUserList(UserList UserList){
            if (UserList!=null){ this.UserList= new UserListBuilder(UserList); _visitables.add(this.UserList);} return (A) this;
    }

    public KubeSchemaFluent.UserListNested<A> withNewUserList(){
            return new UserListNestedImpl();
    }

    public KubeSchemaFluent.UserListNested<A> withNewUserListLike(UserList item){
            return new UserListNestedImpl(item);
    }

    public KubeSchemaFluent.UserListNested<A> editUserList(){
            return withNewUserListLike(getUserList());
    }

    public WatchEvent getWatchEvent(){
            return this.WatchEvent!=null?this.WatchEvent.build():null;
    }

    public A withWatchEvent(WatchEvent WatchEvent){
            if (WatchEvent!=null){ this.WatchEvent= new WatchEventBuilder(WatchEvent); _visitables.add(this.WatchEvent);} return (A) this;
    }

    public KubeSchemaFluent.WatchEventNested<A> withNewWatchEvent(){
            return new WatchEventNestedImpl();
    }

    public KubeSchemaFluent.WatchEventNested<A> withNewWatchEventLike(WatchEvent item){
            return new WatchEventNestedImpl(item);
    }

    public KubeSchemaFluent.WatchEventNested<A> editWatchEvent(){
            return withNewWatchEventLike(getWatchEvent());
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            KubeSchemaFluentImpl that = (KubeSchemaFluentImpl) o;
            if (BaseKubernetesList != null ? !BaseKubernetesList.equals(that.BaseKubernetesList) :that.BaseKubernetesList != null) return false;
            if (Binding != null ? !Binding.equals(that.Binding) :that.Binding != null) return false;
            if (BuildConfigList != null ? !BuildConfigList.equals(that.BuildConfigList) :that.BuildConfigList != null) return false;
            if (BuildList != null ? !BuildList.equals(that.BuildList) :that.BuildList != null) return false;
            if (BuildRequest != null ? !BuildRequest.equals(that.BuildRequest) :that.BuildRequest != null) return false;
            if (ClusterPolicy != null ? !ClusterPolicy.equals(that.ClusterPolicy) :that.ClusterPolicy != null) return false;
            if (ClusterPolicyBinding != null ? !ClusterPolicyBinding.equals(that.ClusterPolicyBinding) :that.ClusterPolicyBinding != null) return false;
            if (ClusterPolicyBindingList != null ? !ClusterPolicyBindingList.equals(that.ClusterPolicyBindingList) :that.ClusterPolicyBindingList != null) return false;
            if (ClusterPolicyList != null ? !ClusterPolicyList.equals(that.ClusterPolicyList) :that.ClusterPolicyList != null) return false;
            if (ClusterRoleBinding != null ? !ClusterRoleBinding.equals(that.ClusterRoleBinding) :that.ClusterRoleBinding != null) return false;
            if (ClusterRoleBindingList != null ? !ClusterRoleBindingList.equals(that.ClusterRoleBindingList) :that.ClusterRoleBindingList != null) return false;
            if (ComponentStatusList != null ? !ComponentStatusList.equals(that.ComponentStatusList) :that.ComponentStatusList != null) return false;
            if (Config != null ? !Config.equals(that.Config) :that.Config != null) return false;
            if (ConfigMap != null ? !ConfigMap.equals(that.ConfigMap) :that.ConfigMap != null) return false;
            if (ConfigMapList != null ? !ConfigMapList.equals(that.ConfigMapList) :that.ConfigMapList != null) return false;
            if (ContainerStatus != null ? !ContainerStatus.equals(that.ContainerStatus) :that.ContainerStatus != null) return false;
            if (DaemonSet != null ? !DaemonSet.equals(that.DaemonSet) :that.DaemonSet != null) return false;
            if (DaemonSetList != null ? !DaemonSetList.equals(that.DaemonSetList) :that.DaemonSetList != null) return false;
            if (DeleteOptions != null ? !DeleteOptions.equals(that.DeleteOptions) :that.DeleteOptions != null) return false;
            if (Deployment != null ? !Deployment.equals(that.Deployment) :that.Deployment != null) return false;
            if (DeploymentConfigList != null ? !DeploymentConfigList.equals(that.DeploymentConfigList) :that.DeploymentConfigList != null) return false;
            if (DeploymentList != null ? !DeploymentList.equals(that.DeploymentList) :that.DeploymentList != null) return false;
            if (DeploymentRollback != null ? !DeploymentRollback.equals(that.DeploymentRollback) :that.DeploymentRollback != null) return false;
            if (Endpoints != null ? !Endpoints.equals(that.Endpoints) :that.Endpoints != null) return false;
            if (EndpointsList != null ? !EndpointsList.equals(that.EndpointsList) :that.EndpointsList != null) return false;
            if (EnvVar != null ? !EnvVar.equals(that.EnvVar) :that.EnvVar != null) return false;
            if (EventList != null ? !EventList.equals(that.EventList) :that.EventList != null) return false;
            if (Group != null ? !Group.equals(that.Group) :that.Group != null) return false;
            if (GroupList != null ? !GroupList.equals(that.GroupList) :that.GroupList != null) return false;
            if (HorizontalPodAutoscaler != null ? !HorizontalPodAutoscaler.equals(that.HorizontalPodAutoscaler) :that.HorizontalPodAutoscaler != null) return false;
            if (HorizontalPodAutoscalerList != null ? !HorizontalPodAutoscalerList.equals(that.HorizontalPodAutoscalerList) :that.HorizontalPodAutoscalerList != null) return false;
            if (Identity != null ? !Identity.equals(that.Identity) :that.Identity != null) return false;
            if (IdentityList != null ? !IdentityList.equals(that.IdentityList) :that.IdentityList != null) return false;
            if (ImageList != null ? !ImageList.equals(that.ImageList) :that.ImageList != null) return false;
            if (ImageStreamList != null ? !ImageStreamList.equals(that.ImageStreamList) :that.ImageStreamList != null) return false;
            if (ImageStreamTagList != null ? !ImageStreamTagList.equals(that.ImageStreamTagList) :that.ImageStreamTagList != null) return false;
            if (Ingress != null ? !Ingress.equals(that.Ingress) :that.Ingress != null) return false;
            if (IngressList != null ? !IngressList.equals(that.IngressList) :that.IngressList != null) return false;
            if (Job != null ? !Job.equals(that.Job) :that.Job != null) return false;
            if (JobList != null ? !JobList.equals(that.JobList) :that.JobList != null) return false;
            if (LimitRangeList != null ? !LimitRangeList.equals(that.LimitRangeList) :that.LimitRangeList != null) return false;
            if (ListMeta != null ? !ListMeta.equals(that.ListMeta) :that.ListMeta != null) return false;
            if (LocalSubjectAccessReview != null ? !LocalSubjectAccessReview.equals(that.LocalSubjectAccessReview) :that.LocalSubjectAccessReview != null) return false;
            if (Namespace != null ? !Namespace.equals(that.Namespace) :that.Namespace != null) return false;
            if (NamespaceList != null ? !NamespaceList.equals(that.NamespaceList) :that.NamespaceList != null) return false;
            if (Node != null ? !Node.equals(that.Node) :that.Node != null) return false;
            if (NodeList != null ? !NodeList.equals(that.NodeList) :that.NodeList != null) return false;
            if (OAuthAccessToken != null ? !OAuthAccessToken.equals(that.OAuthAccessToken) :that.OAuthAccessToken != null) return false;
            if (OAuthAccessTokenList != null ? !OAuthAccessTokenList.equals(that.OAuthAccessTokenList) :that.OAuthAccessTokenList != null) return false;
            if (OAuthAuthorizeToken != null ? !OAuthAuthorizeToken.equals(that.OAuthAuthorizeToken) :that.OAuthAuthorizeToken != null) return false;
            if (OAuthAuthorizeTokenList != null ? !OAuthAuthorizeTokenList.equals(that.OAuthAuthorizeTokenList) :that.OAuthAuthorizeTokenList != null) return false;
            if (OAuthClient != null ? !OAuthClient.equals(that.OAuthClient) :that.OAuthClient != null) return false;
            if (OAuthClientAuthorization != null ? !OAuthClientAuthorization.equals(that.OAuthClientAuthorization) :that.OAuthClientAuthorization != null) return false;
            if (OAuthClientAuthorizationList != null ? !OAuthClientAuthorizationList.equals(that.OAuthClientAuthorizationList) :that.OAuthClientAuthorizationList != null) return false;
            if (OAuthClientList != null ? !OAuthClientList.equals(that.OAuthClientList) :that.OAuthClientList != null) return false;
            if (ObjectMeta != null ? !ObjectMeta.equals(that.ObjectMeta) :that.ObjectMeta != null) return false;
            if (Patch != null ? !Patch.equals(that.Patch) :that.Patch != null) return false;
            if (PersistentVolume != null ? !PersistentVolume.equals(that.PersistentVolume) :that.PersistentVolume != null) return false;
            if (PersistentVolumeClaim != null ? !PersistentVolumeClaim.equals(that.PersistentVolumeClaim) :that.PersistentVolumeClaim != null) return false;
            if (PersistentVolumeClaimList != null ? !PersistentVolumeClaimList.equals(that.PersistentVolumeClaimList) :that.PersistentVolumeClaimList != null) return false;
            if (PersistentVolumeList != null ? !PersistentVolumeList.equals(that.PersistentVolumeList) :that.PersistentVolumeList != null) return false;
            if (PodList != null ? !PodList.equals(that.PodList) :that.PodList != null) return false;
            if (PodTemplateList != null ? !PodTemplateList.equals(that.PodTemplateList) :that.PodTemplateList != null) return false;
            if (Policy != null ? !Policy.equals(that.Policy) :that.Policy != null) return false;
            if (PolicyBinding != null ? !PolicyBinding.equals(that.PolicyBinding) :that.PolicyBinding != null) return false;
            if (PolicyBindingList != null ? !PolicyBindingList.equals(that.PolicyBindingList) :that.PolicyBindingList != null) return false;
            if (PolicyList != null ? !PolicyList.equals(that.PolicyList) :that.PolicyList != null) return false;
            if (Project != null ? !Project.equals(that.Project) :that.Project != null) return false;
            if (ProjectList != null ? !ProjectList.equals(that.ProjectList) :that.ProjectList != null) return false;
            if (ProjectRequest != null ? !ProjectRequest.equals(that.ProjectRequest) :that.ProjectRequest != null) return false;
            if (Quantity != null ? !Quantity.equals(that.Quantity) :that.Quantity != null) return false;
            if (ReplicaSet != null ? !ReplicaSet.equals(that.ReplicaSet) :that.ReplicaSet != null) return false;
            if (ReplicaSetList != null ? !ReplicaSetList.equals(that.ReplicaSetList) :that.ReplicaSetList != null) return false;
            if (ReplicationControllerList != null ? !ReplicationControllerList.equals(that.ReplicationControllerList) :that.ReplicationControllerList != null) return false;
            if (ResourceQuota != null ? !ResourceQuota.equals(that.ResourceQuota) :that.ResourceQuota != null) return false;
            if (ResourceQuotaList != null ? !ResourceQuotaList.equals(that.ResourceQuotaList) :that.ResourceQuotaList != null) return false;
            if (Role != null ? !Role.equals(that.Role) :that.Role != null) return false;
            if (RoleBinding != null ? !RoleBinding.equals(that.RoleBinding) :that.RoleBinding != null) return false;
            if (RoleBindingList != null ? !RoleBindingList.equals(that.RoleBindingList) :that.RoleBindingList != null) return false;
            if (RoleList != null ? !RoleList.equals(that.RoleList) :that.RoleList != null) return false;
            if (RootPaths != null ? !RootPaths.equals(that.RootPaths) :that.RootPaths != null) return false;
            if (RouteList != null ? !RouteList.equals(that.RouteList) :that.RouteList != null) return false;
            if (Scale != null ? !Scale.equals(that.Scale) :that.Scale != null) return false;
            if (Secret != null ? !Secret.equals(that.Secret) :that.Secret != null) return false;
            if (SecretList != null ? !SecretList.equals(that.SecretList) :that.SecretList != null) return false;
            if (SecurityContextConstraints != null ? !SecurityContextConstraints.equals(that.SecurityContextConstraints) :that.SecurityContextConstraints != null) return false;
            if (SecurityContextConstraintsList != null ? !SecurityContextConstraintsList.equals(that.SecurityContextConstraintsList) :that.SecurityContextConstraintsList != null) return false;
            if (ServiceAccount != null ? !ServiceAccount.equals(that.ServiceAccount) :that.ServiceAccount != null) return false;
            if (ServiceAccountList != null ? !ServiceAccountList.equals(that.ServiceAccountList) :that.ServiceAccountList != null) return false;
            if (ServiceList != null ? !ServiceList.equals(that.ServiceList) :that.ServiceList != null) return false;
            if (Status != null ? !Status.equals(that.Status) :that.Status != null) return false;
            if (SubjectAccessReview != null ? !SubjectAccessReview.equals(that.SubjectAccessReview) :that.SubjectAccessReview != null) return false;
            if (SubjectAccessReviewResponse != null ? !SubjectAccessReviewResponse.equals(that.SubjectAccessReviewResponse) :that.SubjectAccessReviewResponse != null) return false;
            if (TagEvent != null ? !TagEvent.equals(that.TagEvent) :that.TagEvent != null) return false;
            if (Template != null ? !Template.equals(that.Template) :that.Template != null) return false;
            if (TemplateList != null ? !TemplateList.equals(that.TemplateList) :that.TemplateList != null) return false;
            if (ThirdPartyResource != null ? !ThirdPartyResource.equals(that.ThirdPartyResource) :that.ThirdPartyResource != null) return false;
            if (ThirdPartyResourceList != null ? !ThirdPartyResourceList.equals(that.ThirdPartyResourceList) :that.ThirdPartyResourceList != null) return false;
            if (User != null ? !User.equals(that.User) :that.User != null) return false;
            if (UserList != null ? !UserList.equals(that.UserList) :that.UserList != null) return false;
            if (WatchEvent != null ? !WatchEvent.equals(that.WatchEvent) :that.WatchEvent != null) return false;
            return true;
    }


    public class BaseKubernetesListNestedImpl<N> extends BaseKubernetesListFluentImpl<KubeSchemaFluent.BaseKubernetesListNested<N>> implements KubeSchemaFluent.BaseKubernetesListNested<N>,Nested<N>{

            private final BaseKubernetesListBuilder builder;
    
            BaseKubernetesListNestedImpl(){
                    this.builder = new BaseKubernetesListBuilder(this);
            }
            BaseKubernetesListNestedImpl(BaseKubernetesList item){
                    this.builder = new BaseKubernetesListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withBaseKubernetesList(builder.build());
    }
    public N endBaseKubernetesList(){
            return and();
    }

}
    public class BindingNestedImpl<N> extends BindingFluentImpl<KubeSchemaFluent.BindingNested<N>> implements KubeSchemaFluent.BindingNested<N>,Nested<N>{

            private final BindingBuilder builder;
    
            BindingNestedImpl(){
                    this.builder = new BindingBuilder(this);
            }
            BindingNestedImpl(Binding item){
                    this.builder = new BindingBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withBinding(builder.build());
    }
    public N endBinding(){
            return and();
    }

}
    public class BuildConfigListNestedImpl<N> extends BuildConfigListFluentImpl<KubeSchemaFluent.BuildConfigListNested<N>> implements KubeSchemaFluent.BuildConfigListNested<N>,Nested<N>{

            private final BuildConfigListBuilder builder;
    
            BuildConfigListNestedImpl(){
                    this.builder = new BuildConfigListBuilder(this);
            }
            BuildConfigListNestedImpl(BuildConfigList item){
                    this.builder = new BuildConfigListBuilder(this, item);
            }
    
    public N endBuildConfigList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withBuildConfigList(builder.build());
    }

}
    public class BuildListNestedImpl<N> extends BuildListFluentImpl<KubeSchemaFluent.BuildListNested<N>> implements KubeSchemaFluent.BuildListNested<N>,Nested<N>{

            private final BuildListBuilder builder;
    
            BuildListNestedImpl(){
                    this.builder = new BuildListBuilder(this);
            }
            BuildListNestedImpl(BuildList item){
                    this.builder = new BuildListBuilder(this, item);
            }
    
    public N endBuildList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withBuildList(builder.build());
    }

}
    public class BuildRequestNestedImpl<N> extends BuildRequestFluentImpl<KubeSchemaFluent.BuildRequestNested<N>> implements KubeSchemaFluent.BuildRequestNested<N>,Nested<N>{

            private final BuildRequestBuilder builder;
    
            BuildRequestNestedImpl(){
                    this.builder = new BuildRequestBuilder(this);
            }
            BuildRequestNestedImpl(BuildRequest item){
                    this.builder = new BuildRequestBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withBuildRequest(builder.build());
    }
    public N endBuildRequest(){
            return and();
    }

}
    public class ClusterPolicyNestedImpl<N> extends ClusterPolicyFluentImpl<KubeSchemaFluent.ClusterPolicyNested<N>> implements KubeSchemaFluent.ClusterPolicyNested<N>,Nested<N>{

            private final ClusterPolicyBuilder builder;
    
            ClusterPolicyNestedImpl(){
                    this.builder = new ClusterPolicyBuilder(this);
            }
            ClusterPolicyNestedImpl(ClusterPolicy item){
                    this.builder = new ClusterPolicyBuilder(this, item);
            }
    
    public N endClusterPolicy(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withClusterPolicy(builder.build());
    }

}
    public class ClusterPolicyBindingNestedImpl<N> extends ClusterPolicyBindingFluentImpl<KubeSchemaFluent.ClusterPolicyBindingNested<N>> implements KubeSchemaFluent.ClusterPolicyBindingNested<N>,Nested<N>{

            private final ClusterPolicyBindingBuilder builder;
    
            ClusterPolicyBindingNestedImpl(){
                    this.builder = new ClusterPolicyBindingBuilder(this);
            }
            ClusterPolicyBindingNestedImpl(ClusterPolicyBinding item){
                    this.builder = new ClusterPolicyBindingBuilder(this, item);
            }
    
    public N endClusterPolicyBinding(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withClusterPolicyBinding(builder.build());
    }

}
    public class ClusterPolicyBindingListNestedImpl<N> extends ClusterPolicyBindingListFluentImpl<KubeSchemaFluent.ClusterPolicyBindingListNested<N>> implements KubeSchemaFluent.ClusterPolicyBindingListNested<N>,Nested<N>{

            private final ClusterPolicyBindingListBuilder builder;
    
            ClusterPolicyBindingListNestedImpl(){
                    this.builder = new ClusterPolicyBindingListBuilder(this);
            }
            ClusterPolicyBindingListNestedImpl(ClusterPolicyBindingList item){
                    this.builder = new ClusterPolicyBindingListBuilder(this, item);
            }
    
    public N endClusterPolicyBindingList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withClusterPolicyBindingList(builder.build());
    }

}
    public class ClusterPolicyListNestedImpl<N> extends ClusterPolicyListFluentImpl<KubeSchemaFluent.ClusterPolicyListNested<N>> implements KubeSchemaFluent.ClusterPolicyListNested<N>,Nested<N>{

            private final ClusterPolicyListBuilder builder;
    
            ClusterPolicyListNestedImpl(){
                    this.builder = new ClusterPolicyListBuilder(this);
            }
            ClusterPolicyListNestedImpl(ClusterPolicyList item){
                    this.builder = new ClusterPolicyListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withClusterPolicyList(builder.build());
    }
    public N endClusterPolicyList(){
            return and();
    }

}
    public class ClusterRoleBindingNestedImpl<N> extends ClusterRoleBindingFluentImpl<KubeSchemaFluent.ClusterRoleBindingNested<N>> implements KubeSchemaFluent.ClusterRoleBindingNested<N>,Nested<N>{

            private final ClusterRoleBindingBuilder builder;
    
            ClusterRoleBindingNestedImpl(){
                    this.builder = new ClusterRoleBindingBuilder(this);
            }
            ClusterRoleBindingNestedImpl(ClusterRoleBinding item){
                    this.builder = new ClusterRoleBindingBuilder(this, item);
            }
    
    public N endClusterRoleBinding(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withClusterRoleBinding(builder.build());
    }

}
    public class ClusterRoleBindingListNestedImpl<N> extends ClusterRoleBindingListFluentImpl<KubeSchemaFluent.ClusterRoleBindingListNested<N>> implements KubeSchemaFluent.ClusterRoleBindingListNested<N>,Nested<N>{

            private final ClusterRoleBindingListBuilder builder;
    
            ClusterRoleBindingListNestedImpl(){
                    this.builder = new ClusterRoleBindingListBuilder(this);
            }
            ClusterRoleBindingListNestedImpl(ClusterRoleBindingList item){
                    this.builder = new ClusterRoleBindingListBuilder(this, item);
            }
    
    public N endClusterRoleBindingList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withClusterRoleBindingList(builder.build());
    }

}
    public class ComponentStatusListNestedImpl<N> extends ComponentStatusListFluentImpl<KubeSchemaFluent.ComponentStatusListNested<N>> implements KubeSchemaFluent.ComponentStatusListNested<N>,Nested<N>{

            private final ComponentStatusListBuilder builder;
    
            ComponentStatusListNestedImpl(){
                    this.builder = new ComponentStatusListBuilder(this);
            }
            ComponentStatusListNestedImpl(ComponentStatusList item){
                    this.builder = new ComponentStatusListBuilder(this, item);
            }
    
    public N endComponentStatusList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withComponentStatusList(builder.build());
    }

}
    public class ConfigNestedImpl<N> extends ConfigFluentImpl<KubeSchemaFluent.ConfigNested<N>> implements KubeSchemaFluent.ConfigNested<N>,Nested<N>{

            private final ConfigBuilder builder;
    
            ConfigNestedImpl(){
                    this.builder = new ConfigBuilder(this);
            }
            ConfigNestedImpl(Config item){
                    this.builder = new ConfigBuilder(this, item);
            }
    
    public N endConfig(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withConfig(builder.build());
    }

}
    public class ConfigMapNestedImpl<N> extends ConfigMapFluentImpl<KubeSchemaFluent.ConfigMapNested<N>> implements KubeSchemaFluent.ConfigMapNested<N>,Nested<N>{

            private final ConfigMapBuilder builder;
    
            ConfigMapNestedImpl(){
                    this.builder = new ConfigMapBuilder(this);
            }
            ConfigMapNestedImpl(ConfigMap item){
                    this.builder = new ConfigMapBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withConfigMap(builder.build());
    }
    public N endConfigMap(){
            return and();
    }

}
    public class ConfigMapListNestedImpl<N> extends ConfigMapListFluentImpl<KubeSchemaFluent.ConfigMapListNested<N>> implements KubeSchemaFluent.ConfigMapListNested<N>,Nested<N>{

            private final ConfigMapListBuilder builder;
    
            ConfigMapListNestedImpl(){
                    this.builder = new ConfigMapListBuilder(this);
            }
            ConfigMapListNestedImpl(ConfigMapList item){
                    this.builder = new ConfigMapListBuilder(this, item);
            }
    
    public N endConfigMapList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withConfigMapList(builder.build());
    }

}
    public class ContainerStatusNestedImpl<N> extends ContainerStatusFluentImpl<KubeSchemaFluent.ContainerStatusNested<N>> implements KubeSchemaFluent.ContainerStatusNested<N>,Nested<N>{

            private final ContainerStatusBuilder builder;
    
            ContainerStatusNestedImpl(ContainerStatus item){
                    this.builder = new ContainerStatusBuilder(this, item);
            }
            ContainerStatusNestedImpl(){
                    this.builder = new ContainerStatusBuilder(this);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withContainerStatus(builder.build());
    }
    public N endContainerStatus(){
            return and();
    }

}
    public class DaemonSetNestedImpl<N> extends DaemonSetFluentImpl<KubeSchemaFluent.DaemonSetNested<N>> implements KubeSchemaFluent.DaemonSetNested<N>,Nested<N>{

            private final DaemonSetBuilder builder;
    
            DaemonSetNestedImpl(){
                    this.builder = new DaemonSetBuilder(this);
            }
            DaemonSetNestedImpl(DaemonSet item){
                    this.builder = new DaemonSetBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withDaemonSet(builder.build());
    }
    public N endDaemonSet(){
            return and();
    }

}
    public class DaemonSetListNestedImpl<N> extends DaemonSetListFluentImpl<KubeSchemaFluent.DaemonSetListNested<N>> implements KubeSchemaFluent.DaemonSetListNested<N>,Nested<N>{

            private final DaemonSetListBuilder builder;
    
            DaemonSetListNestedImpl(){
                    this.builder = new DaemonSetListBuilder(this);
            }
            DaemonSetListNestedImpl(DaemonSetList item){
                    this.builder = new DaemonSetListBuilder(this, item);
            }
    
    public N endDaemonSetList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withDaemonSetList(builder.build());
    }

}
    public class DeleteOptionsNestedImpl<N> extends DeleteOptionsFluentImpl<KubeSchemaFluent.DeleteOptionsNested<N>> implements KubeSchemaFluent.DeleteOptionsNested<N>,Nested<N>{

            private final DeleteOptionsBuilder builder;
    
            DeleteOptionsNestedImpl(){
                    this.builder = new DeleteOptionsBuilder(this);
            }
            DeleteOptionsNestedImpl(DeleteOptions item){
                    this.builder = new DeleteOptionsBuilder(this, item);
            }
    
    public N endDeleteOptions(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withDeleteOptions(builder.build());
    }

}
    public class DeploymentNestedImpl<N> extends DeploymentFluentImpl<KubeSchemaFluent.DeploymentNested<N>> implements KubeSchemaFluent.DeploymentNested<N>,Nested<N>{

            private final DeploymentBuilder builder;
    
            DeploymentNestedImpl(){
                    this.builder = new DeploymentBuilder(this);
            }
            DeploymentNestedImpl(Deployment item){
                    this.builder = new DeploymentBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withDeployment(builder.build());
    }
    public N endDeployment(){
            return and();
    }

}
    public class DeploymentConfigListNestedImpl<N> extends DeploymentConfigListFluentImpl<KubeSchemaFluent.DeploymentConfigListNested<N>> implements KubeSchemaFluent.DeploymentConfigListNested<N>,Nested<N>{

            private final DeploymentConfigListBuilder builder;
    
            DeploymentConfigListNestedImpl(){
                    this.builder = new DeploymentConfigListBuilder(this);
            }
            DeploymentConfigListNestedImpl(DeploymentConfigList item){
                    this.builder = new DeploymentConfigListBuilder(this, item);
            }
    
    public N endDeploymentConfigList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withDeploymentConfigList(builder.build());
    }

}
    public class DeploymentListNestedImpl<N> extends DeploymentListFluentImpl<KubeSchemaFluent.DeploymentListNested<N>> implements KubeSchemaFluent.DeploymentListNested<N>,Nested<N>{

            private final DeploymentListBuilder builder;
    
            DeploymentListNestedImpl(){
                    this.builder = new DeploymentListBuilder(this);
            }
            DeploymentListNestedImpl(DeploymentList item){
                    this.builder = new DeploymentListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withDeploymentList(builder.build());
    }
    public N endDeploymentList(){
            return and();
    }

}
    public class DeploymentRollbackNestedImpl<N> extends DeploymentRollbackFluentImpl<KubeSchemaFluent.DeploymentRollbackNested<N>> implements KubeSchemaFluent.DeploymentRollbackNested<N>,Nested<N>{

            private final DeploymentRollbackBuilder builder;
    
            DeploymentRollbackNestedImpl(){
                    this.builder = new DeploymentRollbackBuilder(this);
            }
            DeploymentRollbackNestedImpl(DeploymentRollback item){
                    this.builder = new DeploymentRollbackBuilder(this, item);
            }
    
    public N endDeploymentRollback(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withDeploymentRollback(builder.build());
    }

}
    public class EndpointsNestedImpl<N> extends EndpointsFluentImpl<KubeSchemaFluent.EndpointsNested<N>> implements KubeSchemaFluent.EndpointsNested<N>,Nested<N>{

            private final EndpointsBuilder builder;
    
            EndpointsNestedImpl(){
                    this.builder = new EndpointsBuilder(this);
            }
            EndpointsNestedImpl(Endpoints item){
                    this.builder = new EndpointsBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withEndpoints(builder.build());
    }
    public N endEndpoints(){
            return and();
    }

}
    public class EndpointsListNestedImpl<N> extends EndpointsListFluentImpl<KubeSchemaFluent.EndpointsListNested<N>> implements KubeSchemaFluent.EndpointsListNested<N>,Nested<N>{

            private final EndpointsListBuilder builder;
    
            EndpointsListNestedImpl(){
                    this.builder = new EndpointsListBuilder(this);
            }
            EndpointsListNestedImpl(EndpointsList item){
                    this.builder = new EndpointsListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withEndpointsList(builder.build());
    }
    public N endEndpointsList(){
            return and();
    }

}
    public class EnvVarNestedImpl<N> extends EnvVarFluentImpl<KubeSchemaFluent.EnvVarNested<N>> implements KubeSchemaFluent.EnvVarNested<N>,Nested<N>{

            private final EnvVarBuilder builder;
    
            EnvVarNestedImpl(EnvVar item){
                    this.builder = new EnvVarBuilder(this, item);
            }
            EnvVarNestedImpl(){
                    this.builder = new EnvVarBuilder(this);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withEnvVar(builder.build());
    }
    public N endEnvVar(){
            return and();
    }

}
    public class EventListNestedImpl<N> extends EventListFluentImpl<KubeSchemaFluent.EventListNested<N>> implements KubeSchemaFluent.EventListNested<N>,Nested<N>{

            private final EventListBuilder builder;
    
            EventListNestedImpl(){
                    this.builder = new EventListBuilder(this);
            }
            EventListNestedImpl(EventList item){
                    this.builder = new EventListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withEventList(builder.build());
    }
    public N endEventList(){
            return and();
    }

}
    public class GroupNestedImpl<N> extends GroupFluentImpl<KubeSchemaFluent.GroupNested<N>> implements KubeSchemaFluent.GroupNested<N>,Nested<N>{

            private final GroupBuilder builder;
    
            GroupNestedImpl(){
                    this.builder = new GroupBuilder(this);
            }
            GroupNestedImpl(Group item){
                    this.builder = new GroupBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withGroup(builder.build());
    }
    public N endGroup(){
            return and();
    }

}
    public class GroupListNestedImpl<N> extends GroupListFluentImpl<KubeSchemaFluent.GroupListNested<N>> implements KubeSchemaFluent.GroupListNested<N>,Nested<N>{

            private final GroupListBuilder builder;
    
            GroupListNestedImpl(){
                    this.builder = new GroupListBuilder(this);
            }
            GroupListNestedImpl(GroupList item){
                    this.builder = new GroupListBuilder(this, item);
            }
    
    public N endGroupList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withGroupList(builder.build());
    }

}
    public class HorizontalPodAutoscalerNestedImpl<N> extends HorizontalPodAutoscalerFluentImpl<KubeSchemaFluent.HorizontalPodAutoscalerNested<N>> implements KubeSchemaFluent.HorizontalPodAutoscalerNested<N>,Nested<N>{

            private final HorizontalPodAutoscalerBuilder builder;
    
            HorizontalPodAutoscalerNestedImpl(){
                    this.builder = new HorizontalPodAutoscalerBuilder(this);
            }
            HorizontalPodAutoscalerNestedImpl(HorizontalPodAutoscaler item){
                    this.builder = new HorizontalPodAutoscalerBuilder(this, item);
            }
    
    public N endHorizontalPodAutoscaler(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withHorizontalPodAutoscaler(builder.build());
    }

}
    public class HorizontalPodAutoscalerListNestedImpl<N> extends HorizontalPodAutoscalerListFluentImpl<KubeSchemaFluent.HorizontalPodAutoscalerListNested<N>> implements KubeSchemaFluent.HorizontalPodAutoscalerListNested<N>,Nested<N>{

            private final HorizontalPodAutoscalerListBuilder builder;
    
            HorizontalPodAutoscalerListNestedImpl(){
                    this.builder = new HorizontalPodAutoscalerListBuilder(this);
            }
            HorizontalPodAutoscalerListNestedImpl(HorizontalPodAutoscalerList item){
                    this.builder = new HorizontalPodAutoscalerListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withHorizontalPodAutoscalerList(builder.build());
    }
    public N endHorizontalPodAutoscalerList(){
            return and();
    }

}
    public class IdentityNestedImpl<N> extends IdentityFluentImpl<KubeSchemaFluent.IdentityNested<N>> implements KubeSchemaFluent.IdentityNested<N>,Nested<N>{

            private final IdentityBuilder builder;
    
            IdentityNestedImpl(){
                    this.builder = new IdentityBuilder(this);
            }
            IdentityNestedImpl(Identity item){
                    this.builder = new IdentityBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withIdentity(builder.build());
    }
    public N endIdentity(){
            return and();
    }

}
    public class IdentityListNestedImpl<N> extends IdentityListFluentImpl<KubeSchemaFluent.IdentityListNested<N>> implements KubeSchemaFluent.IdentityListNested<N>,Nested<N>{

            private final IdentityListBuilder builder;
    
            IdentityListNestedImpl(){
                    this.builder = new IdentityListBuilder(this);
            }
            IdentityListNestedImpl(IdentityList item){
                    this.builder = new IdentityListBuilder(this, item);
            }
    
    public N endIdentityList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withIdentityList(builder.build());
    }

}
    public class ImageListNestedImpl<N> extends ImageListFluentImpl<KubeSchemaFluent.ImageListNested<N>> implements KubeSchemaFluent.ImageListNested<N>,Nested<N>{

            private final ImageListBuilder builder;
    
            ImageListNestedImpl(){
                    this.builder = new ImageListBuilder(this);
            }
            ImageListNestedImpl(ImageList item){
                    this.builder = new ImageListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withImageList(builder.build());
    }
    public N endImageList(){
            return and();
    }

}
    public class ImageStreamListNestedImpl<N> extends ImageStreamListFluentImpl<KubeSchemaFluent.ImageStreamListNested<N>> implements KubeSchemaFluent.ImageStreamListNested<N>,Nested<N>{

            private final ImageStreamListBuilder builder;
    
            ImageStreamListNestedImpl(){
                    this.builder = new ImageStreamListBuilder(this);
            }
            ImageStreamListNestedImpl(ImageStreamList item){
                    this.builder = new ImageStreamListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withImageStreamList(builder.build());
    }
    public N endImageStreamList(){
            return and();
    }

}
    public class ImageStreamTagListNestedImpl<N> extends ImageStreamTagListFluentImpl<KubeSchemaFluent.ImageStreamTagListNested<N>> implements KubeSchemaFluent.ImageStreamTagListNested<N>,Nested<N>{

            private final ImageStreamTagListBuilder builder;
    
            ImageStreamTagListNestedImpl(){
                    this.builder = new ImageStreamTagListBuilder(this);
            }
            ImageStreamTagListNestedImpl(ImageStreamTagList item){
                    this.builder = new ImageStreamTagListBuilder(this, item);
            }
    
    public N endImageStreamTagList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withImageStreamTagList(builder.build());
    }

}
    public class IngressNestedImpl<N> extends IngressFluentImpl<KubeSchemaFluent.IngressNested<N>> implements KubeSchemaFluent.IngressNested<N>,Nested<N>{

            private final IngressBuilder builder;
    
            IngressNestedImpl(){
                    this.builder = new IngressBuilder(this);
            }
            IngressNestedImpl(Ingress item){
                    this.builder = new IngressBuilder(this, item);
            }
    
    public N endIngress(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withIngress(builder.build());
    }

}
    public class IngressListNestedImpl<N> extends IngressListFluentImpl<KubeSchemaFluent.IngressListNested<N>> implements KubeSchemaFluent.IngressListNested<N>,Nested<N>{

            private final IngressListBuilder builder;
    
            IngressListNestedImpl(){
                    this.builder = new IngressListBuilder(this);
            }
            IngressListNestedImpl(IngressList item){
                    this.builder = new IngressListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withIngressList(builder.build());
    }
    public N endIngressList(){
            return and();
    }

}
    public class JobNestedImpl<N> extends JobFluentImpl<KubeSchemaFluent.JobNested<N>> implements KubeSchemaFluent.JobNested<N>,Nested<N>{

            private final JobBuilder builder;
    
            JobNestedImpl(){
                    this.builder = new JobBuilder(this);
            }
            JobNestedImpl(Job item){
                    this.builder = new JobBuilder(this, item);
            }
    
    public N endJob(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withJob(builder.build());
    }

}
    public class JobListNestedImpl<N> extends JobListFluentImpl<KubeSchemaFluent.JobListNested<N>> implements KubeSchemaFluent.JobListNested<N>,Nested<N>{

            private final JobListBuilder builder;
    
            JobListNestedImpl(){
                    this.builder = new JobListBuilder(this);
            }
            JobListNestedImpl(JobList item){
                    this.builder = new JobListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withJobList(builder.build());
    }
    public N endJobList(){
            return and();
    }

}
    public class LimitRangeListNestedImpl<N> extends LimitRangeListFluentImpl<KubeSchemaFluent.LimitRangeListNested<N>> implements KubeSchemaFluent.LimitRangeListNested<N>,Nested<N>{

            private final LimitRangeListBuilder builder;
    
            LimitRangeListNestedImpl(){
                    this.builder = new LimitRangeListBuilder(this);
            }
            LimitRangeListNestedImpl(LimitRangeList item){
                    this.builder = new LimitRangeListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withLimitRangeList(builder.build());
    }
    public N endLimitRangeList(){
            return and();
    }

}
    public class ListMetaNestedImpl<N> extends ListMetaFluentImpl<KubeSchemaFluent.ListMetaNested<N>> implements KubeSchemaFluent.ListMetaNested<N>,Nested<N>{

            private final ListMetaBuilder builder;
    
            ListMetaNestedImpl(){
                    this.builder = new ListMetaBuilder(this);
            }
            ListMetaNestedImpl(ListMeta item){
                    this.builder = new ListMetaBuilder(this, item);
            }
    
    public N endListMeta(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withListMeta(builder.build());
    }

}
    public class LocalSubjectAccessReviewNestedImpl<N> extends LocalSubjectAccessReviewFluentImpl<KubeSchemaFluent.LocalSubjectAccessReviewNested<N>> implements KubeSchemaFluent.LocalSubjectAccessReviewNested<N>,Nested<N>{

            private final LocalSubjectAccessReviewBuilder builder;
    
            LocalSubjectAccessReviewNestedImpl(LocalSubjectAccessReview item){
                    this.builder = new LocalSubjectAccessReviewBuilder(this, item);
            }
            LocalSubjectAccessReviewNestedImpl(){
                    this.builder = new LocalSubjectAccessReviewBuilder(this);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withLocalSubjectAccessReview(builder.build());
    }
    public N endLocalSubjectAccessReview(){
            return and();
    }

}
    public class NamespaceNestedImpl<N> extends NamespaceFluentImpl<KubeSchemaFluent.NamespaceNested<N>> implements KubeSchemaFluent.NamespaceNested<N>,Nested<N>{

            private final NamespaceBuilder builder;
    
            NamespaceNestedImpl(){
                    this.builder = new NamespaceBuilder(this);
            }
            NamespaceNestedImpl(Namespace item){
                    this.builder = new NamespaceBuilder(this, item);
            }
    
    public N endNamespace(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withNamespace(builder.build());
    }

}
    public class NamespaceListNestedImpl<N> extends NamespaceListFluentImpl<KubeSchemaFluent.NamespaceListNested<N>> implements KubeSchemaFluent.NamespaceListNested<N>,Nested<N>{

            private final NamespaceListBuilder builder;
    
            NamespaceListNestedImpl(){
                    this.builder = new NamespaceListBuilder(this);
            }
            NamespaceListNestedImpl(NamespaceList item){
                    this.builder = new NamespaceListBuilder(this, item);
            }
    
    public N endNamespaceList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withNamespaceList(builder.build());
    }

}
    public class NodeNestedImpl<N> extends NodeFluentImpl<KubeSchemaFluent.NodeNested<N>> implements KubeSchemaFluent.NodeNested<N>,Nested<N>{

            private final NodeBuilder builder;
    
            NodeNestedImpl(){
                    this.builder = new NodeBuilder(this);
            }
            NodeNestedImpl(Node item){
                    this.builder = new NodeBuilder(this, item);
            }
    
    public N endNode(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withNode(builder.build());
    }

}
    public class NodeListNestedImpl<N> extends NodeListFluentImpl<KubeSchemaFluent.NodeListNested<N>> implements KubeSchemaFluent.NodeListNested<N>,Nested<N>{

            private final NodeListBuilder builder;
    
            NodeListNestedImpl(){
                    this.builder = new NodeListBuilder(this);
            }
            NodeListNestedImpl(NodeList item){
                    this.builder = new NodeListBuilder(this, item);
            }
    
    public N endNodeList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withNodeList(builder.build());
    }

}
    public class OAuthAccessTokenNestedImpl<N> extends OAuthAccessTokenFluentImpl<KubeSchemaFluent.OAuthAccessTokenNested<N>> implements KubeSchemaFluent.OAuthAccessTokenNested<N>,Nested<N>{

            private final OAuthAccessTokenBuilder builder;
    
            OAuthAccessTokenNestedImpl(){
                    this.builder = new OAuthAccessTokenBuilder(this);
            }
            OAuthAccessTokenNestedImpl(OAuthAccessToken item){
                    this.builder = new OAuthAccessTokenBuilder(this, item);
            }
    
    public N endOAuthAccessToken(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withOAuthAccessToken(builder.build());
    }

}
    public class OAuthAccessTokenListNestedImpl<N> extends OAuthAccessTokenListFluentImpl<KubeSchemaFluent.OAuthAccessTokenListNested<N>> implements KubeSchemaFluent.OAuthAccessTokenListNested<N>,Nested<N>{

            private final OAuthAccessTokenListBuilder builder;
    
            OAuthAccessTokenListNestedImpl(){
                    this.builder = new OAuthAccessTokenListBuilder(this);
            }
            OAuthAccessTokenListNestedImpl(OAuthAccessTokenList item){
                    this.builder = new OAuthAccessTokenListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withOAuthAccessTokenList(builder.build());
    }
    public N endOAuthAccessTokenList(){
            return and();
    }

}
    public class OAuthAuthorizeTokenNestedImpl<N> extends OAuthAuthorizeTokenFluentImpl<KubeSchemaFluent.OAuthAuthorizeTokenNested<N>> implements KubeSchemaFluent.OAuthAuthorizeTokenNested<N>,Nested<N>{

            private final OAuthAuthorizeTokenBuilder builder;
    
            OAuthAuthorizeTokenNestedImpl(){
                    this.builder = new OAuthAuthorizeTokenBuilder(this);
            }
            OAuthAuthorizeTokenNestedImpl(OAuthAuthorizeToken item){
                    this.builder = new OAuthAuthorizeTokenBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withOAuthAuthorizeToken(builder.build());
    }
    public N endOAuthAuthorizeToken(){
            return and();
    }

}
    public class OAuthAuthorizeTokenListNestedImpl<N> extends OAuthAuthorizeTokenListFluentImpl<KubeSchemaFluent.OAuthAuthorizeTokenListNested<N>> implements KubeSchemaFluent.OAuthAuthorizeTokenListNested<N>,Nested<N>{

            private final OAuthAuthorizeTokenListBuilder builder;
    
            OAuthAuthorizeTokenListNestedImpl(){
                    this.builder = new OAuthAuthorizeTokenListBuilder(this);
            }
            OAuthAuthorizeTokenListNestedImpl(OAuthAuthorizeTokenList item){
                    this.builder = new OAuthAuthorizeTokenListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withOAuthAuthorizeTokenList(builder.build());
    }
    public N endOAuthAuthorizeTokenList(){
            return and();
    }

}
    public class OAuthClientNestedImpl<N> extends OAuthClientFluentImpl<KubeSchemaFluent.OAuthClientNested<N>> implements KubeSchemaFluent.OAuthClientNested<N>,Nested<N>{

            private final OAuthClientBuilder builder;
    
            OAuthClientNestedImpl(){
                    this.builder = new OAuthClientBuilder(this);
            }
            OAuthClientNestedImpl(OAuthClient item){
                    this.builder = new OAuthClientBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withOAuthClient(builder.build());
    }
    public N endOAuthClient(){
            return and();
    }

}
    public class OAuthClientAuthorizationNestedImpl<N> extends OAuthClientAuthorizationFluentImpl<KubeSchemaFluent.OAuthClientAuthorizationNested<N>> implements KubeSchemaFluent.OAuthClientAuthorizationNested<N>,Nested<N>{

            private final OAuthClientAuthorizationBuilder builder;
    
            OAuthClientAuthorizationNestedImpl(){
                    this.builder = new OAuthClientAuthorizationBuilder(this);
            }
            OAuthClientAuthorizationNestedImpl(OAuthClientAuthorization item){
                    this.builder = new OAuthClientAuthorizationBuilder(this, item);
            }
    
    public N endOAuthClientAuthorization(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withOAuthClientAuthorization(builder.build());
    }

}
    public class OAuthClientAuthorizationListNestedImpl<N> extends OAuthClientAuthorizationListFluentImpl<KubeSchemaFluent.OAuthClientAuthorizationListNested<N>> implements KubeSchemaFluent.OAuthClientAuthorizationListNested<N>,Nested<N>{

            private final OAuthClientAuthorizationListBuilder builder;
    
            OAuthClientAuthorizationListNestedImpl(){
                    this.builder = new OAuthClientAuthorizationListBuilder(this);
            }
            OAuthClientAuthorizationListNestedImpl(OAuthClientAuthorizationList item){
                    this.builder = new OAuthClientAuthorizationListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withOAuthClientAuthorizationList(builder.build());
    }
    public N endOAuthClientAuthorizationList(){
            return and();
    }

}
    public class OAuthClientListNestedImpl<N> extends OAuthClientListFluentImpl<KubeSchemaFluent.OAuthClientListNested<N>> implements KubeSchemaFluent.OAuthClientListNested<N>,Nested<N>{

            private final OAuthClientListBuilder builder;
    
            OAuthClientListNestedImpl(){
                    this.builder = new OAuthClientListBuilder(this);
            }
            OAuthClientListNestedImpl(OAuthClientList item){
                    this.builder = new OAuthClientListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withOAuthClientList(builder.build());
    }
    public N endOAuthClientList(){
            return and();
    }

}
    public class ObjectMetaNestedImpl<N> extends ObjectMetaFluentImpl<KubeSchemaFluent.ObjectMetaNested<N>> implements KubeSchemaFluent.ObjectMetaNested<N>,Nested<N>{

            private final ObjectMetaBuilder builder;
    
            ObjectMetaNestedImpl(ObjectMeta item){
                    this.builder = new ObjectMetaBuilder(this, item);
            }
            ObjectMetaNestedImpl(){
                    this.builder = new ObjectMetaBuilder(this);
            }
    
    public N endObjectMeta(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withObjectMeta(builder.build());
    }

}
    public class PersistentVolumeNestedImpl<N> extends PersistentVolumeFluentImpl<KubeSchemaFluent.PersistentVolumeNested<N>> implements KubeSchemaFluent.PersistentVolumeNested<N>,Nested<N>{

            private final PersistentVolumeBuilder builder;
    
            PersistentVolumeNestedImpl(){
                    this.builder = new PersistentVolumeBuilder(this);
            }
            PersistentVolumeNestedImpl(PersistentVolume item){
                    this.builder = new PersistentVolumeBuilder(this, item);
            }
    
    public N endPersistentVolume(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withPersistentVolume(builder.build());
    }

}
    public class PersistentVolumeClaimNestedImpl<N> extends PersistentVolumeClaimFluentImpl<KubeSchemaFluent.PersistentVolumeClaimNested<N>> implements KubeSchemaFluent.PersistentVolumeClaimNested<N>,Nested<N>{

            private final PersistentVolumeClaimBuilder builder;
    
            PersistentVolumeClaimNestedImpl(){
                    this.builder = new PersistentVolumeClaimBuilder(this);
            }
            PersistentVolumeClaimNestedImpl(PersistentVolumeClaim item){
                    this.builder = new PersistentVolumeClaimBuilder(this, item);
            }
    
    public N endPersistentVolumeClaim(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withPersistentVolumeClaim(builder.build());
    }

}
    public class PersistentVolumeClaimListNestedImpl<N> extends PersistentVolumeClaimListFluentImpl<KubeSchemaFluent.PersistentVolumeClaimListNested<N>> implements KubeSchemaFluent.PersistentVolumeClaimListNested<N>,Nested<N>{

            private final PersistentVolumeClaimListBuilder builder;
    
            PersistentVolumeClaimListNestedImpl(){
                    this.builder = new PersistentVolumeClaimListBuilder(this);
            }
            PersistentVolumeClaimListNestedImpl(PersistentVolumeClaimList item){
                    this.builder = new PersistentVolumeClaimListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withPersistentVolumeClaimList(builder.build());
    }
    public N endPersistentVolumeClaimList(){
            return and();
    }

}
    public class PersistentVolumeListNestedImpl<N> extends PersistentVolumeListFluentImpl<KubeSchemaFluent.PersistentVolumeListNested<N>> implements KubeSchemaFluent.PersistentVolumeListNested<N>,Nested<N>{

            private final PersistentVolumeListBuilder builder;
    
            PersistentVolumeListNestedImpl(){
                    this.builder = new PersistentVolumeListBuilder(this);
            }
            PersistentVolumeListNestedImpl(PersistentVolumeList item){
                    this.builder = new PersistentVolumeListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withPersistentVolumeList(builder.build());
    }
    public N endPersistentVolumeList(){
            return and();
    }

}
    public class PodListNestedImpl<N> extends PodListFluentImpl<KubeSchemaFluent.PodListNested<N>> implements KubeSchemaFluent.PodListNested<N>,Nested<N>{

            private final PodListBuilder builder;
    
            PodListNestedImpl(PodList item){
                    this.builder = new PodListBuilder(this, item);
            }
            PodListNestedImpl(){
                    this.builder = new PodListBuilder(this);
            }
    
    public N endPodList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withPodList(builder.build());
    }

}
    public class PodTemplateListNestedImpl<N> extends PodTemplateListFluentImpl<KubeSchemaFluent.PodTemplateListNested<N>> implements KubeSchemaFluent.PodTemplateListNested<N>,Nested<N>{

            private final PodTemplateListBuilder builder;
    
            PodTemplateListNestedImpl(){
                    this.builder = new PodTemplateListBuilder(this);
            }
            PodTemplateListNestedImpl(PodTemplateList item){
                    this.builder = new PodTemplateListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withPodTemplateList(builder.build());
    }
    public N endPodTemplateList(){
            return and();
    }

}
    public class PolicyNestedImpl<N> extends PolicyFluentImpl<KubeSchemaFluent.PolicyNested<N>> implements KubeSchemaFluent.PolicyNested<N>,Nested<N>{

            private final PolicyBuilder builder;
    
            PolicyNestedImpl(){
                    this.builder = new PolicyBuilder(this);
            }
            PolicyNestedImpl(Policy item){
                    this.builder = new PolicyBuilder(this, item);
            }
    
    public N endPolicy(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withPolicy(builder.build());
    }

}
    public class PolicyBindingNestedImpl<N> extends PolicyBindingFluentImpl<KubeSchemaFluent.PolicyBindingNested<N>> implements KubeSchemaFluent.PolicyBindingNested<N>,Nested<N>{

            private final PolicyBindingBuilder builder;
    
            PolicyBindingNestedImpl(){
                    this.builder = new PolicyBindingBuilder(this);
            }
            PolicyBindingNestedImpl(PolicyBinding item){
                    this.builder = new PolicyBindingBuilder(this, item);
            }
    
    public N endPolicyBinding(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withPolicyBinding(builder.build());
    }

}
    public class PolicyBindingListNestedImpl<N> extends PolicyBindingListFluentImpl<KubeSchemaFluent.PolicyBindingListNested<N>> implements KubeSchemaFluent.PolicyBindingListNested<N>,Nested<N>{

            private final PolicyBindingListBuilder builder;
    
            PolicyBindingListNestedImpl(){
                    this.builder = new PolicyBindingListBuilder(this);
            }
            PolicyBindingListNestedImpl(PolicyBindingList item){
                    this.builder = new PolicyBindingListBuilder(this, item);
            }
    
    public N endPolicyBindingList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withPolicyBindingList(builder.build());
    }

}
    public class PolicyListNestedImpl<N> extends PolicyListFluentImpl<KubeSchemaFluent.PolicyListNested<N>> implements KubeSchemaFluent.PolicyListNested<N>,Nested<N>{

            private final PolicyListBuilder builder;
    
            PolicyListNestedImpl(){
                    this.builder = new PolicyListBuilder(this);
            }
            PolicyListNestedImpl(PolicyList item){
                    this.builder = new PolicyListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withPolicyList(builder.build());
    }
    public N endPolicyList(){
            return and();
    }

}
    public class ProjectNestedImpl<N> extends ProjectFluentImpl<KubeSchemaFluent.ProjectNested<N>> implements KubeSchemaFluent.ProjectNested<N>,Nested<N>{

            private final ProjectBuilder builder;
    
            ProjectNestedImpl(){
                    this.builder = new ProjectBuilder(this);
            }
            ProjectNestedImpl(Project item){
                    this.builder = new ProjectBuilder(this, item);
            }
    
    public N endProject(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withProject(builder.build());
    }

}
    public class ProjectListNestedImpl<N> extends ProjectListFluentImpl<KubeSchemaFluent.ProjectListNested<N>> implements KubeSchemaFluent.ProjectListNested<N>,Nested<N>{

            private final ProjectListBuilder builder;
    
            ProjectListNestedImpl(){
                    this.builder = new ProjectListBuilder(this);
            }
            ProjectListNestedImpl(ProjectList item){
                    this.builder = new ProjectListBuilder(this, item);
            }
    
    public N endProjectList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withProjectList(builder.build());
    }

}
    public class ProjectRequestNestedImpl<N> extends ProjectRequestFluentImpl<KubeSchemaFluent.ProjectRequestNested<N>> implements KubeSchemaFluent.ProjectRequestNested<N>,Nested<N>{

            private final ProjectRequestBuilder builder;
    
            ProjectRequestNestedImpl(){
                    this.builder = new ProjectRequestBuilder(this);
            }
            ProjectRequestNestedImpl(ProjectRequest item){
                    this.builder = new ProjectRequestBuilder(this, item);
            }
    
    public N endProjectRequest(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withProjectRequest(builder.build());
    }

}
    public class QuantityNestedImpl<N> extends QuantityFluentImpl<KubeSchemaFluent.QuantityNested<N>> implements KubeSchemaFluent.QuantityNested<N>,Nested<N>{

            private final QuantityBuilder builder;
    
            QuantityNestedImpl(){
                    this.builder = new QuantityBuilder(this);
            }
            QuantityNestedImpl(Quantity item){
                    this.builder = new QuantityBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withQuantity(builder.build());
    }
    public N endQuantity(){
            return and();
    }

}
    public class ReplicaSetNestedImpl<N> extends ReplicaSetFluentImpl<KubeSchemaFluent.ReplicaSetNested<N>> implements KubeSchemaFluent.ReplicaSetNested<N>,Nested<N>{

            private final ReplicaSetBuilder builder;
    
            ReplicaSetNestedImpl(){
                    this.builder = new ReplicaSetBuilder(this);
            }
            ReplicaSetNestedImpl(ReplicaSet item){
                    this.builder = new ReplicaSetBuilder(this, item);
            }
    
    public N endReplicaSet(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withReplicaSet(builder.build());
    }

}
    public class ReplicaSetListNestedImpl<N> extends ReplicaSetListFluentImpl<KubeSchemaFluent.ReplicaSetListNested<N>> implements KubeSchemaFluent.ReplicaSetListNested<N>,Nested<N>{

            private final ReplicaSetListBuilder builder;
    
            ReplicaSetListNestedImpl(){
                    this.builder = new ReplicaSetListBuilder(this);
            }
            ReplicaSetListNestedImpl(ReplicaSetList item){
                    this.builder = new ReplicaSetListBuilder(this, item);
            }
    
    public N endReplicaSetList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withReplicaSetList(builder.build());
    }

}
    public class ReplicationControllerListNestedImpl<N> extends ReplicationControllerListFluentImpl<KubeSchemaFluent.ReplicationControllerListNested<N>> implements KubeSchemaFluent.ReplicationControllerListNested<N>,Nested<N>{

            private final ReplicationControllerListBuilder builder;
    
            ReplicationControllerListNestedImpl(){
                    this.builder = new ReplicationControllerListBuilder(this);
            }
            ReplicationControllerListNestedImpl(ReplicationControllerList item){
                    this.builder = new ReplicationControllerListBuilder(this, item);
            }
    
    public N endReplicationControllerList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withReplicationControllerList(builder.build());
    }

}
    public class ResourceQuotaNestedImpl<N> extends ResourceQuotaFluentImpl<KubeSchemaFluent.ResourceQuotaNested<N>> implements KubeSchemaFluent.ResourceQuotaNested<N>,Nested<N>{

            private final ResourceQuotaBuilder builder;
    
            ResourceQuotaNestedImpl(){
                    this.builder = new ResourceQuotaBuilder(this);
            }
            ResourceQuotaNestedImpl(ResourceQuota item){
                    this.builder = new ResourceQuotaBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withResourceQuota(builder.build());
    }
    public N endResourceQuota(){
            return and();
    }

}
    public class ResourceQuotaListNestedImpl<N> extends ResourceQuotaListFluentImpl<KubeSchemaFluent.ResourceQuotaListNested<N>> implements KubeSchemaFluent.ResourceQuotaListNested<N>,Nested<N>{

            private final ResourceQuotaListBuilder builder;
    
            ResourceQuotaListNestedImpl(){
                    this.builder = new ResourceQuotaListBuilder(this);
            }
            ResourceQuotaListNestedImpl(ResourceQuotaList item){
                    this.builder = new ResourceQuotaListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withResourceQuotaList(builder.build());
    }
    public N endResourceQuotaList(){
            return and();
    }

}
    public class RoleNestedImpl<N> extends RoleFluentImpl<KubeSchemaFluent.RoleNested<N>> implements KubeSchemaFluent.RoleNested<N>,Nested<N>{

            private final RoleBuilder builder;
    
            RoleNestedImpl(){
                    this.builder = new RoleBuilder(this);
            }
            RoleNestedImpl(Role item){
                    this.builder = new RoleBuilder(this, item);
            }
    
    public N endRole(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withRole(builder.build());
    }

}
    public class RoleBindingNestedImpl<N> extends RoleBindingFluentImpl<KubeSchemaFluent.RoleBindingNested<N>> implements KubeSchemaFluent.RoleBindingNested<N>,Nested<N>{

            private final RoleBindingBuilder builder;
    
            RoleBindingNestedImpl(){
                    this.builder = new RoleBindingBuilder(this);
            }
            RoleBindingNestedImpl(RoleBinding item){
                    this.builder = new RoleBindingBuilder(this, item);
            }
    
    public N endRoleBinding(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withRoleBinding(builder.build());
    }

}
    public class RoleBindingListNestedImpl<N> extends RoleBindingListFluentImpl<KubeSchemaFluent.RoleBindingListNested<N>> implements KubeSchemaFluent.RoleBindingListNested<N>,Nested<N>{

            private final RoleBindingListBuilder builder;
    
            RoleBindingListNestedImpl(){
                    this.builder = new RoleBindingListBuilder(this);
            }
            RoleBindingListNestedImpl(RoleBindingList item){
                    this.builder = new RoleBindingListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withRoleBindingList(builder.build());
    }
    public N endRoleBindingList(){
            return and();
    }

}
    public class RoleListNestedImpl<N> extends RoleListFluentImpl<KubeSchemaFluent.RoleListNested<N>> implements KubeSchemaFluent.RoleListNested<N>,Nested<N>{

            private final RoleListBuilder builder;
    
            RoleListNestedImpl(){
                    this.builder = new RoleListBuilder(this);
            }
            RoleListNestedImpl(RoleList item){
                    this.builder = new RoleListBuilder(this, item);
            }
    
    public N endRoleList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withRoleList(builder.build());
    }

}
    public class RootPathsNestedImpl<N> extends RootPathsFluentImpl<KubeSchemaFluent.RootPathsNested<N>> implements KubeSchemaFluent.RootPathsNested<N>,Nested<N>{

            private final RootPathsBuilder builder;
    
            RootPathsNestedImpl(){
                    this.builder = new RootPathsBuilder(this);
            }
            RootPathsNestedImpl(RootPaths item){
                    this.builder = new RootPathsBuilder(this, item);
            }
    
    public N endRootPaths(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withRootPaths(builder.build());
    }

}
    public class RouteListNestedImpl<N> extends RouteListFluentImpl<KubeSchemaFluent.RouteListNested<N>> implements KubeSchemaFluent.RouteListNested<N>,Nested<N>{

            private final RouteListBuilder builder;
    
            RouteListNestedImpl(RouteList item){
                    this.builder = new RouteListBuilder(this, item);
            }
            RouteListNestedImpl(){
                    this.builder = new RouteListBuilder(this);
            }
    
    public N endRouteList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withRouteList(builder.build());
    }

}
    public class ScaleNestedImpl<N> extends ScaleFluentImpl<KubeSchemaFluent.ScaleNested<N>> implements KubeSchemaFluent.ScaleNested<N>,Nested<N>{

            private final ScaleBuilder builder;
    
            ScaleNestedImpl(){
                    this.builder = new ScaleBuilder(this);
            }
            ScaleNestedImpl(Scale item){
                    this.builder = new ScaleBuilder(this, item);
            }
    
    public N endScale(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withScale(builder.build());
    }

}
    public class SecretNestedImpl<N> extends SecretFluentImpl<KubeSchemaFluent.SecretNested<N>> implements KubeSchemaFluent.SecretNested<N>,Nested<N>{

            private final SecretBuilder builder;
    
            SecretNestedImpl(){
                    this.builder = new SecretBuilder(this);
            }
            SecretNestedImpl(Secret item){
                    this.builder = new SecretBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withSecret(builder.build());
    }
    public N endSecret(){
            return and();
    }

}
    public class SecretListNestedImpl<N> extends SecretListFluentImpl<KubeSchemaFluent.SecretListNested<N>> implements KubeSchemaFluent.SecretListNested<N>,Nested<N>{

            private final SecretListBuilder builder;
    
            SecretListNestedImpl(){
                    this.builder = new SecretListBuilder(this);
            }
            SecretListNestedImpl(SecretList item){
                    this.builder = new SecretListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withSecretList(builder.build());
    }
    public N endSecretList(){
            return and();
    }

}
    public class SecurityContextConstraintsNestedImpl<N> extends SecurityContextConstraintsFluentImpl<KubeSchemaFluent.SecurityContextConstraintsNested<N>> implements KubeSchemaFluent.SecurityContextConstraintsNested<N>,Nested<N>{

            private final SecurityContextConstraintsBuilder builder;
    
            SecurityContextConstraintsNestedImpl(){
                    this.builder = new SecurityContextConstraintsBuilder(this);
            }
            SecurityContextConstraintsNestedImpl(SecurityContextConstraints item){
                    this.builder = new SecurityContextConstraintsBuilder(this, item);
            }
    
    public N endSecurityContextConstraints(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withSecurityContextConstraints(builder.build());
    }

}
    public class SecurityContextConstraintsListNestedImpl<N> extends SecurityContextConstraintsListFluentImpl<KubeSchemaFluent.SecurityContextConstraintsListNested<N>> implements KubeSchemaFluent.SecurityContextConstraintsListNested<N>,Nested<N>{

            private final SecurityContextConstraintsListBuilder builder;
    
            SecurityContextConstraintsListNestedImpl(SecurityContextConstraintsList item){
                    this.builder = new SecurityContextConstraintsListBuilder(this, item);
            }
            SecurityContextConstraintsListNestedImpl(){
                    this.builder = new SecurityContextConstraintsListBuilder(this);
            }
    
    public N endSecurityContextConstraintsList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withSecurityContextConstraintsList(builder.build());
    }

}
    public class ServiceAccountNestedImpl<N> extends ServiceAccountFluentImpl<KubeSchemaFluent.ServiceAccountNested<N>> implements KubeSchemaFluent.ServiceAccountNested<N>,Nested<N>{

            private final ServiceAccountBuilder builder;
    
            ServiceAccountNestedImpl(){
                    this.builder = new ServiceAccountBuilder(this);
            }
            ServiceAccountNestedImpl(ServiceAccount item){
                    this.builder = new ServiceAccountBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withServiceAccount(builder.build());
    }
    public N endServiceAccount(){
            return and();
    }

}
    public class ServiceAccountListNestedImpl<N> extends ServiceAccountListFluentImpl<KubeSchemaFluent.ServiceAccountListNested<N>> implements KubeSchemaFluent.ServiceAccountListNested<N>,Nested<N>{

            private final ServiceAccountListBuilder builder;
    
            ServiceAccountListNestedImpl(){
                    this.builder = new ServiceAccountListBuilder(this);
            }
            ServiceAccountListNestedImpl(ServiceAccountList item){
                    this.builder = new ServiceAccountListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withServiceAccountList(builder.build());
    }
    public N endServiceAccountList(){
            return and();
    }

}
    public class ServiceListNestedImpl<N> extends ServiceListFluentImpl<KubeSchemaFluent.ServiceListNested<N>> implements KubeSchemaFluent.ServiceListNested<N>,Nested<N>{

            private final ServiceListBuilder builder;
    
            ServiceListNestedImpl(){
                    this.builder = new ServiceListBuilder(this);
            }
            ServiceListNestedImpl(ServiceList item){
                    this.builder = new ServiceListBuilder(this, item);
            }
    
    public N endServiceList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withServiceList(builder.build());
    }

}
    public class StatusNestedImpl<N> extends StatusFluentImpl<KubeSchemaFluent.StatusNested<N>> implements KubeSchemaFluent.StatusNested<N>,Nested<N>{

            private final StatusBuilder builder;
    
            StatusNestedImpl(){
                    this.builder = new StatusBuilder(this);
            }
            StatusNestedImpl(Status item){
                    this.builder = new StatusBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withStatus(builder.build());
    }
    public N endStatus(){
            return and();
    }

}
    public class SubjectAccessReviewNestedImpl<N> extends SubjectAccessReviewFluentImpl<KubeSchemaFluent.SubjectAccessReviewNested<N>> implements KubeSchemaFluent.SubjectAccessReviewNested<N>,Nested<N>{

            private final SubjectAccessReviewBuilder builder;
    
            SubjectAccessReviewNestedImpl(){
                    this.builder = new SubjectAccessReviewBuilder(this);
            }
            SubjectAccessReviewNestedImpl(SubjectAccessReview item){
                    this.builder = new SubjectAccessReviewBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withSubjectAccessReview(builder.build());
    }
    public N endSubjectAccessReview(){
            return and();
    }

}
    public class SubjectAccessReviewResponseNestedImpl<N> extends SubjectAccessReviewResponseFluentImpl<KubeSchemaFluent.SubjectAccessReviewResponseNested<N>> implements KubeSchemaFluent.SubjectAccessReviewResponseNested<N>,Nested<N>{

            private final SubjectAccessReviewResponseBuilder builder;
    
            SubjectAccessReviewResponseNestedImpl(){
                    this.builder = new SubjectAccessReviewResponseBuilder(this);
            }
            SubjectAccessReviewResponseNestedImpl(SubjectAccessReviewResponse item){
                    this.builder = new SubjectAccessReviewResponseBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withSubjectAccessReviewResponse(builder.build());
    }
    public N endSubjectAccessReviewResponse(){
            return and();
    }

}
    public class TagEventNestedImpl<N> extends TagEventFluentImpl<KubeSchemaFluent.TagEventNested<N>> implements KubeSchemaFluent.TagEventNested<N>,Nested<N>{

            private final TagEventBuilder builder;
    
            TagEventNestedImpl(){
                    this.builder = new TagEventBuilder(this);
            }
            TagEventNestedImpl(TagEvent item){
                    this.builder = new TagEventBuilder(this, item);
            }
    
    public N endTagEvent(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withTagEvent(builder.build());
    }

}
    public class TemplateNestedImpl<N> extends TemplateFluentImpl<KubeSchemaFluent.TemplateNested<N>> implements KubeSchemaFluent.TemplateNested<N>,Nested<N>{

            private final TemplateBuilder builder;
    
            TemplateNestedImpl(){
                    this.builder = new TemplateBuilder(this);
            }
            TemplateNestedImpl(Template item){
                    this.builder = new TemplateBuilder(this, item);
            }
    
    public N endTemplate(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withTemplate(builder.build());
    }

}
    public class TemplateListNestedImpl<N> extends TemplateListFluentImpl<KubeSchemaFluent.TemplateListNested<N>> implements KubeSchemaFluent.TemplateListNested<N>,Nested<N>{

            private final TemplateListBuilder builder;
    
            TemplateListNestedImpl(TemplateList item){
                    this.builder = new TemplateListBuilder(this, item);
            }
            TemplateListNestedImpl(){
                    this.builder = new TemplateListBuilder(this);
            }
    
    public N endTemplateList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withTemplateList(builder.build());
    }

}
    public class ThirdPartyResourceNestedImpl<N> extends ThirdPartyResourceFluentImpl<KubeSchemaFluent.ThirdPartyResourceNested<N>> implements KubeSchemaFluent.ThirdPartyResourceNested<N>,Nested<N>{

            private final ThirdPartyResourceBuilder builder;
    
            ThirdPartyResourceNestedImpl(){
                    this.builder = new ThirdPartyResourceBuilder(this);
            }
            ThirdPartyResourceNestedImpl(ThirdPartyResource item){
                    this.builder = new ThirdPartyResourceBuilder(this, item);
            }
    
    public N endThirdPartyResource(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withThirdPartyResource(builder.build());
    }

}
    public class ThirdPartyResourceListNestedImpl<N> extends ThirdPartyResourceListFluentImpl<KubeSchemaFluent.ThirdPartyResourceListNested<N>> implements KubeSchemaFluent.ThirdPartyResourceListNested<N>,Nested<N>{

            private final ThirdPartyResourceListBuilder builder;
    
            ThirdPartyResourceListNestedImpl(){
                    this.builder = new ThirdPartyResourceListBuilder(this);
            }
            ThirdPartyResourceListNestedImpl(ThirdPartyResourceList item){
                    this.builder = new ThirdPartyResourceListBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withThirdPartyResourceList(builder.build());
    }
    public N endThirdPartyResourceList(){
            return and();
    }

}
    public class UserNestedImpl<N> extends UserFluentImpl<KubeSchemaFluent.UserNested<N>> implements KubeSchemaFluent.UserNested<N>,Nested<N>{

            private final UserBuilder builder;
    
            UserNestedImpl(){
                    this.builder = new UserBuilder(this);
            }
            UserNestedImpl(User item){
                    this.builder = new UserBuilder(this, item);
            }
    
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withUser(builder.build());
    }
    public N endUser(){
            return and();
    }

}
    public class UserListNestedImpl<N> extends UserListFluentImpl<KubeSchemaFluent.UserListNested<N>> implements KubeSchemaFluent.UserListNested<N>,Nested<N>{

            private final UserListBuilder builder;
    
            UserListNestedImpl(){
                    this.builder = new UserListBuilder(this);
            }
            UserListNestedImpl(UserList item){
                    this.builder = new UserListBuilder(this, item);
            }
    
    public N endUserList(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withUserList(builder.build());
    }

}
    public class WatchEventNestedImpl<N> extends WatchEventFluentImpl<KubeSchemaFluent.WatchEventNested<N>> implements KubeSchemaFluent.WatchEventNested<N>,Nested<N>{

            private final WatchEventBuilder builder;
    
            WatchEventNestedImpl(){
                    this.builder = new WatchEventBuilder(this);
            }
            WatchEventNestedImpl(WatchEvent item){
                    this.builder = new WatchEventBuilder(this, item);
            }
    
    public N endWatchEvent(){
            return and();
    }
    public N and(){
            return (N) KubeSchemaFluentImpl.this.withWatchEvent(builder.build());
    }

}


}
