package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import java.lang.String;
import java.lang.Object;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.fabric8.kubernetes.api.builder.Nested;

public interface LifecycleFluent<A extends LifecycleFluent<A>> extends Fluent<A>{


    public Handler getPostStart();
    public A withPostStart(Handler postStart);
    public LifecycleFluent.PostStartNested<A> withNewPostStart();
    public LifecycleFluent.PostStartNested<A> withNewPostStartLike(Handler item);
    public LifecycleFluent.PostStartNested<A> editPostStart();
    public Handler getPreStop();
    public A withPreStop(Handler preStop);
    public LifecycleFluent.PreStopNested<A> withNewPreStop();
    public LifecycleFluent.PreStopNested<A> withNewPreStopLike(Handler item);
    public LifecycleFluent.PreStopNested<A> editPreStop();

    public interface PostStartNested<N> extends Nested<N>,HandlerFluent<LifecycleFluent.PostStartNested<N>>{

        
    public N endPostStart();    public N and();
}
    public interface PreStopNested<N> extends Nested<N>,HandlerFluent<LifecycleFluent.PreStopNested<N>>{

        
    public N and();    public N endPreStop();
}


}
